Package: StabMap
Type: Package
Title: Stabilised mosaic single cell data integration using unshared
        features
Version: 1.6.0
Authors@R: c(
    person("Shila", "Ghazanfar", , "shazanfar@gmail.com", role = c("aut", "cre", "ctb")),
    person("Aiden", "Jin", role = "ctb"),
    person("Nicholas", "Robertson", , "nicholas.robertson@sydney.edu.au", role = "ctb")
  )
Description: StabMap performs single cell mosaic data integration by first 
    building a mosaic data topology, and for each reference dataset, traverses 
    the topology to project and predict data onto a common embedding. Mosaic
    data should be provided in a list format, with all relevant features 
    included in the data matrices within each list object. The output of
    stabMap is a joint low-dimensional embedding taking into account all 
    available relevant features. Expression imputation can also be performed
    using the StabMap embedding and any of the original data matrices for 
    given reference and query cell lists.
License: GPL-2
Encoding: UTF-8
URL: https://sydneybiox.github.io/StabMap,
        https://sydneybiox.github.io/StabMap/
BugReports: https://github.com/sydneybiox/StabMap/issues
biocViews: SingleCell, DimensionReduction, Software
Depends: R (>= 4.4.0),
Imports: igraph, slam, BiocNeighbors, Matrix, MASS, abind,
        SummarizedExperiment, methods, MatrixGenerics, BiocGenerics,
        BiocSingular, BiocParallel
Suggests: scran, scater, knitr, UpSetR, gridExtra,
        SingleCellMultiModal, BiocStyle, magrittr, testthat (>= 3.0.0),
        purrr, sparseMatrixStats
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/StabMap
git_branch: RELEASE_3_23
git_last_commit: 2c98354
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:06:02 UTC; biocbuild
Author: Shila Ghazanfar [aut, cre, ctb],
  Aiden Jin [ctb],
  Nicholas Robertson [ctb]
Maintainer: Shila Ghazanfar <shazanfar@gmail.com>

# StabMap: Stabilised mosaic single cell data integration using unshared features

<img src="man/figures/hex.png" align="right" height="250" width="250"/>

## Installation

Install `StabMap` via Bioconductor 

``` r
library(BiocManager)
BiocManager::install("StabMap")
```

Install the Github version of StabMap

``` r
BiocManager::install("SydneyBioX/StabMap")
```

## Vignette

You can find the vignette showing how StabMap can be used with PBMC single cell data at this [website](https://marionilab.github.io/StabMap/articles/stabMap_PBMC_Multiome.html).

## Method

<img src="man/figures/method.png" align="middle" width="80%"/>

**Figure: StabMap method overview.**\
a. Example mosaic data integration displaying observed data matrices with varying overlap of features among the datasets. Datasets are summarised using the mosaic data topology (MDT). Cells are then projected onto the common StabMap embedding across all cells.\
b. Cells from all datasets are projected onto the reference space (dark red) by traversing the shortest paths along the MDT. Blue cells are projected directly onto the reference space, whereas yellow cells are first projected onto the space defined by the blue cells, followed by projection to the dark red space. All cells are then combined to yield the common StabMap embedding.\
c. The process described in panel b is performed for various selected reference datasets (default = all), followed by L2-norm re-weighting provided by the user (default = equal weight). These reweighted embeddings are then concatenated to form the StabMap embedding for multiple reference datasets, and can be used for further downstream analysis tasks.

## Contact

shila.ghazanfar \<at\> sydney.edu.au, or marioni \<at\> ebi.ac.uk.

#' Re-weight StabMap embedding
#'
#' Re-weights embedding according to given weights for each reference dataset.
#' This gives more or less weighting to each contributing dataset and method
#' (PCA or LDA),
#'
#' @param embedding Joint embedding as output from stabMap.
#' @param weights (optional) named numeric vector giving relative weights for
#' each reference dataset.
#' @param factor numeric multiplicative value to offset near-zero values.
#'
#' @return matrix of same dimensions as `embedding`.
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' lapply(assay_list, dim)
#'
#' # specify which datasets to use as reference coordinates
#' reference_list <- c("D1", "D3")
#'
#' # specify some sample labels to distinguish using linear discriminant
#' # analysis (LDA)
#' labels_list <- list(
#'   D1 = rep(letters[1:5], length.out = ncol(assay_list[["D1"]]))
#' )
#'
#' # stabMap
#' out <- stabMap(assay_list,
#'   reference_list = reference_list,
#'   labels_list = labels_list,
#'   ncomponentsReference = 20,
#'   ncomponentsSubset = 20
#' )
#'
#' # look at the scale of each component and discriminant
#' boxplot(out, las = 2, outline = FALSE)
#'
#' # re-weight embedding for less contribution from LDs and equal contribution
#' # from PCs of both references
#' out_reweighted <- reWeightEmbedding(
#'   out,
#'   weights = c("D1_LD" = 0.5, "D1_PC" = 1, "D3_PC" = 1)
#' )
#'
#' # look at the new scale of each component and discriminant
#' boxplot(out_reweighted, las = 2, outline = FALSE)
#'
#' @export
reWeightEmbedding <- function(embedding, weights = NULL, factor = 1e6) {
  cols <- as.character(interaction(gsub("_PC.*|_LD.*", "", colnames(embedding)),
    ifelse(grepl("_PC", colnames(embedding)), "PC", "LD"),
    sep = "_"
  ))

  cols_split <- split(colnames(embedding), cols)

  m <- paste(c("reweighting for references: ", names(cols_split)))
  message(m)

  if (is.null(weights)) {
    weights <- lapply(cols_split, function(x) 1)
  }

  norms <- lapply(cols_split, function(cols) {
    sum(abs(embedding[, cols]))
  })

  norms_long <- unsplit(norms, cols)
  weights_long <- factor * unlist(weights)[cols]

  embedding_norm <- t((t(embedding) / norms_long) * weights_long)

  return(embedding_norm)
}

#' Adaptive k-Nearest Neighbour Classification
#'
#' Adaptive k-Nearest Neighbour Classification for a k-nearest neighbour matrix,
#' given class labels and local k values for the training data
#'
#'
#' @param knn Is a k-nearest neighbour matrix, giving the indices of the
#' training set that the query is closest to. Rows are the query cells, columns
#' are the NNs. Typically output using
#' BiocNeighbors::queryKNN(,,k = max(k_local)).
#' @param class Is the labels associated with the training set.
#' @param k_local Is an integer vector length of the training set, giving the
#' local k to use if k_local is given as a single integer, then that value is
#' used as k for all observations.
#'
#' @return A character vector of of classifications for the test set.
#'
#' @examples
#' # Generate example data
#' data <- matrix(rpois(10 * 20, 10), 10, 20) # 10 genes, 20 cells
#' data_2 <- matrix(rpois(10 * 30, 10), 10, 30) # 10 genes, 30 cells
#'
#' # Generate error matrix for k_local
#' E <- matrix(runif(100), 20, 5)
#' colnames(E) <- paste0("K_", 1:5)
#'
#' # Define training class labels and adaptive k-values
#' class <- factor(rep(letters[1:2], each = 10))
#' k_local <- getAdaptiveK(E, labels = class)
#'
#' knn <- BiocNeighbors::queryKNN(
#'   t(data), t(data_2),
#'   k = max(as.numeric(gsub("K_", "", k_local)))
#' )$index
#'
#' # Adaptive KNN classification
#' test <- adaptiveKNN(
#'   knn, class, as.numeric(gsub("K_", "", k_local))
#' )
#'
#' @export
adaptiveKNN <- function(knn,
                        class,
                        k_local) {

  query_best_k <- getQueryK(knn, k_local)

  if (any(query_best_k > ncol(knn))) {
    warning(
      "k is larger than nearest neighbours provided, ",
      "taking all neighbours given"
    )
  }

  # convert the KNN names to the class labels
  knn_class <- vectorSubset(class, knn)

  new_class <- mapply(
    getModeFirst, split(knn_class, seq_len(nrow(knn_class))), query_best_k,
    USE.NAMES = FALSE
  )
  names(new_class) <- rownames(knn_class)

  return(new_class)
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = FALSE
)

## ----setup, message=FALSE, warning=FALSE--------------------------------------
library(StabMap)
library(magrittr)

library(scater)
library(scran)
library(SingleCellMultiModal)
library(gridExtra)

## -----------------------------------------------------------------------------
set.seed(2024)

## ----message=FALSE, warning=FALSE---------------------------------------------
mae <- scMultiome(
  "pbmc_10x",
  mode = "*", dry.run = FALSE, format = "MTX", verbose = TRUE
)

## -----------------------------------------------------------------------------
mae

upsetSamples(mae)

head(colData(mae))

dim(experiments(mae)[["rna"]])

names(experiments(mae))

## -----------------------------------------------------------------------------
sce.rna <- experiments(mae)[["rna"]]

# Normalisation
sce.rna <- logNormCounts(sce.rna)

# Feature selection
decomp <- modelGeneVar(sce.rna)
hvgs <- rownames(decomp)[decomp$mean > 0.01 & decomp$p.value <= 0.05]

length(hvgs)

sce.rna <- sce.rna[hvgs, ]

## -----------------------------------------------------------------------------
dim(experiments(mae)[["atac"]])

sce.atac <- experiments(mae)[["atac"]]

# Normalise
sce.atac <- logNormCounts(sce.atac)

# Feature selection using highly variable peaks
# And adding matching peaks to genes
decomp <- modelGeneVar(sce.atac)
hvgs <- rownames(decomp)[decomp$mean > 0.25 &
  decomp$p.value <= 0.05]
length(hvgs)

sce.atac <- sce.atac[hvgs, ]

## -----------------------------------------------------------------------------
logcounts_all <- rbind(logcounts(sce.rna), logcounts(sce.atac))
dim(logcounts_all)

assayType <- ifelse(rownames(logcounts_all) %in% rownames(sce.rna),
  "rna", "atac"
)
table(assayType)

## -----------------------------------------------------------------------------
dataType <- setNames(
  sample(c("RNA", "Multiome"), ncol(logcounts_all),
    prob = c(0.5, 0.5), replace = TRUE
  ),
  colnames(logcounts_all)
)
table(dataType)

assay_list <- list(
  RNA = logcounts_all[assayType %in% c("rna"), dataType %in% c("RNA")],
  Multiome = logcounts_all[
    assayType %in% c("rna", "atac"), dataType %in% c("Multiome")
  ]
)

lapply(assay_list, dim)
lapply(assay_list, class)

## -----------------------------------------------------------------------------
mosaicDataUpSet(assay_list, plot = FALSE)

## -----------------------------------------------------------------------------
mdt <- mosaicDataTopology(assay_list)
mdt
plot(mdt)

## -----------------------------------------------------------------------------
stab <- stabMap(assay_list,
  reference_list = c("Multiome"),
  plot = FALSE
)
dim(stab)
stab[1:5, 1:5]

## -----------------------------------------------------------------------------
stab_umap <- calculateUMAP(t(stab))
dim(stab_umap)

plot(stab_umap, pch = 16, cex = 0.3, col = factor(dataType[rownames(stab)]))

## -----------------------------------------------------------------------------
imp <- imputeEmbedding(
  assay_list,
  stab,
  reference = colnames(assay_list[["Multiome"]]),
  query = colnames(assay_list[["RNA"]])
)

class(imp)
names(imp)
lapply(imp, dim)
lapply(assay_list, dim)
imp[["Multiome"]][1:5, 1:5]

## -----------------------------------------------------------------------------
annotation <- "celltype"
referenceLabels <- colData(
  experiments(mae)[["rna"]]
)[colnames(assay_list$Multiome), annotation]
names(referenceLabels) <- colnames(assay_list$Multiome)

table(referenceLabels)

## -----------------------------------------------------------------------------
knn_out <- classifyEmbedding(
  stab,
  referenceLabels,
)

## -----------------------------------------------------------------------------
# Extract query labels
queryLabels <- colData(
  experiments(mae)[["rna"]]
)[colnames(assay_list$RNA), annotation]
names(queryLabels) <- colnames(assay_list$RNA)

acc <- mean(queryLabels == knn_out[names(queryLabels), "predicted_labels"])
acc

## -----------------------------------------------------------------------------
# Extract reference and query cells from UMAP embedding
stab_umap_ref <- stab_umap[colnames(assay_list$Multiome), ]
stab_umap_query <- stab_umap[colnames(assay_list$RNA), ]

# Create UMAP for reference cells
df_umap_ref <- data.frame(
  x = stab_umap_ref[, 1],
  y = stab_umap_ref[, 2],
  cell_type = referenceLabels[rownames(stab_umap_ref)]
)

p_ref <- df_umap_ref %>%
  ggplot() +
  aes(x = x, y = y, colour = cell_type) +
  geom_point(size = 1) +
  ggtitle("Reference cell type annotation")

# Create UMAP for query cells
df_umap_query <- data.frame(
  x = stab_umap_query[, 1],
  y = stab_umap_query[, 2],
  cell_type = queryLabels[rownames(stab_umap_query)]
)

p_query <- df_umap_query %>%
  ggplot() +
  aes(x = x, y = y, colour = cell_type) +
  geom_point(size = 1) +
  ggtitle("Query predicted cell types")

grid.arrange(p_ref, p_query, ncol = 2)

## -----------------------------------------------------------------------------
dataTypeIndirect <- setNames(
  sample(c("RNA", "Multiome", "ATAC"), ncol(logcounts_all),
    prob = c(0.3, 0.3, 0.3), replace = TRUE
  ),
  colnames(logcounts_all)
)
table(dataTypeIndirect)

assay_list_indirect <- list(
  RNA = logcounts_all[assayType %in% c("rna"), dataTypeIndirect %in% c("RNA")],
  Multiome = logcounts_all[
    assayType %in% c("rna", "atac"), dataTypeIndirect %in% c("Multiome")
  ],
  ATAC = logcounts_all[
    assayType %in% c("atac"), dataTypeIndirect %in% c("ATAC")
  ]
)

lapply(assay_list_indirect, dim)
lapply(assay_list_indirect, class)

## -----------------------------------------------------------------------------
mosaicDataUpSet(assay_list_indirect, plot = FALSE)

## -----------------------------------------------------------------------------
mdt_indirect <- mosaicDataTopology(assay_list_indirect)
mdt_indirect
plot(mdt_indirect)

## -----------------------------------------------------------------------------
stab_indirect <- stabMap(assay_list_indirect,
  reference_list = c("Multiome"),
  plot = FALSE
)
dim(stab_indirect)
stab_indirect[1:5, 1:5]

## -----------------------------------------------------------------------------
stab_indirect_umap <- calculateUMAP(t(stab_indirect))
dim(stab_indirect_umap)

plot(stab_indirect_umap,
  pch = 16, cex = 0.3,
  col = factor(dataTypeIndirect[rownames(stab_indirect)])
)

## -----------------------------------------------------------------------------
cellType <- setNames(mae$celltype, colnames(mae[[1]]))

plot(stab_indirect_umap,
  pch = 16, cex = 0.3,
  col = factor(cellType[rownames(stab_indirect)])
)

## -----------------------------------------------------------------------------
sessionInfo()

#' getArgMin
#'
#' For each row in a matrix calculate the first index which gives the minimum
#' value
#'
#' @param M A matrix.
#' @param return_colnames Logical whether to return column names of matrix
#' (default TRUE). Otherwise return index.
#' @param identicalNA Logical whether to return NA if all values in a row are
#' identical (default TRUE).
#'
#' @return A vector containing the first index or column name of the
#' minimum values for each row of the matrix.
#'
#' @keywords internal
getArgMin <- function(M, return_colnames = TRUE, identicalNA = TRUE) {
  m <- max.col(-M, ties.method = "first")

  if (return_colnames) {
    if (!is.null(colnames(M)[1])) {
      m <- colnames(M)[m]
    }
  }

  names(m) <- rownames(M)

  if (identicalNA) {
    # if all the values in a row of M are identical,
    # return NA
    m[apply(M, 1, allEqual)] <- NA
  }

  return(m)
}


#' getModeFirst
#'
#' Identify the mode of x up to the first index
#'
#' @param x A character or a factor.
#' @param first An integer.
#'
#' @return A character of the mode of x.
#'
#' @keywords internal
getModeFirst <- function(x, first) {
  names(which.max(table(x[seq_len(first)])[unique(x[seq_len(first)])]))
}

#' getQueryK
#'
#' For each cell in the query data, use the 1NN's adaptive k value
#' (of the reference data) to identify the local best k value
#'
#' @param knn Is a k-nearest neighbour matrix, giving the indices of the
#' training set that the query is closest to. Rows are the query cells, columns
#' are the NNs, should be a large value. Typically output using
#' BiocNeighbors::queryKNN(,,k = max(k_local)).
#' @param k_local Is an integer vector length of the reference set, giving the
#' local k to use. If k_local is given as a single integer, then that value is
#' used as k for all observations.
#'
#' @return An integer vector with local k to use for each query cell.
#'
#' @keywords internal
getQueryK <- function(knn, k_local) {

  if (length(k_local) == 1) {
    k_local <- rep(k_local, nrow(knn))
    return(k_local)
  }

  query_best_k <- k_local[knn[, 1]]

  return(query_best_k)
}


#' isUnequal
#'
#' Checks if elements of 2 vectors are unequal
#'
#' @param x A vector.
#' @param y A vector.
#'
#' @return An integer vector. 1 for unequal. 0 for equal
#'
#' @keywords internal
isUnequal <- function(x, y) {
  1 * (as.character(x) != as.character(y))
}

#' allEqual
#'
#' Checks if a vector is equal to its first element
#'
#' @param x A vector.
#'
#' @return logical whether a a vector is equal to its first element.
#'
#' @keywords internal
allEqual <- function(x) {
  all(x == x[1])
}

#' getBinaryError
#'
#' For potential k values, generate a binary error matrix from KNN label
#' classification
#'
#' @param knn Is a k-nearest neighbour matrix, giving the indices of the
#' training set that the query is closest to. Rows are the query cells, columns
#' are the NNs, should be a large value. Typically output using
#' BiocNeighbors::queryKNN(,,k = max(k_values)).
#' @param k_values Is an integer vector of the values of k to consider for
#' extracting accuracy. If k_values has names then pass these to colnames of E.
#' @param class_train Is a factor or character vector of classes that
#' corresponds to the indices given within knn.
#' @param class_true Is a factor or character vector that corresponds to the
#' rows of knn. If class_true has names then pass these to rownames of E.
#'
#' @return A sparse binary error matrix.
#'
#' @keywords internal
getBinaryError <- function(knn,
                           k_values,
                           class_train,
                           class_true) {

  if (max(unlist(k_values)) > ncol(knn)) {
    m <- paste0(
      "largest k value is larger than neighbours provided in knn (i.e. ",
      ncol(knn),
      "), select a smaller k value or provide more neighbours"
    )
    stop(m)
  }

  class_pred <- mapply(
    adaptiveKNN, k_values,
    MoreArgs = list(class = class_train, knn = knn)
  )
  E <- methods::as(
    apply(class_pred, 2, isUnequal, y = class_true), "sparseMatrix"
  )

  rownames(E) <- names(class_true)
  colnames(E) <- names(k_values)

  return(E)
}

#' combineBinaryErrors
#'
#' Combines binary error matrices by averaging error values across all matrices,
#' for each entry (row and column combination)
#'
#' @param E_list A list containing matrices. Each matrix must have the same
#' number of columns (k-values) and contain rownames (cells).
#'
#' @return A sparse error matrix.
#'
#' @keywords internal
combineBinaryErrors <- function(E_list) {

  if (!allEqual(unlist(lapply(E_list, ncol)))) {
    stop("each matrix in E_list must have the same number of columns")
  }

  if (any(unlist(lapply(E_list, function(x) is.null(rownames(x)))))) {
    stop("each matrix in E_list must have associated rownames")
  }

  all_rows <- unlist(lapply(E_list, rownames))

  E_exp <- do.call(rbind, E_list)
  E_split <- split.data.frame(E_exp, all_rows)

  # data becomes dense at this stage
  E_means <- lapply(E_split, Matrix::colMeans, na.rm = TRUE)

  E <- methods::as(do.call(rbind, E_means), "sparseMatrix")

  return(E)
}


#' getBestColumn
#'
#' Identifies the index of the column of a matrix with the minimum mean.
#' If balanced_labels is given then calculate the balanced mean
#'
#' @param E An error matrix.
#' @param balanced_labels Class labels for each row (cell) of E.
#'
#' @return The index of the best performing column of E
#'
#' @keywords internal
getBestColumn <- function(E,
                          balanced_labels = NULL) {

  if (is.null(balanced_labels)) {
    return(which.min(colMeans(E, na.rm = TRUE)))
  } else {
    E_lab <- apply(E, 2, function(x) tapply(x, balanced_labels, mean))
    return(which.min(colMeans(E_lab, na.rm = TRUE)))
  }
}

#' smoothLocal
#'
#' Smooth out the adaptive k values. Can be smoothed by computing the
#' arithmetic or geometric mean of the adaptive k-values for each cells
#' neighbourhood
#'
#' @param best_k Is a named vector of local best k values
#' @param local Is a KNN matrix, with rows same as best_k and values indices of
#' best_k.
#' @param smooth An integer of k-nearest neighbours to smooth over.
#' @param mean_type Character indicating to calculate the 'geometric' or
#' 'arithmetic' mean.
#'
#' @return A numeric vector of smoothed adaptive k-values.
#'
#' @keywords internal
smoothLocal <- function(best_k, local, smooth = 10, mean_type = "geometric") {

  nms <- names(best_k)

  if (mean_type == "arithmetic") {
    best_k_smooth <- ceiling(
      rowMeans(vectorSubset(best_k, local[, seq_len(smooth)]))
    )
  }
  if (mean_type == "geometric") {
    best_k_smooth <- ceiling(
      apply(vectorSubset(best_k, local[, seq_len(smooth)]), 1, gm_mean)
    )
  }
  names(best_k_smooth) <- nms
  return(best_k_smooth)
}

#' gm_mean
#'
#' Calculate the geometric mean
#'
#' @param x A vector.
#' @param na.rm A logical value indicating whether NA values should be stripped
#' before calculating the geometric mean.
#'
#' @return A numeric.
#'
#' @keywords internal
gm_mean <- function(x, na.rm = TRUE) {
  if (all(is.na(x))) {
    return(NA)
  }
  exp(sum(log(x[x > 0]), na.rm = na.rm) / sum(!is.na(x)))
}

#' buildLabelsDataFrame
#'
#' Build dataframe for output from `classifyEmbedding`
#'
#' @param labels Is a named character vector with true labels.
#' @param resubstituted_labels Is a named character vector with predicted
#' labels.
#' @param k_adaptive Is a named vector of the k-values, this could be a single
#' integer when fixed.
#'
#' @return A dataframe with rows the same as resubstituted_labels and columns
#' for input_labels, predicted_labels, and resubstituted_labels.
#'
#' @keywords internal
buildLabelsDataFrame <- function(labels, resubstituted_labels, k_adaptive) {

  df <- data.frame(
    input_labels = as.character(labels[names(resubstituted_labels)]),
    resubstituted_labels = as.character(resubstituted_labels),
    predicted_labels = as.character(resubstituted_labels),
    row.names = names(resubstituted_labels)
  )
  df[names(labels), "predicted_labels"] <- labels

  if (length(k_adaptive) == 1) {
    df$k <- k_adaptive
  } else {
    df$k <- k_adaptive[rownames(df)]
  }

  return(df)
}

#' getBinaryErrorFromPredictions
#'
#' Compute binary error between predicted labels and true labels
#'
#' @param pred Is a matrix of class label predictions.
#' @param labels Is a named vector of true labels.
#'
#' @return A sparse binary error matrix.
#'
#' @keywords internal
getBinaryErrorFromPredictions <- function(pred, labels) {

  E <- methods::as(
    apply(pred, 2, isUnequal, y = labels[rownames(pred)]), "sparseMatrix"
  )
  rownames(E) <- names(labels)
  colnames(E) <- colnames(pred)

  return(E)
}

#' queryNamedKNN
#'
#' queryNamedKNN
#'
#' @param coords_reference coords_reference
#' @param coords_query coords_query
#' @param k k
#'
#' @return matrix
#'
#' @keywords internal
queryNamedKNN <- function(coords_reference, coords_query, k) {

  knn <- BiocNeighbors::queryKNN(
    coords_reference,
    coords_query,
    k = k, get.distance = FALSE
  )$index
  rownames(knn) <- rownames(coords_query)
  knn_name <- vectorSubset(rownames(coords_reference), knn)

  return(knn_name)
}

#' mosaicDataUpSet
#'
#' Plots feature overlaps of mosaic data as an UpSet plot.
#'
#' @param assay_list a list of data matrices with rownames (features) specified.
#' @param plot logical (default FALSE) whether the UpSet plot should be printed.
#' @param ... further arguments passed to `upset` from the `UpSetR` package.
#'
#' @return UpSet object displaying degree of overlap of rownames (features)
#' among each of the data matrices in \code{assay_list}. Set bars correspond to
#' the number of cells/samples present in each data matrix.
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' lapply(assay_list, dim)
#' mosaicDataUpSet(assay_list)
#'
#' # additional arguments from UpSetR::upset()
#' mosaicDataUpSet(assay_list, empty.intersections = TRUE)
#'
#' @export
mosaicDataUpSet <- function(assay_list, plot = FALSE, ...) {

  if (!requireNamespace("UpSetR", quietly = TRUE)) {
    stop("Install 'UpSetR' to use this function")
  }

  df <- as.data.frame(1 * do.call(
    cbind,
    lapply(
      assay_list,
      function(x) {
        Reduce(union, lapply(assay_list, rownames)) %in%
          rownames(x)
      }
    )
  ))

  df_cells <- as.data.frame(1 * do.call(
    cbind, lapply(
      assay_list,
      function(x) {
        Reduce(union, lapply(assay_list, colnames)) %in%
          colnames(x)
      }
    )
  ))

  g <- UpSetR::upset(df, ...)

  g0 <- suppressMessages(UpSetR::upset(df_cells, ...))
  g$Sizes <- g0$Sizes

  if (plot) {
    methods::show(g)
  }
  return(g)
}

#' mosaicDataTopology
#'
#' Generate mosaic data topology network as an igraph object.
#'
#' @param assay_list a list of data matrices with rownames (features) specified.
#'
#' @return igraph weighted network with nodes corresponding to
#' \code{assay_list} elements, and edges present if the matrices share at
#' least one rowname. Edge weights correspond to the number of shared
#' rownames among data matrices.
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' mdt <- mosaicDataTopology(assay_list)
#' mdt
#' plot(mdt)
#'
#' @export
mosaicDataTopology <- function(assay_list) {

  datasets <- names(assay_list)

  pairs <- t(utils::combn(datasets, 2))

  edge_weights <- apply(pairs, 1, function(x) {
    length(Reduce(intersect, lapply(assay_list[x], rownames)))
  })

  pairs_overlapping <- pairs[edge_weights != 0, , drop = FALSE]
  edge_weights_overlapping <- edge_weights[edge_weights != 0]

  g <- igraph::graph_from_edgelist(pairs_overlapping, directed = FALSE)
  igraph::E(g)$weight <- edge_weights_overlapping

  g <- igraph::graph_from_edgelist(pairs_overlapping, directed = FALSE)
  sd <- setdiff(datasets, igraph::V(g)$name)
  if (length(sd) > 0) {
    g <- igraph::add_vertices(g, length(sd), name = sd)
  }

  if (igraph::components(g)$no != 1) {
    message(
      "feature network is not connected, features must overlap via",
      " rownames for StabMap to run"
    )
  }

  # add some aesthetic attributes to the network
  igraph::V(g)$frame.color <- "white"
  igraph::V(g)$color <- "white"
  igraph::V(g)$label.color <- "black"
  igraph::V(g)$label.family <- "sans"

  return(g)
}

#' Stabilised mosaic single cell data integration using unshared features
#'
#' stabMap performs mosaic data integration by first building a mosaic data
#' topology, and for each reference dataset, traverses the topology to
#' project and predict data onto a common principal component (PC) or linear
#' discriminant (LD) embedding.
#'
#' @param assay_list A list of data matrices with rownames (features) specified.
#' @param labels_list (optional) named list containing cell labels
#' @param reference_list Named list containing logical values whether the data
#' matrix should be considered as a reference dataset, alternatively a
#' character vector containing the names of the reference data matrices. If
#' NULL, defaults to:
#'  sapply(names(assay_list), function(x) TRUE, simplify = FALSE)
#' @param reference_features_list List of features to consider as reference data
#' (default is all available features).
#' @param reference_scores_list Named list of reference scores (default NULL).
#' If provided, matrix of cells (rows with rownames given) and dimensions
#' (columns with colnames given) are used as the reference low-dimensional
#' embedding to target, as opposed to performing PCA or LDA on the input
#' reference data.
#' @param ncomponentsReference Number of principal components for embedding
#' reference data, given either as an integer or a named list for each
#' reference dataset.
#' @param ncomponentsSubset Number of principal components for embedding query
#' data prior to projecting to the reference, given either as an integer or a
#' named list for each reference dataset.
#' @param suppressMessages Logical whether to suppress messages (default TRUE).
#' @param projectAll Logical whether to re-project reference data along with
#' query (default FALSE).
#' @param restrictFeatures logical whether to restrict to features used in
#' dimensionality reduction of reference data (default FALSE). Overall it's
#' recommended that this be FALSE for single-hop integrations and TRUE for
#' multi-hop integrations.
#' @param maxFeatures Maximum number of features to consider for predicting
#' principal component scores (default 1000).
#' @param plot Logical whether to plot mosaic data UpSet plot and mosaic data
#' topology networks (default TRUE).
#' @param scale.center Logical whether to re-center data to a mean of 0 (default
#' FALSE).
#' @param scale.scale Logical whether to re-scale data to standard deviation of
#' 1 (default FALSE).
#' @param SE_assay_names Either a string indicating the name of the assays for
#'   the SummarizedExperiment objects in assay_list or a named list of assay
#'   names, where the names corrispond to the names SE objects in assay_list
#'   (default "logcounts")
#' @param BPPARAM a BiocParallelParam object specifying how parallelisation
#' should be performed
#' @param verbose Logical whether console output is provided (default TRUE)
#'
#' @return matrix containing common embedding with rows corresponding to cells,
#' and columns corresponding to PCs or LDs for reference dataset(s).
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' lapply(assay_list, dim)
#'
#' # specify which datasets to use as reference coordinates
#' reference_list <- c("D1", "D3")
#'
#' # specify some sample labels to distinguish using linear discriminant
#' # analysis (LDA)
#' labels_list <- list(
#'   D1 = rep(letters[1:5], length.out = ncol(assay_list[["D1"]]))
#' )
#'
#' # examine the topology of this mosaic data integration
#' mosaicDataUpSet(assay_list)
#' plot(mosaicDataTopology(assay_list))
#'
#' # stabMap
#' out <- stabMap(assay_list,
#'   reference_list = reference_list,
#'   labels_list = labels_list,
#'   ncomponentsReference = 20,
#'   ncomponentsSubset = 20
#' )
#'
#' head(out)
#'
#' @importFrom MatrixGenerics rowMaxs rowWeightedVars rowVars
#' @importFrom BiocParallel SerialParam bpstart bpstop
#' @export
stabMap <- function(assay_list,
                    labels_list = NULL,
                    reference_list = NULL,
                    reference_features_list = lapply(assay_list, rownames),
                    reference_scores_list = NULL,
                    ncomponentsReference = 50,
                    ncomponentsSubset = 50,
                    suppressMessages = TRUE,
                    projectAll = FALSE,
                    restrictFeatures = FALSE,
                    maxFeatures = 1000,
                    plot = TRUE,
                    scale.center = TRUE,
                    scale.scale = TRUE,
                    SE_assay_names = "logcounts",
                    BPPARAM = SerialParam(),
                    verbose = TRUE
                    ) {
  # check various things and error if not:

  if (is.null(reference_list)) {
    reference_list <- as.list(vapply(
      names(assay_list),
      function(x) TRUE,
      FUN.VALUE = logical(1)
    ))
  }

  se_idx <- unlist(
    lapply(assay_list, \(x) methods::is(x, "SummarizedExperiment"))
  )

  if (any(se_idx)) {
    assay_list[se_idx] <- stabMapSE(
      assay_list[se_idx],
      assays = SE_assay_names
    )
  }

  # the columns of each assay_list (cells) should all have different names
  stopifnot(
    "columns of each assay_list (cells) should all have different names" =
      !any(duplicated(unlist(lapply(assay_list, colnames))))
  )

  # each of the assays should have rownames and colnames defined
  stopifnot(
    "each assay in assay_list must have colnames specified" =
      all(unlist(lapply(assay_list, function(x) !is.null(colnames(x)))))
  )

  stopifnot(
    "each assay in assay_list must have rownames specified" =
      all(unlist(lapply(assay_list, function(x) !is.null(rownames(x)))))
  )

  # assay_list should have names
  stopifnot(
    "each assay in assay_list must be named" =
      !is.null(names(assay_list)) & !any(names(assay_list) == "")
  )

  # and the assay_list names should be unique
  stopifnot(
    "each assay in assay_list must have a unique name" =
      !any(duplicated(names(assay_list)))
  )

  # remove features with zero variance
  assay_list <- lapply(assay_list, function(x) {
    x[MatrixGenerics::rowVars(x) > 0, ]
  })


  ## remove messages from calculatePCA
  if (suppressMessages) {
    sm <- function(expr) {
      suppressWarnings(suppressMessages(eval(expr)))
    }
  } else {
    sm <- function(expr) {
      eval(expr)
    }
  }

  ## reference_list should have names, if it's not a list, then it should be
  ## a character vector of the names of assay_list which should be included
  if (is.character(reference_list)) {
    reference_list <- as.list(vapply(
      names(assay_list),
      function(x) x %in% reference_list,
      FUN.VALUE = logical(1)
    ))
  }

  # if ncomponentsReference given as integer convert to a list
  if (is.numeric(ncomponentsReference)) {
    ncomponentsReference <- as.list(
      rep(ncomponentsReference, length(reference_list))
    )
    names(ncomponentsReference) <- names(reference_list)
  }

  # if ncomponentsSubset given as integer convert to a list
  if (is.numeric(ncomponentsSubset)) {
    ncomponentsSubset <- as.list(rep(ncomponentsSubset, length(reference_list)))
    names(ncomponentsSubset) <- names(reference_list)
  }

  if (plot) mosaicDataUpSet(assay_list)

  assay_network <- mosaicDataTopology(assay_list)
  if (plot) plot(assay_network)

  ## check whether the network is a connected component
  ## the number of components should be 1
  if (igraph::components(assay_network)$no != 1) {
    stop(
      "feature network is not connected, features must overlap in some way via",
      " rownames"
    )
  }

  ## if needed, scale the data
  if (any(c(scale.center, scale.scale))) {
    assay_list <- lapply(
      assay_list,
      function(x) {
        BiocGenerics::t(
          scale(BiocGenerics::t(x), center = scale.center, scale = scale.scale)
        )
      }
    )
  }

  all_embeddings_list <- list()

  for (reference_dataset in names(assay_list)) {
    ## if not a reference go next
    if (!reference_list[[reference_dataset]]) next

    m <- paste0("treating \"", reference_dataset, "\" as reference")
    if (verbose) message(m)

    ## when the graph has a weight, then by default it will use them
    # shortest path is weighted by the number of shared features
    to_nodes <- names(
      sort(igraph::distances(
        assay_network,
        to = reference_dataset
      )[, reference_dataset])
    )
    all_paths <- lapply(igraph::all_shortest_paths(assay_network,
                                                   from = reference_dataset
    )$res, names)
    names(all_paths) <- unlist(lapply(all_paths, function(x) rev(x)[1]))
    all_paths <- all_paths[to_nodes]

    ## the PC space of the reference dataset
    nPC <- min(
      ncomponentsReference[[reference_dataset]],
      nrow(assay_list[[reference_dataset]])
    )

    for (projectionType in c("PC", "LD")) {
      if (projectionType %in% "PC") {
        if (!is.null(reference_scores_list[[reference_dataset]])) {
          if (verbose) message("reference scores given, using these for mosaic integration")
          reference_scores <- reference_scores_list[[reference_dataset]]
          restrictFeatures <- FALSE
        } else {
          # reference_scores_raw <- sm(
          #   scater::calculatePCA(
          #     assay_list[[reference_dataset]][
          #       reference_features_list[[reference_dataset]],
          #     ],
          #     ncomponents = nPC,
          #     scale = FALSE
          #   )
          # )
          # start replacement
          reference_scores_obj = BiocSingular::runPCA(
            t(assay_list[[reference_dataset]][
              reference_features_list[[reference_dataset]],
            ]),
            rank = nPC,
            scale = FALSE,
            BPPARAM = BPPARAM
          )

          reference_scores_raw <- reference_scores_obj$x
          attr(reference_scores_raw, "rotation") <- reference_scores_obj$rotation
          # end replacement


          attr(reference_scores_raw, "rotation") <- list(
            attr(reference_scores_raw, "rotation"),
            stats::setNames(
              rep(0, nrow(attr(reference_scores_raw, "rotation"))),
              rownames(attr(reference_scores_raw, "rotation"))
            )
          )

          loadings_reference <- attr(reference_scores_raw, "rotation")

          reference_scores <- as.matrix(
            t(assay_list[[reference_dataset]])
          ) %*1% loadings_reference
        }

        d_nPC <- diag(ncol(reference_scores_raw))
        colnames(d_nPC) <- paste0(
          reference_dataset, "_", colnames(reference_scores)
        )

        P_0 <- d_nPC
      }

      if (projectionType %in% "LD") {
        # linear discriminants

        if (is.null(labels_list[[reference_dataset]])) next

        m <- paste0(
          "labels provided for \"",
          reference_dataset,
          "\", adding LD components"
        )
        if (verbose) message(m)

        features <- Reduce(intersect, lapply(assay_list, rownames))
        if (length(features) == 0) {
          features <- reference_features_list[[reference_dataset]]
        }

        if (length(features) > maxFeatures) {
          if (verbose) {
            message(
              "more input features than maxFeatures, subsetting features using",
              " variance ranking"
            )
          }
          # genevars <- scran::modelGeneVar(
          #   assay_list[[reference_dataset]][features, ]
          # )
          # genevars_sorted <- genevars[order(genevars$bio, decreasing = TRUE), ]
          # features <- rownames(genevars_sorted)[seq_len(maxFeatures)]
          # replacement below
          features = selectFeatures(assay_list[[reference_dataset]], features, maxFeatures)
        }

        labels_train <- labels_list[[reference_dataset]]

        ## remove features with zero variance for LDA
        vars <- MatrixGenerics::rowMaxs(
          apply(Matrix::fac2sparse(labels_train), 1, function(x) {
            MatrixGenerics::rowWeightedVars(
              assay_list[[reference_dataset]][features, ], x
            )
          }),
          na.rm = TRUE
        )
        if (any(vars == 0)) {
          if (verbose) message("removing features with zero intra-class variance")
        }
        features <- features[vars > 0]

        data_train <- t(assay_list[[reference_dataset]][features, ])

        lda.fit <- sm(MASS::lda(data_train[!is.na(labels_train), ],
                                grouping = labels_train[!is.na(labels_train)]
        ))
        colnames(lda.fit$scaling) <- paste0(
          reference_dataset, "_", colnames(lda.fit$scaling)
        )

        reference_scores <- t(
          assay_list[[reference_dataset]][features, ]
        ) %projpred% lda.fit

        d_nLD <- diag(ncol(reference_scores))
        colnames(d_nLD) <- colnames(reference_scores)

        P_0 <- d_nLD
      }


      embedding_list <- list()

      for (path in all_paths) {
        if (verbose) {
          message(paste0(
            "generating embedding for path with reference \"",
            reference_dataset,
            "\": ",
            paste0(rev(paste0("\"", path, "\"")), collapse = " -> ")
          ))
        }

        if (identical(as.character(path), reference_dataset)) {
          embedding_list[[reference_dataset]] <- reference_scores %projpred% P_0
          next
        }

        path_current <- path

        P <- P_0

        obj <- list(P)
        ops <- list("%projpred%")

        while (length(path_current) > 1) {
          features_current <- Reduce(
            intersect, lapply(assay_list[path_current[seq_len(2)]], rownames)
          )
          if (path_current[1] == reference_dataset) {
            current_scores <- as.matrix(reference_scores)

            # features when nearest the reference
            if (projectionType == "PC" && restrictFeatures) {
              features_current <- intersect(
                rownames(loadings_reference[[1]]),
                rownames(assay_list[[path_current[2]]])
              )
              if (length(features_current) == 0) {
                if (verbose) {
                  message(
                    "No common features when using restrictFeatures, switching",
                    " to intersection"
                  )
                }
                features_current <- Reduce(
                  intersect, lapply(assay_list[path_current[seq_len(2)]], rownames)
                )
              }
            }
          } else {
            current_obj <- obj[[length(obj)]]
            if (is.list(current_obj)) current_obj <- current_obj[[1]]
            scores_features <- setdiff(rownames(current_obj), "intercept")
            current_scores <- as.matrix(
              t(assay_list[[path_current[1]]][scores_features, ])
            )
          }

          if (length(path_current) > 2) {
            nPC_sub <- min(
              ncomponentsSubset[[reference_dataset]], length(features_current)
            )

            # dimred_current <- sm(scater::calculatePCA(
            #   assay_list[[path_current[1]]][features_current, ],
            #   ncomponents = nPC_sub,
            #   scale = FALSE
            # ))
            # start replacement
            dimred_current_obj = BiocSingular::runPCA(
              t(assay_list[[path_current[1]]][features_current, ]),
              rank = nPC_sub,
              scale = FALSE,
              BPPARAM = BPPARAM
            )

            dimred_current <- dimred_current_obj$x
            attr(dimred_current, "rotation") <- dimred_current_obj$rotation
            # end replacement


            attr(dimred_current, "rotation") <- list(
              attr(dimred_current, "rotation"),
              rowMeans(assay_list[[path_current[1]]][features_current, ])
            )
            loadings_current <- attr(dimred_current, "rotation")

            coef <- stats::lm.fit(
              cbind(intercept = 1, dimred_current),
              current_scores
            )$coefficients
            coef <- stats::na.omit(coef)

            obj[[length(obj) + 1]] <- coef

            obj[[length(obj) + 1]] <- loadings_current
            ops <- c("%*1%", ops)
            ops <- c("%**%", ops)
          } else {
            ## if there are more than maxFeatures in features_current,
            ## then restrict to HVGs
            if (length(features_current) > maxFeatures) {
              if (verbose) {
                message(
                  "more input features than maxFeatures, subsetting features",
                  " using variance ranking"
                )
              }

              # genevars <- scran::modelGeneVar(
              #   assay_list[[path_current[1]]][features_current, ],
              #   min.mean = 0
              # )
              # genevars_sorted <- genevars[
              #   order(genevars$bio, decreasing = TRUE),
              # ]
              # features_current <- rownames(
              #   genevars_sorted
              # )[seq_len(maxFeatures)]
              # replacement below

              features_current = selectFeatures(assay_list[[path_current[1]]],
                                                features_current,
                                                maxFeatures)
            }

            coef <- stats::lm.fit(
              cbind(
                intercept = 1,
                as.matrix(t(assay_list[[path_current[1]]][features_current, ]))
              ),
              current_scores
            )$coefficients
            coef <- stats::na.omit(coef)
            obj[[length(obj) + 1]] <- coef
            ops <- c("%*1%", ops)
          }
          ## if length(path_current) == 2 then this is the last step,
          ## i.e. can use all genes in the remaining assay for coefficient
          ## estimation
          path_previous <- path_current[1]
          path_current <- path_current[-1]
        }

        ## now that the path is just length 1, perform the projection
        obj[[length(obj) + 1]] <- t(assay_list[[path_current]])
        if (length(obj) - length(ops) != 1) {
          ops <- c("%**%", ops)
        }
        embedding_list[[path_current]] <- .runOps(
          rev(obj), ops,
          leftToRight = FALSE
        )

        ## also project the prior data too
        if (projectAll) {
          obj[[length(obj)]] <- t(assay_list[[path_previous]])

          embedding_list[[path_previous]] <- .runOps(
            rev(obj), ops,
            leftToRight = FALSE
          )

          for (path_previous_previous in path) {
            if (path_previous_previous == path_previous) break

            features_previous_previous <- rownames(
              assay_list[[path_previous_previous]]
            )

            previous_previous_ind <- max(which(unlist(lapply(obj, function(x) {
              if (is.list(x)) {
                x <- x[[1]]
              }
              any(features_previous_previous %in% rownames(x))
            }))))

            obj_previous_previous <- obj[seq_len(previous_previous_ind)]
            ops_previous_previous <- rev(
              rev(ops)[seq_len(length(obj_previous_previous) - 1)]
            )

            obj_previous_previous[[length(obj_previous_previous) + 1]] <- t(
              assay_list[[path_previous_previous]]
            )
            ops_previous_previous <- c("%**%", ops_previous_previous)

            embedding_list[[path_previous_previous]] <- .runOps(
              rev(obj_previous_previous), ops_previous_previous,
              leftToRight = FALSE
            )
          }
        }
      }

      embedding <- as.matrix(do.call(rbind, embedding_list))

      ## re-centre the embedding
      embedding <- t(t(embedding) - colMeans(embedding))

      all_embeddings_list[[
        paste0(reference_dataset, "_", projectionType)
      ]] <- embedding
    }
  }

  all_cells <- rownames(all_embeddings_list[[1]])

  all_embeddings <- do.call(
    cbind, lapply(all_embeddings_list, "[", all_cells, )
  )

  return(all_embeddings)
}

test_that("stabMap works", {
  set.seed(2021)
  assay_list <- mockMosaicData()

  # specify which datasets to use as reference coordinates
  reference_list <- c("D1", "D3")

  # specify some sample labels to distinguish using linear discriminant
  # analysis (LDA)
  labels_list <- list(
    D1 = rep(letters[1:5], length.out = ncol(assay_list[["D1"]]))
  )

  # stabMap
  out <- stabMap(assay_list,
    reference_list = reference_list,
    labels_list = labels_list,
    ncomponentsReference = 20,
    ncomponentsSubset = 20,
    verbose = FALSE
  )

  testthat::expect_snapshot_value(
    out,
    style = "serialize"
  )

  # error if only one input dataset
  testthat::expect_error(stabMap(assay_list[[1]]))

  # error if mismatch of colnames
  testthat::expect_error(stabMap(assay_list[c(1,3)]))

  # warning if ncomponents set higher than number of samples
  testthat::expect_warning(stabMap(assay_list,
                                 reference_list = reference_list,
                                 ncomponentsReference = 100,
                                 ncomponentsSubset = 50,
                                 verbose = FALSE
  ))
})

test_that("imputeEmbedding works", {
  set.seed(2021)
  assay_list <- mockMosaicData()

  # stabMap
  out <- stabMap(assay_list,
    ncomponentsReference = 20,
    ncomponentsSubset = 20,
    verbose = FALSE
  )

  # impute values
  quietIE <- purrr::quietly(imputeEmbedding)
  imp <- quietIE(assay_list, out)

  testthat::expect_snapshot_value(
    imp, style = "serialize"
  )

  # error when out is not provided
  testthat::expect_error(quietIE(assay_list))

  # error when rownames or colnames not given
  out2 <- out
  rownames(out2) <- NULL
  colnames(out2) <- NULL
  testthat::expect_error(quietIE(assay_list, out2))

  # expect same output when out is sparse
  out_sparse = as(out, "dgCMatrix")
  imp_sparse = imp <- quietIE(assay_list, out_sparse)
  testthat::expect_equal(imp, imp_sparse)
})

#' mockMosaicData
#'
#' Mock up a mosaic data list using simulated data, for use in documentation
#' examples.
#'
#' @param names character vector of mock datasets.
#' @param ncells integer vector of cells in each mock dataset.
#' @param ngenes list containing integer vectors of features measured in each
#' mock dataset.
#' @param fun name of function to simulate data, default "rnorm".
#' @param ... further arguments passed to `fun`.
#'
#' @return assay_list a list of data matrices with rownames (features)
#' specified.
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' lapply(assay_list, dim)
#'
#' # simulate data from another distribution
#' assay_list <- mockMosaicData(fun = "rnbinom", size = 5, prob = 0.5)
#' lapply(assay_list, dim)
#'
#' @export
mockMosaicData <- function(names = c("D1", "D2", "D3"),
                           ncells = c(50, 50, 50),
                           ngenes = list(1:150, 76:225, 151:300),
                           fun = "rnorm",
                           ...) {
  assay_list <- mapply(
    function(name, ncell, ngene) {
      matrix(get(fun)(ncell * length(ngene), ...),
        nrow = length(ngene),
        ncol = ncell,
        dimnames = list(
          paste0("gene_", ngene),
          paste0(name, "_cell_", seq_len(ncell))
        )
      )
    },
    names, ncells, ngenes,
    SIMPLIFY = FALSE
  )

  return(assay_list)
}

#' Adaptive k selection for KNN classification
#'
#' Given an error matrix, identify the k that maximises the accuracy for cells
#' belonging to a provided labelling/grouping. If no labelling given, expect a
#' cell-cell similarity network to identify the k that maximises the accuracy
#' for cells within that neighbourhood. If neither are given, simply treat all
#' cells as if they have the same labelling/grouping
#'
#' @param E An error matrix with rows corresponding to cells and columns
#' corresponding to candidate k values, with values themselves corresponding to
#' error values (either binary for single classification, or continuous after
#' multiple classification).
#' @param labels Group labels for cells.
#' @param local A neighbourhood index representation, as typically output using
#' BiocNeighbors::findKNN().
#' @param outputPerCell Logical whether to return adaptive k for each cell, not
#' just for each label type (used for when labels is given).
#' @param ... Includes return_colnames, whether to give the colnames of the best
#' selected, or just the index, which is default TRUE.
#'
#' @return Vector of adaptive k values.
#'
#' @examples
#' E <- matrix(runif(100), 20, 5)
#' colnames(E) <- paste0("K_", 1:5)
#'
#' # generate cell labels
#' labels <- factor(rep(letters[1:2], each = 10))
#'
#' # generate nearest neighbourhood index representation
#' data <- matrix(rpois(10 * 20, 10), 10, 20) # 10 genes, 20 cells
#' local <- BiocNeighbors::findKNN(t(data), k = 5, get.distance = FALSE)$index
#'
#' best_k_labels <- getAdaptiveK(E,
#'   labels = labels
#' )
#' best_k_local <- getAdaptiveK(E,
#'   local = local
#' )
#'
#' @export
getAdaptiveK <- function(E,
                         labels = NULL,
                         local = NULL,
                         outputPerCell = TRUE,
                         ...) {

  if (is.null(labels) & is.null(local)) {
    labels <- factor(rep("All", nrow(E)))
  }

  if (!is.null(labels)) {
    if (!methods::is(labels, "factor")) {
      labels <- factor(labels)
    }
    L <- Matrix::fac2sparse(labels)

    LE <- L %*% E

    k_best <- getArgMin(LE, ...)

    if (outputPerCell) {
      k_best <- k_best[labels]
      names(k_best) <- rownames(E)
    }

    return(k_best)
  }

  local_self <- local

  LE <- apply(E, 2, function(e) Matrix::rowSums(vectorSubset(e, local_self)))

  k_best <- getArgMin(LE, ...)
  names(k_best) <- rownames(E)

  return(k_best)
}

#' Run a sequence of binary operations
#'
#' @param obj list of objects.
#' @param ops list of operations (length should be 1 less than `obj`).
#' @param leftToRight logical whether operations should be performed in order
#' from left to right (default), or right to left.
#'
#' @return matrix or array output of the sequence of binary operations
#'
#' @keywords internal
.runOps <- function(obj, ops, leftToRight = TRUE) {
  if (leftToRight) {
    out <- obj[[1]]
    for (i in seq_along(ops)) {
      out <- get(ops[[i]])(out, obj[[i + 1]])
    }
  } else {
    out <- obj[[length(obj)]]
    for (i in rev(seq_along(ops))) {
      out <- get(ops[[i]])(obj[[i]], out)
    }
  }
  return(out)
}

#' Binary operator for model predictions on data
#'
#' This function performs model predictions via the \code{predict} function
#' for each column of data.
#'
#' @usage data \%pred\% models
#' @param data is a matrix with rows corresponding to features, and columns
#' corresponding to cells/observations
#' @param models is a list of univariate outcome models with the features as
#' explanatory variables
#'
#' @return a matrix with rows equal to \code{length(models)} and columns
#' corresponding to cells/observations
#'
#' @keywords internal
"%pred%" <- function(data, models) {
  do.call(rbind, lapply(models, stats::predict, t(data)))
}

#' Sorted matrix multiplication with intercept column
#'
#' This function first binds a column filled with 1s named \code{intercept} to
#' \code{a}, then performs rownames and colnames-aware (\code{\%**\%}) matrix
#' multiplication with \code{b}.
#'
#' @usage a \%*1\% b
#' @param a a matrix with rownames specified
#' @param b a matrix with colnames specified
#'
#' @return matrix
#'
#' @keywords internal
"%*1%" <- function(a, b) {
  if (is.list(a)) {
    a <- a[[1]]
  }
  cbind(intercept = 1, a) %**% b
}

#' Project and/or predict data using feature weights or a LDA model object
#'
#' This function takes a data matrix a and, depending on the class of b,
#' projects the data using feature weights, or predicts new values using
#' linear discriminant analysis (LDA) model object, or both.
#'
#' @usage a \%projpred\% b
#' @param a a matrix with colnames specified
#' @param b a matrix with rownames specified, or a lda model object, or a
#' list containing a matrix and/or a lda model object.
#'
#' @return matrix
#'
#' @keywords internal
"%projpred%" <- function(a, b) {

  if (methods::is(b, "lda")) {
    features <- rownames(b$scaling)
    am <- stats::predict(b, newdata = a[, features])$x
    return(am)
  }

  if (!is.list(b)) {
    return(a %*% b)
  }

  ab <- a %*% b[[1]]
  if (methods::is(b[[2]], "lda")) {
    am <- stats::predict(b[[2]], newdata = a)$x
  }
  if (methods::is(b[[2]], "svm")) {
    am <- attr(
      stats::predict(b[[2]], newdata = a, decision.values = TRUE),
      "decision.values"
    )
  }

  return(cbind(ab, am))
}

#' vectorSubset
#'
#' vectorSubset
#'
#' @param vec vec
#' @param mat mat
#'
#' @return matrix
#'
#' @keywords internal
vectorSubset <- function(vec, mat) {

  vmat <- c(mat)
  vvec <- vec[vmat]

  vecmat <- matrix(vvec, nrow = nrow(mat), ncol = ncol(mat))
  colnames(vecmat) <- colnames(mat)
  rownames(vecmat) <- rownames(mat)

  return(vecmat)
}

#' Adaptive k-Nearest Neighbour Classification using the StabMap joint embedding
#'
#' Performs adaptive k-nearest neighbour classification of discrete labels for a
#' training set from a query set, leveraging the StabMap joint embedding. The
#' training labels are defined in `labels`, with all other rows of the
#' embedding treated as the testing set.
#'
#' @param coords A cells (rows) x dimensions data matrix, on which euclidean
#' distances are to be calculated for KNN classification. Must have rownames.
#' Typically, output from `stabMap()`.
#' @param labels A named character vector of labels for the training set.
#' @param type A character of the type of adaptive KNN classification to be
#' used. Must be one of "adaptive_local", "adaptive_labels",
#' "uniform_optimised", or "uniform_fixed". Default
#' is "uniform_fixed".
#' @param k_values A numeric vector of potential k values. If type is
#' "uniform_fixed", then the first value of k_values is used. Default is 5.
#' @param error_measure Is the error type to use for selection of the best k.
#' Must be one of "simple_error" or "balanced_error". "simple_error" weights all
#' cells equally. "balanced_error" weights error by `labels` factors. Only
#' affects error type for type == "uniform_optimised".
#' @param adaptive_nFold Is the number of folds for adaptive selection
#' cross-validation.
#' @param adaptive_nRep Is the number of repetitions of adaptive selection
#' cross-validation.
#' @param adaptive_local_nhood Is the neighbourhood size for optimising locally.
#' @param adaptive_local_smooth Is the number of neighbours to use for smoothing
#' locally.
#' @param verbose Logical whether to print repetition and fold number for
#' adaptive selection cross-validation.
#'
#' @return Is a dataframe with rows the same as coords, and same rownames.
#' Columns are: input_labels is the training labels that were provided in
#' `labels` (NA is used as labels for the testing set), resubstituted_labels is
#' predicted labels for all rows (including for the training data),
#' predicted_labels is predicted labels for the testing set but true labels as
#' provided in `labels` for the training set, k is the adaptive k value used for
#' that each row of the training set.
#'
#' @examples
#' set.seed(100)
#' # Simulate coordinates
#' coords <- matrix(rnorm(1000), 100, 10)
#' rownames(coords) <- paste0("cell_", seq_len(nrow(coords)))
#'
#' # Define labels of the first 50 cells
#' labels <- rep(paste0("type_", letters[1:5]), 10)
#' names(labels) <- rownames(coords)[seq_along(labels)]
#'
#' # Uniform fixed KNN classification
#' knn_out <- classifyEmbedding(
#'   coords, labels,
#'   type = "uniform_fixed", k_values = 5
#' )
#' table(knn_out$predicted_labels)
#'
#' # Adaptive KNN classification using local error
#' knn_out <- classifyEmbedding(
#' coords, labels,
#' type = "adaptive_local",
#' k_values = 2:3,
#' adaptive_nFold = 5,
#' adaptive_nRep = 10
#' )
#' table(knn_out$predicted_labels)
#'
#  # Adaptive KNN classification using adaptive labels
#' knn_out <- classifyEmbedding(
#'   coords, labels,
#'   type = "adaptive_labels",
#'   k_values = 2:3,
#'   adaptive_nFold = 5,
#'   adaptive_nRep = 10
#' )
#' table(knn_out$predicted_labels)
#'
#' # Adaptive KNN classification using uniform optimised with balanced error
#' knn_out <- classifyEmbedding(
#'   coords, labels,
#'   type = "uniform_optimised",
#'   k_values = 2:3,
#'   adaptive_nFold = 3,
#'   adaptive_nRep = 10,
#'   error_measure = "balanced_error"
#' )
#' table(knn_out$predicted_labels)
#'
#' @export
classifyEmbedding <- function(
    coords,
    labels,
    type = c("uniform_fixed", "adaptive_labels", "adaptive_local", "uniform_optimised"),
    k_values = 5,
    error_measure = c("simple_error", "balanced_error"),
    adaptive_nFold = 2,
    adaptive_nRep = 5,
    adaptive_local_nhood = 100,
    adaptive_local_smooth = 10,
    verbose = TRUE) {

  type <- match.arg(type)
  error_measure <- match.arg(error_measure)

  if (is.null(rownames(coords)[1])) {
    stop("coords must have rownames")
  }

  if (is.null(names(labels)[1])) {
    stop("labels must have names")
  }

  max_k <- max(k_values)

  coords_train <- coords[names(labels), ]

  if (type == "uniform_fixed") {
    k <- k_values[1]

    knn <- queryNamedKNN(coords_train, coords, k = k)

    resubstituted_labels <- adaptiveKNN(
      knn,
      labels,
      k
    )

    out <- buildLabelsDataFrame(labels, resubstituted_labels, k_adaptive = k)

    return(out)
  }

  E_list <- vector("list", length = adaptive_nRep)

  for (Rep in seq_len(adaptive_nRep)) {
    train_k <- sample(seq_len(adaptive_nFold), nrow(coords_train),
      prob = rep(1, adaptive_nFold), replace = TRUE
    )

    if (verbose) message("Rep ", Rep, " of ", adaptive_nRep)

    for (fold in seq_len(adaptive_nFold)) {
      if (verbose) message("Fold ", fold, " of ", adaptive_nFold)

      coords_train_k <- coords_train[train_k == fold, ]
      coords_test_k <- coords_train[!train_k == fold, ]

      knn <- queryNamedKNN(coords_train_k, coords_test_k, k = max_k)

      labels_train <- labels[rownames(coords_train_k)]
      labels_test <- labels[rownames(coords_test_k)]

      E <- getBinaryError(
        knn = knn,
        k_values = k_values,
        class_train = labels_train,
        class_true = labels_test
      )

      E_list[[Rep]] <- E
    }
  }
  E <- combineBinaryErrors(E_list)[rownames(coords_train), ]


  if (type == "uniform_optimised") {
    # select the best column based on the error type
    if (error_measure == "simple_error") {
      best_column <- getBestColumn(E)
    }
    if (error_measure == "balanced_error") {
      best_column <- getBestColumn(E, balanced_labels = labels[rownames(E)])
    }
    k_adaptive <- k_values[best_column]
  }

  if (type == "adaptive_labels") {
    best_k_labels_index <- getAdaptiveK(E,
      labels = labels[rownames(E)],
      local = NULL,
      outputPerCell = TRUE
    )
    best_k_labels <- vectorSubset(k_values, as.matrix(best_k_labels_index))[, 1]

    # if any are NA, select the geometric mean value among the rest
    best_k_labels[is.na(best_k_labels)] <- ceiling(gm_mean(best_k_labels))

    k_adaptive <- best_k_labels[names(labels)]
  }

  if (type == "adaptive_local") {
    local <- queryNamedKNN(coords_train, coords_train, k = adaptive_local_nhood)

    best_k_local_index <- getAdaptiveK(E,
      local = local,
      outputPerCell = TRUE
    )
    best_k_local_unsmoothed <- vectorSubset(
      k_values, as.matrix(best_k_local_index)
    )[, 1]

    if (any(is.na(best_k_local_unsmoothed))) {
      defined <- names(best_k_local_unsmoothed)[!is.na(best_k_local_unsmoothed)]

      local_defined <- queryNamedKNN(
        coords_train[defined, ], coords_train,
        k = adaptive_local_nhood
      )
    } else {
      local_defined <- local
    }

    best_k_local <- smoothLocal(
      best_k_local_unsmoothed, local_defined,
      smooth = adaptive_local_smooth
    )

    k_adaptive <- best_k_local[names(labels)]
  }

  max_k <- max(k_adaptive)

  knn <- queryNamedKNN(coords_train, coords, k = max_k)

  resubstituted_labels <- adaptiveKNN(
    knn,
    labels,
    k_adaptive
  )

  out <- buildLabelsDataFrame(
    labels, resubstituted_labels,
    k_adaptive = k_adaptive
  )

  return(out)
}

#' selectFeatures
#'
#' For a given assay and set of features, perform variance ranking and select
#' a subset of features
#'
#' @param assay An assay matrix rows are features, columns are cells
#' @param features Character vector of the current features that are selected
#' @param maxFeatures Integer of the number of maxFeatures to select
#'
#' @return A character vector of the selected features according to variance
#' ranking.
#'
#' @keywords internal
selectFeatures = function(assay, features, maxFeatures) {

  if (!requireNamespace("scran", quietly = TRUE)) {
    stop("Install 'scran' select features when maxFeatures is selected")
  }

  genevars <- scran::modelGeneVar(
    assay[features, ],
    min.mean = 0
  )
  genevars_sorted <- genevars[
    order(genevars$bio, decreasing = TRUE),
  ]
  features_selected <- rownames(
    genevars_sorted
  )[seq_len(maxFeatures)]
  return(features_selected)
}

#' Stabilised mosaic single cell data integration using unshared features
#'
#' stabMapSE performs StabMap with SummarizedExperiment type
#' (SingleCellExperiment, SpatialExperiment) objects as input.
#'
#' @param SE_list List of SummarizedExperiment, SingleCellExperiment,
#' SpatialExperiment, etc that should be named.
#' @param assays Named character vector of assays to be extracted from the
#' objects.
#'
#' @return matrix containing common embedding with rows corresponding to cells,
#' and columns corresponding to PCs or LDs for reference dataset(s).
#' @importFrom SummarizedExperiment assay
#' @noRd
stabMapSE <- function(SE_list,
                      assays = "logcounts",
                      args = list()) {
  if (length(assays) == 1) {
    assays <- stats::setNames(rep(assays, length(SE_list)), names(SE_list))
  }

  stopifnot(
    "SE_assay_names should have names corresponding to the SE objects in assay_list" = setequal(names(SE_list), names(assays))
  )

  assay_list <- mapply(
    SummarizedExperiment::assay,
    SE_list,
    assays[names(SE_list)],
    SIMPLIFY = FALSE
  )

  return(assay_list)
}

#' Impute values using StabMap joint embedding
#'
#' Performs naive imputation of values from the list of mosaic data
#' and joint embedding from StabMap.
#'
#' @param assay_list List of mosaic data from which to perform imputation.
#' @param embedding Joint embedding from which to extract nearest neighbour
#' relationships.
#' @param reference Character vector of cell names to treat as reference cells.
#' @param query Character vector of cell names to treat as query cells.
#' @param neighbours Number of nearest neighbours to consider (default 5).
#' @param fun function (default `mean`) to aggregate nearest neighbours'
#' imputed values.
#'
#' @return List containing imputed values from each assay_list
#' data matrix which contains reference cells.
#'
#' @examples
#' set.seed(2021)
#' assay_list <- mockMosaicData()
#' lapply(assay_list, dim)
#'
#' # stabMap
#' out <- stabMap(assay_list,
#'   ncomponentsReference = 20,
#'   ncomponentsSubset = 20
#' )
#'
#' # impute values
#' imp <- imputeEmbedding(assay_list, out)
#'
#' # inspect the imputed values
#' lapply(imp, dim)
#' imp[[1]][1:5, 1:5]
#'
#' @export
imputeEmbedding <- function(assay_list,
                            embedding,
                            reference = Reduce(union, lapply(assay_list, colnames)),
                            query = Reduce(union, lapply(assay_list, colnames)),
                            neighbours = 5,
                            fun = mean) {
  
  embedding_knn <- embedding
  if (methods::is(embedding_knn, "dgCMatrix") &&
      !methods::hasMethod("queryKNN", signature = c("dgCMatrix", "missing"))) {
    embedding_knn <- as.matrix(embedding_knn)
  }

  has_reference <- lapply(
    assay_list, function(x) any(reference %in% colnames(x))
  )

  imputed_list <- list()

  for (assayName in names(assay_list)) {
    if (!has_reference[[assayName]]) next

    assayMat <- assay_list[[assayName]]

    referenceCells <- intersect(reference, colnames(assayMat))

    knn_out <- queryNamedKNN(
      embedding_knn[referenceCells, ], embedding_knn[query, ], neighbours
    )

    imputedList <- apply(knn_out, 2, function(knnval) {
      assayMat[, knnval]
    }, simplify = FALSE)

    if (!methods::is(imputedList[[1]], "matrix")) {
      imputedArray <- slam::as.simple_sparse_array(do.call(cbind, imputedList))
      dim(imputedArray) <- c(dim(imputedList[[1]]), length(imputedList))

      imputedMeans <- slam::drop_simple_sparse_array(
        slam::rollup(imputedArray, 3, NULL, fun)
      )
      imputedMeans <- methods::as(
        methods::as(methods::as(
          methods::as(
            imputedMeans, "array"
          ), "dMatrix"
        ), "generalMatrix"),
        "CsparseMatrix"
      )
    } else {
      imputedArray <- abind::abind(imputedList, along = 3)

      imputedMeans <- apply(imputedArray, seq_len(2), fun)
    }

    colnames(imputedMeans) <- rownames(knn_out)
    rownames(imputedMeans) <- rownames(assayMat)

    imputed_list[[assayName]] <- imputedMeans
  }

  return(imputed_list)
}

#' Sorted matrix multiplication
#'
#' This function multiplies two matrices but first reorders the rows of the
#' second matrix to match the columns of the first matrix
#'
#' @usage X \%**\% Y
#' @param X a matrix with colnames specified.
#' @param Y a matrix with rownames specified. Alternatively, a list assumed to
#' contain two objects, a matrix with rownames specified, and a vector of
#' scaling values for subtraction.
#'
#' @return matrix
#'
#' @keywords internal
"%**%" <- function(X, Y) {

  if (is.list(Y)) {
    rmeans <- Y[[2]]
    Y <- Y[[1]]
  } else {
    rmeans <- rep(0, nrow(Y))
    names(rmeans) <- rownames(Y)
  }

  features <- intersect(colnames(X), rownames(Y))
  XY <- (X[, features] - rmeans[features]) %*% Y[features, ]
  return(XY)
}

test_that("classifyEmbedding works", {
  set.seed(1234)

  coords <- matrix(rnorm(1000), 100, 10)
  rownames(coords) <- paste0("cell_", seq_len(nrow(coords)))

  # Define labels of the first 50 cells
  labels <- rep(paste0("type_", letters[1:5]), 10)
  names(labels) <- rownames(coords)[seq_along(labels)]

  quietCE <- purrr::quietly(classifyEmbedding)

  # Uniform fixed KNN classification
  knn_out <- quietCE(
    coords, labels,
    type = "uniform_fixed", k_values = 5
  )
  testthat::expect_snapshot_value(
    knn_out, style = "serialize"
  )

  # Adaptive KNN classification using local error
  knn_out <- quietCE(
    coords, labels,
    type = "adaptive_local",
    k_values = 2:3,
    adaptive_nFold = 5,
    adaptive_nRep = 10
  )
  testthat::expect_snapshot_value(
    knn_out, style = "serialize"
  )

  # Adaptive KNN classification using adaptive labels
  knn_out <- quietCE(
    coords, labels,
    type = "adaptive_labels",
    k_values = 2:3,
    adaptive_nFold = 5,
    adaptive_nRep = 10
  )

  testthat::expect_snapshot_value(
    knn_out, style = "serialize"
  )

  # Adaptive KNN classification using uniform optimised with balanced error
  knn_out <- quietCE(
    coords, labels,
    type = "uniform_optimised",
    k_values = 2:3,
    adaptive_nFold = 3,
    adaptive_nRep = 10,
    error_measure = "balanced_error"
  )

  testthat::expect_snapshot_value(
    knn_out, style = "serialize"
  )

  # expect error if coords and labels don't match names
  # because of no names in label
  testthat::expect_error(quietCE(
    coords, setNames(labels, NULL),
    type = "uniform_optimised",
    k_values = 2:3,
    adaptive_nFold = 3,
    adaptive_nRep = 10,
    error_measure = "balanced_error"
  ))

  # expect error if coords and labels don't match names
  # because of actual mismatch
  testthat::expect_error(quietCE(
    coords, setNames(labels, seq_along(labels)),
    type = "uniform_optimised",
    k_values = 2:3,
    adaptive_nFold = 3,
    adaptive_nRep = 10,
    error_measure = "balanced_error"
  ))

  # expect error if coords is transposed, error will
  # be because of not matching labels
  testthat::expect_error(quietCE(
    t(coords), labels,
    type = "uniform_optimised",
    k_values = 2:3,
    adaptive_nFold = 3,
    adaptive_nRep = 10,
    error_measure = "balanced_error"
  ))
})

---
title: "StabMap: Stabilised mosaic single cell data integration using unshared features"
author:
  - Shila Ghazanfar
  - Nick Robertson
  - Aiden Jin
output:
  BiocStyle::html_document:
    toc_float: true
  BiocStyle::pdf_document: default
package: StabMap
vignette: |
  %\VignetteIndexEntry{Mosaic single cell data integration}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = FALSE
)
```


```{r setup, message=FALSE, warning=FALSE}
library(StabMap)
library(magrittr)

library(scater)
library(scran)
library(SingleCellMultiModal)
library(gridExtra)
```

```{r}
set.seed(2024)
```

# Introduction

StabMap is a technique for performing mosaic single cell data integration. 
Mosaic data integration presents the challenge of integration of data where 
only some features or cells are shared across datasets. For example, these 
challenges arise when integrating single-cell datasets that measure different 
molecular profiles, such as chromatin accessibility or RNA expression assays. 
Integrative analysis of such data may provide a more in-depth profile of each 
cell, facilitating downstream analysis. To read more about StabMap please see 
our [paper on Nature Biotechnology](https://www.nature.com/articles/s41587-023-01766-z).  

## Vignette Goals
In this vignette we will elaborate on how mosaic single cell data integration 
is implemented in the `StabMap` package. We address a few key goals: 

  - Mosaic Data integration for 2 datasets
  
  - Demonstrating cell imputation following integration
  
  - Indirect mosaic data integration for 3 datasets, including 2 non-overlapping 
    datasets

# Load data

In this tutorial we will work with a multi-assay single cell dataset, consisting
of ATAC and gene expression data for 10,032 cells. 

```{r, message=FALSE, warning=FALSE}
mae <- scMultiome(
  "pbmc_10x",
  mode = "*", dry.run = FALSE, format = "MTX", verbose = TRUE
)
```

Perform some exploration of this data.

```{r}
mae

upsetSamples(mae)

head(colData(mae))

dim(experiments(mae)[["rna"]])

names(experiments(mae))
```

Keep the first 2,000 cells only. Normalise and select variable features for the 
RNA modality.


```{r}
sce.rna <- experiments(mae)[["rna"]]

# Normalisation
sce.rna <- logNormCounts(sce.rna)

# Feature selection
decomp <- modelGeneVar(sce.rna)
hvgs <- rownames(decomp)[decomp$mean > 0.01 & decomp$p.value <= 0.05]

length(hvgs)

sce.rna <- sce.rna[hvgs, ]
```

Keep the first 2,000 cells only. Normalise and select variable features for the ATAC modality.

```{r}
dim(experiments(mae)[["atac"]])

sce.atac <- experiments(mae)[["atac"]]

# Normalise
sce.atac <- logNormCounts(sce.atac)

# Feature selection using highly variable peaks
# And adding matching peaks to genes
decomp <- modelGeneVar(sce.atac)
hvgs <- rownames(decomp)[decomp$mean > 0.25 &
  decomp$p.value <= 0.05]
length(hvgs)

sce.atac <- sce.atac[hvgs, ]
```

Create a composite full data matrix by concatenating.

```{r}
logcounts_all <- rbind(logcounts(sce.rna), logcounts(sce.atac))
dim(logcounts_all)

assayType <- ifelse(rownames(logcounts_all) %in% rownames(sce.rna),
  "rna", "atac"
)
table(assayType)
```

# Mosaic data integration with StabMap

We will simulate a situation where half of the cells correspond to the Multiome
(RNA + ATAC features) modality, and half of the cells correspond to the RNA modality.
Our goal is to then integrate both datasets by generating a joint embedding of 
the cells using all data, and to impute the missing ATAC cell values from the RNA 
modality cells.

```{r}
dataType <- setNames(
  sample(c("RNA", "Multiome"), ncol(logcounts_all),
    prob = c(0.5, 0.5), replace = TRUE
  ),
  colnames(logcounts_all)
)
table(dataType)

assay_list <- list(
  RNA = logcounts_all[assayType %in% c("rna"), dataType %in% c("RNA")],
  Multiome = logcounts_all[
    assayType %in% c("rna", "atac"), dataType %in% c("Multiome")
  ]
)

lapply(assay_list, dim)
lapply(assay_list, class)
```

Examine the shared features between the two datasets using `mosaicDataUpSet()`.

```{r}
mosaicDataUpSet(assay_list, plot = FALSE)
```

From this we note that there are shared features between the RNA and Multiome
datasets, but there are many features that are observed only in the Multiome
dataset and not the RNA - as we had constructed.

We can understand the `mosaicDataTopology()` of these datasets, which
generates an `igraph` object, which can be inspected and plotted. 
The `mosaicDataTopology()` is a weighted network where nodes represent each 
dataset, and edges connect nodes with at least one overlapping feature.   

```{r}
mdt <- mosaicDataTopology(assay_list)
mdt
plot(mdt)
```

From this we note that the datasets RNA and Multiome share at least some 
features. StabMap requires that the mosaic data topology network be connected,
that is, that there should be a path between every pair of nodes in the network.

We now aim to integrate the data from the RNA and Multiome modality by generating 
a common joint embedding for these data using `stabMap()`. The `stabMap()` integration
approach aims to stabilize integration of single-cell data by exploting the 
non-overlapping features, so that cells with similar biological profiles will 
cluster. Stabilisation using non-overlapping features may be important
when there are limited overlapping features or when the informative features are
unknown. 

<details>
  <summary>**What is `stabMap` doing?**</summary>
`stabMap` generates a joint embedding using 3 steps:

- Identify the `mosaicDataTopology()`
  
- Embed the reference dataset into a lower dimensional space
  
- Project cells from non-reference datasets onto the reference dataset embedding
 by using a model to traverse shortest paths in the `mosaicDataTopology()`   
 
</details>

Since the Multiome data contains all features, we treat this as the reference dataset.
Since we already examined the mosaic data topology, we set `plot = FALSE`.

```{r}
stab <- stabMap(assay_list,
  reference_list = c("Multiome"),
  plot = FALSE
)
dim(stab)
stab[1:5, 1:5]
```

We can reduce the dimension further using non-linear approaches such as UMAP.

```{r}
stab_umap <- calculateUMAP(t(stab))
dim(stab_umap)

plot(stab_umap, pch = 16, cex = 0.3, col = factor(dataType[rownames(stab)]))
```

Here we see that the RNA and Multiome cells are fairly well-mixed.

# Data imputation after StabMap

Given the joint embedding, we can predict the missing ATAC cell values using
`imputeEmbedding()`. We use `imputeEmbedding()` for demonstration purposes as 
for our data both modalities have sufficient sample sizes (cells) and thus 
cellular imputation isn't needed. 

To `imputeEmbedding()` we provide the data list, and the joint embedding as output 
from `stabMap()`. We set the Multiome cells as reference and the RNA cells as
query. This is useful for downstream visualisation or further interpretation.

```{r}
imp <- imputeEmbedding(
  assay_list,
  stab,
  reference = colnames(assay_list[["Multiome"]]),
  query = colnames(assay_list[["RNA"]])
)

class(imp)
names(imp)
lapply(imp, dim)
lapply(assay_list, dim)
imp[["Multiome"]][1:5, 1:5]
```

# Annotating Query Datasets using the StabMap embedding

We can also leverage this joint embedding to annotate the query data.
We will use a k-nearest neighbors (KNN) based algorithm to 
transfer cell type labels from the reference to the query dataset. For our 
demonstration we will treat the Multiome dataset as the reference and the RNA 
dataset as the query.   

The column data of the single cell experiments objects contained in `mae` 
contain cell type annotations for each cell in the `celltype` column. We first
extract cell type annotations for our reference dataset (Multiome). 

```{r}
annotation <- "celltype"
referenceLabels <- colData(
  experiments(mae)[["rna"]]
)[colnames(assay_list$Multiome), annotation]
names(referenceLabels) <- colnames(assay_list$Multiome)

table(referenceLabels)
```

To classify query cells based on a reference dataset we can use the 
`classifyEmbedding()` function. We provide the joint embedding generated by 
`stabMap()` and cell type labels for the reference dataset to the
`classifyEmbedding()` function. `classifyEmbedding()` returns a dataframe with predicted 
labels in the `predicted_labels` column. 

```{r}
knn_out <- classifyEmbedding(
  stab,
  referenceLabels,
)
```

As we have simulated out datasets we have the true label annotations for the RNA
(query) cells. We can evaluate how well our predicted annotations match the true
annotations use a measure such as accuracy. 

```{r}
# Extract query labels
queryLabels <- colData(
  experiments(mae)[["rna"]]
)[colnames(assay_list$RNA), annotation]
names(queryLabels) <- colnames(assay_list$RNA)

acc <- mean(queryLabels == knn_out[names(queryLabels), "predicted_labels"])
acc
```

Since both the reference and query cells are embedded in the same low 
dimensional space we can also visualise their cells together. Here we present a 
UMAP visualisation colour coded by their cell types. 

```{r}
# Extract reference and query cells from UMAP embedding
stab_umap_ref <- stab_umap[colnames(assay_list$Multiome), ]
stab_umap_query <- stab_umap[colnames(assay_list$RNA), ]

# Create UMAP for reference cells
df_umap_ref <- data.frame(
  x = stab_umap_ref[, 1],
  y = stab_umap_ref[, 2],
  cell_type = referenceLabels[rownames(stab_umap_ref)]
)

p_ref <- df_umap_ref %>%
  ggplot() +
  aes(x = x, y = y, colour = cell_type) +
  geom_point(size = 1) +
  ggtitle("Reference cell type annotation")

# Create UMAP for query cells
df_umap_query <- data.frame(
  x = stab_umap_query[, 1],
  y = stab_umap_query[, 2],
  cell_type = queryLabels[rownames(stab_umap_query)]
)

p_query <- df_umap_query %>%
  ggplot() +
  aes(x = x, y = y, colour = cell_type) +
  geom_point(size = 1) +
  ggtitle("Query predicted cell types")

grid.arrange(p_ref, p_query, ncol = 2)
```

# Indirect mosaic data integration with StabMap

StabMap is a flexible framework for mosaic data integration, and can still 
integrate data even when there are pairs of datasets that share no features at 
all. So long as there is a path connecting the datasets along the mosaic data 
topology (and the underlying assumption that the shared features along these
paths contain information), then we can extract meaningful joint embeddings. To
demonstrate this, we will simulate three data sources.

```{r}
dataTypeIndirect <- setNames(
  sample(c("RNA", "Multiome", "ATAC"), ncol(logcounts_all),
    prob = c(0.3, 0.3, 0.3), replace = TRUE
  ),
  colnames(logcounts_all)
)
table(dataTypeIndirect)

assay_list_indirect <- list(
  RNA = logcounts_all[assayType %in% c("rna"), dataTypeIndirect %in% c("RNA")],
  Multiome = logcounts_all[
    assayType %in% c("rna", "atac"), dataTypeIndirect %in% c("Multiome")
  ],
  ATAC = logcounts_all[
    assayType %in% c("atac"), dataTypeIndirect %in% c("ATAC")
  ]
)

lapply(assay_list_indirect, dim)
lapply(assay_list_indirect, class)
```

Using `mosaicDataUpSet()`, we note that there are no shared features between 
the ATAC and RNA datasets. For their integration we might be able to match features by extracting
genomic positions and making the "central dogma assumption", that is, that the
peaks associated with a genomic position overlapping a gene should correspond to
positive gene expression for that gene. However, using `stabMap()` we need not make this 
assumption for the data integration to be performed.

```{r}
mosaicDataUpSet(assay_list_indirect, plot = FALSE)
```

We can understand the `mosaicDataTopology()` of these datasets, which
generates an `igraph` object, which can be inspected and plotted.

```{r}
mdt_indirect <- mosaicDataTopology(assay_list_indirect)
mdt_indirect
plot(mdt_indirect)
```

StabMap only requires that the mosaic data topology network be connected,
that is, that there should be a path between every pair of nodes in the network.
While ATAC and RNA have no overlapping features, since there is a path between 
RNA and ATAC (via Multiome), we can proceed.

We now generate a common joint embedding for these data using `stabMap()`. Since the 
Multiome data contains all features, we again treat this as the reference 
dataset. Since we already examined the mosaic data topology, we set 
`plot = FALSE`.

```{r}
stab_indirect <- stabMap(assay_list_indirect,
  reference_list = c("Multiome"),
  plot = FALSE
)
dim(stab_indirect)
stab_indirect[1:5, 1:5]
```

We can reduce the dimension further using non-linear approaches such as UMAP.

```{r}
stab_indirect_umap <- calculateUMAP(t(stab_indirect))
dim(stab_indirect_umap)

plot(stab_indirect_umap,
  pch = 16, cex = 0.3,
  col = factor(dataTypeIndirect[rownames(stab_indirect)])
)
```

Here we see that the RNA, ATAC and Multiome cells are fairly well-mixed.

Colouring the cells by their original cell type, we can also see that the 
mosaic data integration is meaningful.

```{r}
cellType <- setNames(mae$celltype, colnames(mae[[1]]))

plot(stab_indirect_umap,
  pch = 16, cex = 0.3,
  col = factor(cellType[rownames(stab_indirect)])
)
```

<details>
  <summary>**Session Info**</summary>
  
```{r}
sessionInfo()
```

</details>

# stabMap works

    WAoAAAACAAQEAAACAwAAAAIOAAAZyEAFBEtgCICFwBIF4vGlIcE/4+yXmqJWysAQ58RaniDf
    QA8oWXfPmA9AACRqhw8fn7/1SSs/6bpAQA2nyZY89aU/8zD1QWrSKsAHfElxvIxHP/+z2z8g
    qmI/+dUStaxeb0ADEHeFV90KwAVdIc0NaMe/8en5BLyPmb/uVmGbz3XFP+67+UMpP3a/8nfA
    Gax3Ub/hsJSmZhQAwAbma0Y0UCnABEHryoD/MUAS8Cqg1V+8v9tGo0Ba0Ju/6pclAYe/HL/W
    sDVr9e2Vv+fYa+uz8bs//TYe5kTcRMAIIvomrV8mP+EgUZSydlC/oUGxMUWK+MAC2T0skHqm
    v/P6gXkiL0rAFJjPb5p3Q7/4UUR7u0zKQAI/0WFAxco/+DJROTf+1D/0aS/FxtvIP9CVMTvA
    ldO/1VYW/76MEEAHMlJ+dL3kwBnXyCZ59h9AC5vSaiDoYL/QsN3idroMv9+KToVAGFPACoy5
    pPv4U0AO7dGoRvNjQBEer6iEg08/3O1BL2+UZj/41LnenErAP/dBf8V4LMXAKTGS4wZKJMBB
    mE/cuQAFwD0dxTWTaxPAOKx4vv+jjsBJPMmWqEF9wDTL5CSxNqi/+kt4h/yPNkAkep8oEgE2
    QEW4PBXW4hJANeYW9UUOdMA4qXOjJV7gwD1wYkLbYQhARy8mCwtoZ0BKJp7Ai4H6wD5EDoTc
    dSxALFAnhY7P8EAwJHk8cWKiQCLJSXtVt6nAMq4nYhy/AUAxlH1o9MXrQCuUjSBYAkxAHYlk
    4q5s2cAyGqKcyNcSwEEayZezoIDAM4AjgN7sP8AwPf5Uy4TbwC4qeygJB7RAUCl1plk4ScAw
    DTH9XrYHwDmrYJwmTitAPH8Cd2hCsUA6T6M5ZwT1QD8hE/SauRW/8NfE3ZDBp0BCZJRsvsBH
    wDOPjQ4kvLHASlQPO+F82cAjWWtkIgajQCbYcw15s2LACrZqSWs6DcATxVTjZy31QCBGMbk0
    SrDAJe0Yubewp0BAFoQK8ye7wCcKtKahum1AB2/dY7nEkMAlY0oNfNRtQAZCleCtpsNAO5DK
    ZAHZuEA1ubG8OatHwCeQK3+E2xq//N6cmuDgWsAUtw6C++uIwCCwwg+jxulAHY5+JjTKF8AJ
    TN6t6uOSwA7nqnutb3fACjsRRRVZcsAQIz96EVqxwA9usumt165AFDAC3YoeSUAmMdqcP1yr
    QAmnw+XFt0q/9CTy1hPb8EAQcVO6V7dwv+q9w9Iab6PAJEFcVqGuvL/6WeTEcGZ4QBrVBeUA
    c0bAAyBQ8+lAdb/1AE7M9Fyiv/VyIdtLxe3AHzOMNRh2f7/yfnqVwPa9v/3v0/krM9hAIx0r
    uoI3YUAWCZ8dcs3sQABU3H1SlJZAHvxrI3lUWMAhQb0MQnV6QAdAiKeLzXVAAFeQl+AysEAA
    gf1yi7TMv9HsGIM+6wBAASyo98ky3EAJ+6iV9nARP+iHiskHvmlACVCu7m/AI8AS5YrUuOD9
    v9d16jhFoLe/5cKlz57vp8AF2DsazD7tQBgdXnUNWhi//2qP8ZL+EkARzfkAnN7jwCTBgzwl
    rpRAEOIuJgj/8D/3x4YZ0lN2QBM4kmvyd1JAFICMDONM18AJXjF60fmcP+JoG0K1uoq/+MF8
    MSry4sAAWyGkJt5BP+0kPWYSsXFADDOo4ocdAUARB8wHt10av9hajcuZQLo/tGa2fNknjL/p
    TKnt+6Ozv9/UKUI6V1e/6B3IUoQphr/88UTQOr7UQAHsNwAqSAG/08dVIoalqz/ewjx0dFlQ
    QAPFJJc3ewtAActhQ53DqcAR8qpsz6newAtr2Dyf04m/vwpGHoH2U0AFRuBL/XIhv//pojwB
    4n5ABx4omtqpdcAIPQme/shEQAalEOrvfeTAEEqRhopygT/s3O4/zwPrwABcYleYvpA//uyg
    a/saVL/2T26SKeenP/emTBjCOOC/fDG1o8A62kATyIQIY0sIwAUfnWRs/cO/47SmbZpdR7/r
    lLZzJ8CCv70v5QKeQHrADb5hKyiNSUACIVdoCe07v/WY50pol6A/7ilmp2dTesAHYVD24KAm
    QBYGSNDVAvxAEGDUgXcSMb/sENcPcNVUQA+Ky8jn8T3AEVFchkhD4sABJVsZs4/5P9McQlZq
    ZzBAOxDMxnFx/EBKVSk5yDu2QElFiBsk8DdAS1keX1L7/UBUim2mFfKHQEOsOROi4oDAImAF
    FLiRd8Ah6gz7KbnqwFLlDM6u7eDARk0797m6cUBAdp7Oq+o6QEbrxwLnmHrAVgRLMrknl8Ba
    61O9klzLQEShBq4IDT3APaBs1D/Cn8BAro3s2aHAwCqI42snUk1ARtKKWMCKX8BFke2jTKR/
    wEB5X6Q2ePTAIQM/JpZF2UBJhT4LL/OBQEopseLQAv5ASEY964P9kkAzl5aPabHfQD6K9Mng
    li7AXED0zv6ZbEAwV4RvVDawQEkNPrOzr2fATdszwrEQvsBGJzFmqv0qwEn0JIdNGHRAFjVm
    vMDGCsBKJFJiSwZbQEU4mnZPbyZAVjcM825s3EAwVUWUVV/GwCaktazaOZFABVAzVxhZkEA7
    rYggO1rTwCcNlJQ+rO1AOm3VW0ZUj8BQU21EaUtIQAOb/SEZoYNACFStxYT0YUA6ebLz8v0i
    P+H/KgkzHW/ARJXVUMth1cBC1RIsa376QBsaZ12uc+3AMoOBidTXrb/cGlLxmlT6QCGNV4aN
    +rFAGwtHEAqvvUASBTTV/c4nQDQ8O40Va9FALXMicX+040Aieo5HFu9lQCQUotKU2STAOmbE
    IgHA50A2SIiRUnkEP/fR0ewM9Zu/7DmZX9hC5L/0LggMPCi2wDBJiyh18A/AHQxxR0RILj/8
    d5cbX7jbwABdLwA9XInAIFvjLMGIcMAqQVpDXF7IwCEPg3Di4KJALMA0CTWf8UAOsfAAKOBv
    wC9iRPzNYQdAJCdMs2jKEsAj3epWJQnGQB8e92y6NADACGCtE2QNZUApz32MP4RcwA2JY/Ux
    uoHALRWs4LdjukArGsCPpLmuwC6UBVLS6PdAFMykZsPfl0AHK1EXMGYFQAjQNtn8nlzANrn9
    Sy41vz/Jbhh/MDdaQDfx49IDe/ZAIEVGDy8SJUAbCiwaULJtwColYsgdRTtAF8RudSOLbsAn
    0+Y0SCF1v9ZkqiSaQj1APc86L+QG3sAmP3dPp1wHwCkCaNyzr6vAMk5Ay660rUAQM9woyJ+T
    P+qwUqSiXnNABOHperMli7/hJG2ENuwBwAzU/byboyLAELOMNC9UXL/W1kitav/jwBgt/AvP
    J2BACyP6Y4W6ZcAKR5gjzIevQADN0Br9QDG/1sgM1T6/H7/wjhb6oD8RP/zxYFFu66FAD1Wu
    1dogYT/3eWXOYadUv+W78qu/XCg/009Z1evyMz+CszPAJwxVQAne2ZKpyhU/tDr8dK85YT/K
    3Y2UiHe3QAbMOZrfYko/79pfRYFbzcATTf2pa5q5v/10efRZcudABdnIBRh/sz/mi9nb/z2l
    P+2LmKFZ3lBAGOJR0l1cucAHBZJ2We7tv+1CJBO037W/+6u/exyQK7/eJQwuJaZBv/iB9E67
    r/LAC1DiuxcOYL/If+nyA7bLQAOc7Tw3BL8/9vIzUkKHUkAB4EHsx/4cwAm27EwsZvI/9gL9
    0P5FED/dZOKreEvwP/R3x844Iuy/8ISFrJSGar/6gCE+kB+hP7YgPcL62I7ACPaw1tfAor/r
    YyJK4E/hv4og3+mXl0jAPRVQfqfO8sBJ/aHXaxWFwEQ3OCO3/57ATN2h3gmBisBUIJgf8XSu
    wEwSvexAf3JAAUjFvFjXLEAX0JWYr+BAQFm2X4yHxMdAQ7nbs7CQgsBEixhU+s6xwEx8/jeB
    WaFAVSSCsiTBH0BYNzOJxVXMwENz9MjvIJFAQX5iNI6pk0BFnAGE3bJfQDVF3XP/aaDASwfi
    77ucSkBDIHecywJoQD6LFqewN4hABbAp50ydo8BI3kw9oQUxwEvixDiYWPDASsAPSc5djMA6
    SYRWRaCWwD+wuE/c9wNAXTTvtscSgMApbR9Jw44JwE0B1dXVOFlARAjIrYnHDUBFVX/gvuU8
    QFB3fBKT7V7AB5oiGZFSa0BITgcr1ba2wEOIypzfwUjAVt5cxAxrIMAzc1h0sYldQDGFSQVG
    gwtAJOTfzEOznsA4cT2LoIPZQCxsqilUe0fAEXrCJj0xTEBN73pg93EEQB8GT4RR8OjAM2i6
    aa7//cBEh+4mFhR+QBV2x9l5/Q5ARfdQo4s3bUBOb9aYjD01QCqyzh4zcvbAJhrqkHVdnUAU
    4TNIh45tQBet9MuISkBAD1ajtAEpQUAqaPQ7SodVQBocU2Yt3A4/9OLvTe18PkAYPWarYFTq
    QAx5x7EJjmPAHSNuOliSVcAcOk3n+bQ0v97O7tB36Ww/981T2QamPb//hPYswln9wBuw3MPE
    yBFAFEyEg1AheEAARmB30yNhwA9ayqasKGW/8d8bdgd1sr/vapf/7cRLQCL2Y8lup2m/1cSM
    SrpX3z/dlf/5J8E+wBy3KDvSiSDAMOtrgx0lJD/zrhkm+9MAv/o2ifR9jJDAEXcel3vZ4r/5
    DlqY58j9wCL6mEWkLMvADw3p75yhqkAmtnoKuOzYQCJM21eDdxBAE+I7iXo2qL/iTqq9Slv7
    QBS5QUlYjM3AJNklk1stKUAc3i8crITgv95k+FlGDStAFPMX5Il0tD/JfxUui1VzwADkpVKJ
    05nAJskWmnhDysAcd8OLe1MHv/ubXYlWXyQ/4vXejIXPST/ndwuqF2q4P/sP3gg9tpvAFLbL
    MDVBl8AM33/KRe92v/A8tylkk3O/kxcuLCg6J8ALoRI1xpCQP3QLRuC9xRW/8mHroVKWOr/5
    +z1SjCmhwAdrBa9Agne/9O15WcYZeT/6STzX7Bn/v/YJdAJE8qvAC/sAvoLVJ7/kAjnYgRKM
    QAlgkiHCDsI/86OY/LuYH0AbDCJidnJQP+tudeP3se/AAF38uOTu3z/025KOEESDP8N7aD25
    lzhADgvM96cKRb/YfaqVgEMLQBDfXYyT9ny/7zAv3cVJCj/djw1Plw3IwAMoFV3EIkvAAZzG
    EJLeHkAAUXj0Iqc8wBO6kd/erHW/4/4Mq0uZoUADx3lKKK7rQBIFZp5XwEXACnQB3BQJk7/G
    Lf9S33LNP9HO3JiAqg0//rppyIE3Gb/Xh1Rx6dyHv/Rj1ouGfJq/+sHeisdv0z/wtZBuCkDJ
    v/064hcvguW/0V6GYEvoBz/zGV95LnmCwABcIKDAP1q/9jzcfOM8pUADZnm7Ya9xQAP53o9S
    918/xfEiyBVJFUARhTaZNMN2P2IX3uGCrULAIuSpame8w8Az1iLkIZq+wDo7UMU917rAMxUh
    C9nwicA7LWprRoSBwBsKl2HBi8NAFsjHVRYNe0AfQ/eOeW4EQDONTjnLiw1AHpxDHuPAP8Ar
    xHzS0V9XwC9MpCvqABxAQ+dcpktRfkBCggcDEud6wCmMgeEMm81AG4UWPxWQ70Ae2Tl8c8aG
    QCEAMEAphtrAJ1lpX+ARpkAwoLJVCaxtQCr74I9wCGVAIQCMFyR5ZcAw6iXwMv4GwDiRmDHR
    M9DAJ3UrMLT+nsASj0pkyK9TwC89fSDmhBJAQq7fZgryYcAiST9a32PLwC76rKaff/tAOQo4
    +DfboUA09BZVaeM2QCWL7jDrzkJAD46VpufEY0A2QuojbpoFwC13dEu08dbAO4qXU85FW8AC
    vb8hIWbFQBscO/aBpaDAE0aePoF2F8AgnMmAjn9pwAMti2M0YovALyTQL2nrm0A1G2LCp5te
    wCJdOMb+kINAE7Cx+TZuhcATHTXxGThqwBHZp1+2X+FAMBQtxd3bLEAZHZMjijaOP9KV5d3W
    wulAEM+LHmssREAEK4PY3+MhP+5DCQjCk0pAA1x/dwY8vj/GMV5SsWxOv+y5dt95MBXAEzVX
    DkFMsEAmxPd/lCNRQCOvzTvv3FG/254TrRK46MAZ4KovBZ61QChkh1lrelu/9nK/w4NQj7/d
    9/l3Y7BVQAP7LP1OJ7C/9u4QwKvtb8ARUMa4mpfrwBXU7GQJ4jw/t/6uHDhQkUABM8whMTR0
    v9tePeiQUV6/5S9xGSAsacAGYOwfsi21QAGVFkhnIyXAG6QMLn4tlcAKBWxDjik1wBPvlioh
    Vl/AJoIr0yOzMz/+Nf7ox8yiP9j//c6wqa3ABjYwMV/x9kASrOTe79dCQCWtV0KIF9XAI7Dq
    4hoi87/8lWW79lFQv/SrpLB78pu/xTNUvSJmYEAqD6XVWQ8pwBSLcMB5GY5AASXvNvedksAR
    LcG2ul8yQBgHsSckDDa/9T9Mupl84MAUr3S29nRRQCJH4wH1Fa7AFkZRTol33UACsAaimTLj
    v/fh91x4/4nAGhi9j46U4j/245k7kOQFP+Q1Z/Cge/DABoXeSsGxi0AHZ8TecqTdwAJ1iUZd
    i9E/quNv8K/PRL/5AGj8JF6jQAI5nC7IEmFAEVR2joepyr/zJxn3sBTHP/M4XPXW6vK/4txo
    Qts2qL/q/5rFLKuqQAUw7zKs9gw/4mgrdR+jAz/teRGowDj2P/mQsiBZEYe/09gDRSQ+YkAG
    f50r9poxwABvTaveeei/0HhxU0g7VkARUHpA4Cy9P+o9QeRof6G/6emclU6qYsAE3HuB7dSi
    v/mtLNOs+sm/8bqrXNFV97/mny6xJF80wA3YRGrX9cHAAY5SYhM+KUAOx7ag5VDxwAqxneU8
    yC+/6QQnmOmyw8AJkoma3f3GwAYV8xKozFS/8dc8pH0A0T/4fHdfpLaiP/jorPFM7JPABmvV
    8FGbcUAEJ0jfTxloQBg0p0XUbPs//viGRe4Aj7/mth2DYe5ewAD0G+dRYWO/65f2ZqsDSD/v
    VFZyC6fZQAVs0j1+t3o/9bvsfQpwlcATCOwwdA+7v/3pxbnQC25AJXx2KDodS0A5JKBL1HIl
    QDZCA47A4z5APsCFZq0dc0A/wKjvX1+sQDxVVe50ZMc/up5NqI4qJUAQWU3QpXEWwEj4Qv/0
    vzPALSxYSxYbTEA5QIjq8JQcQD97bWfuSm/ARYwX+nqWqsBIgayoZN1vQDaBoJykKb3AKufS
    maMB78A1ntL5xkOdwDGUR69AqfNANfy+RRc1YMAdlOb3IvQFwDTAksI5MBVAEK/UaW1SlEAo
    PsEzMnz6QDuR05aXoAJANlzOC1BkXkAiNVqPDDEWQC+5WHE2Q/zASEqGcbQVjUAgskcJFSUB
    QEAgZRVLS3rAKctCI1JFyMAk6BGxABJswDxouErFNum/7AJPDb5QAMA3E/4RMjqLQDMMoO4A
    RJlAR3HBQS7fW0ApxSnur8f4wDMq+iwCYFrAFFxGDmzvtEAqLGSKMv+nwDGi6tvpOZq/9skE
    ugXow8BAXx3op97ewBF2b3Ax0MdAE6uQtvtpmUA7i8k6vFxUwBpoSVbayBHAN+RFyGQPMsBC
    9Z9PMyptwCy5A6mHy/pALotzP8/xdcASDGaeAA9MwBKGIwmmJuvAJup6cucMe8AQFVLPGaUL
    wDJu05ylQ3PAJGeM3y817cAzodd2r4X8wDxER+F00NNAN1rMrzMy3MAVrRZ/YhBxwDMXyxWD
    DlE/8H2FYuIPcL/7Zmdow6NUQCf7oLpSCH7AId6MT6eDlEAn9juhCC+CQDfoRdw2BeNAFeYd
    WqWL3EAP/wPUYSwYQAkWKAxvcHHAIoYcYWWCL8AHMQTya46kQDFD1NQ4SsZAIG5Y+dYb9EAr
    yNvPjWWRwCICXfuN7H1AM7TLN1Ne+8A4hFBrOszoQBWDPvJFpo1ALSWLJL4skcA2og1KLBbL
    wCNk140F5xJAICVedEAyMUAqqB+cigeqwAbgU9jC1F1AQhQtGn7J7sA2XAAyCLliwCyLIYVK
    B7vAMXsALQkTzcACb1VPtiQdQCHgKpBSZUTAEp+Gw/FEc0A4Ip8OLXtowCq7aZmISSPAOLFB
    6XfB8UACpH5YzeqFQDWuuu2Dm6xAQm2Fpp9j18AEAtsHjAmkv/fmaUG5uQG/8YEbO4hSGz/R
    Y26nxAfTv9Vi2lycF7U//euyZ37l80AGl9v3AKxbP3kKqBkwbxU/7I0C/Vhr60AJ7J7ElQgT
    P+sJoqdbkqhABPK4UJbGvT//usK0XRe1QAEfPjF9lpRABG+5miUoFUASKErgvyBhP9Grr7j7
    RH4/43pZajdoMkAOgZZEd1BFv/J3RfIcUGDADoRYdeCNBj/6UwAduYD7P+C9pWfRfsK/8Ikv
    Jifvf8ALWcm3LW3JP/D/h631Lby/sB6Ugxy7vL/4FgMsRdwiQA8Omh8a5hk/1XUNwBevEcAE
    HdUJkiKuv6VCe1NFpkzAEZP+4W9Os0AAgkhqUigAwAoIeBVasGxAE4bCs/EvZT/6pKORRPdC
    v9o032HFfK+/uNpZGlsFrcAA+yfBqwI5P8cZJvbm+XvAE5e0Ot2vJj/Aa4/5Zr3qP7salquH
    GcjAC5LJN3rZRb/4VlA3XDG3wBCJWJxj/xs/4B1vpHU6Mr/7zyiiPceZv95vR4hSyDu/+BGu
    LTKB/sASh6j1ooXdv/Z0F3+v2+k/gvMsDItv+b/iGT8ZhrSYP+WteVXjkDNADBQoTSogskAG
    VioQNYsXP/sMwZZe3MrAD7P4BnAOzkALvmrm9VVOQACtyGirOAI//f9eMCVjYj/BPWhnYzo7
    QAv7NSCsVb7ADdeljR7LSMACORpZekNdwBqtKmlf/9JAByvkHliJ8UAImURAbI+dQAVGAGYS
    5YQ//ZL2YR5p+7/2hHoWCYgnQA1Xgw20kXbACAHzPFEJd8AaCTUr/TTcv5Zx/qliOs8/9edk
    VGRyVUAHxSh5D8vEP99clWb2Xu1AEhd9xBrNUUAZiL5dyghLwAbRZTUUb+DADN3ix46VoUAY
    mqinAy67v/tZ/UimNrfABeT6TahWgD/yq7O+FOqFQAQ4tiocNQPAGwMqN264AT/4dEbx9M0n
    P+e7mO4VK3u/4+/1QoYb17/6o7LBWiR6wBkPQ9O/Jmo/8RqT2a4J3j/+rdb6OESFwA1mL8zU
    TUxAE03Mkn+8PMAP0oWC7tESv9kJozhoUD7AFJoiVwy6Fb/ewnav3Cz8wATFbehbHgZAKMyz
    BOD9PEAiUB5G5ZjkwA0RFQS9D1LAI3rxkE79zEAfkfGVKu2SP7OjpuzA5GZAD+ZGQATGpMAK
    MT0zv/EAQCB4XeyNl+FAFU8oVAd6jT/0e5xZRVFiwBDxPAICOCzAHDqCnetURr/7PjQe0PYK
    wAahUAo5HpS//wctOdjrJj/7NLyWMPwAQCOXW1lITMzAMKyjyqwNWEALhYbbRO4bQAtvrnZQ
    4z/AM0nm0zM2zkAEw2bkuhJ7wBLfOOtLi/m/8CQ19Er4H8Ao8Hfuc8nYwBaTd8k3egLAE0Y4
    jGbZC0AnmoPQ8Jr0QDNWlaJy5+k/3+StwL/GWMAVp/0VoxUlQCDJochSwNbAHD23YQa5AkAp
    cAIEHWPXwCCpfVYldvdAEpNc1AFHs8AUosStaHRvQCemQYmT4VXAIupneP4OU8AIXe5ZPKXC
    wBWjTirfry3AAINHCVUeYEAkrgp78PkEQCfHBr5EYyPAHK+VSKBnfD/Psuniz0bhP9BI2nEv
    bne/ov+amnLj6z/7E8x1KkEWQBFDZMzv4v7ADgbhFuH42L/wXNlLyARbv92NiBK42VHAE6oU
    PMZIsr+PnrodQlM6QBQCd4lTVnXAE9Eyu/ffH7/xNpwt4CvywAWDaB8u4YK/4iR7d1LKNkAG
    5GzuwfrRv/l2idiufH0/4IW3j6ZMREAAf65uU143P+k/W1rP/ii/jBpUX9LLjL/3+fbJ9q+f
    P+u/Su02RSBAD2hkZDqk4z/me7z2aHk2QBNBn8VP8wjAAyEVzjniXcABYjg0eBC+v+KxkCah
    d1Y/88sYIebOdEAAIBiELU4WwAUSFTUGv2i/0wPs/8El1b/9V1RnaJimv9847hNJJZpACT0u
    0zWEVj/2AO+8s10XQAoX0tARbic/zvDmKGL2Ez/bxuX+ftSVwALLo59UbIe/3WSG7JLfuMAA
    USMjAgA8P/eAuOP4gQu/uK3vrajUM7/qLHlWV7awP+4mu3/P+/A/8mVP+yb/8cAM/IunNU0l
    v+5iT2yBEadAM7ATLopzUkA3rMD+bXz7QDlQLc1Ob1lAQgjXwGDoMEBGjfzaQXpjQEKkbri5
    xO1AA4cxQPNno0ABuRa2bY0cwEwRdL1Jn2DAOE8uDOOocUA4z3Tux82WQEDaK8f94EDATETC
    sIVuAsBN86I++1ssQDKBdBjOICDAO63L6PM5PMBDSBh5qb89wCqcTeTccM5ARYD1hbaj+MA5
    ka1WIXUEwDQ3orMmgolADzp7jtkMREBA5OJQWP68QECzfnA7KoNAQotz4co8CkAewztbZxot
    QDa6cAM8ugLAUfyepZaDGsAVlWBr/VymQEIeZJ1475/AMjXTrAyLKsA0zyVZ/BWGwEPD0XK/
    SbZAJiFdJh9cRMA57ZCrmuuLQDkO/NBY95JATQTAocz+KUAjb1eCa69KwBXSEy+V3lrAJ/lZ
    /XkLs0A6mIUafYlxwBOqcGE0Rq7AKn04WvsnlcBGHubgrITGwCgzYzfP2BtAMUaEYKID1EBA
    iHEVMTKqwBigAr/406PAOYykOXLOsMBD5M+fGn2Tv/71jp/yFp7ABoiJ1sEcCkAUsUV2p3zg
    wBY2jqmIsM1AKffX38rAukAW+1SBiyaqwBCgoLyqf53ALE0eSQYBbUAzL5bor1xzQCBhm9lS
    //DAImtKuVE9FkAI37nq16H1QCs4xaVzbFS/7MJ0pNIx0r+ytowrev5wv+v0Eg1EWSpADCrI
    nFuYUcApNTEW6LcbwDfLtNLFJNQ/98JOasoEakAfTZUq+Bx5P/M/uPe0IRTAEsTT8R+cmEAQ
    x6R18tH+v+cMwWhUN0bAE1sLwHikwUALeCQfT0dXwBMjkDlV64TAGXQ0kewLyb/n3FSLDFSS
    wAHoYHkcMmbADFkWgvuS/0A0X0vRt8NzQDY16beG9z7ALPt84pjyHMACBu3MZ44FwBHV5fto
    ld/AKSg0aKptfEA2vllhXDTNwBoxXEiMZnpAKvV697eN7MAjjb3FfReqQBqk77/Kp+PAKcZf
    9GPaw8AhqUdu6JjzQBfnEEXbiXU//RzpREcZJD/34ZTE6VhGwAMdygkpWu7AGNVv+GxbnD/i
    y0x5nTO9v+hfCG+XF1k/+TdoCLIIwj/oYFjqlBx6P+z/hGV5Fq6/3YRQKvIo0MAOu+9FRxNR
    P4uJNBZGjalAAo/SggzA1UARNgUmx2S7QALP6YBS8qU/21pHBr/rL7/wRDIpOaapv/AW+K7m
    73pACGSbx4Bxrr/yXdY00H6BwAowqaeX6ne/3khANUxXhcAO2Vljo7AGv/Zz9c/vih7ACGVP
    rNBWWL/qc3IiLCl1v892RoZyA8dABp8uCOC19MARpmCedOaWP/ZQoubil98//z7wvgBdxT/7
    EarC7Vv/wAiBJAwVVjbADrBE6mRo+7/pFg9wY1w/QA6bSfjqz/0/8wVTg3L8AEAKgvjpZI18
    v+j8SVHPEEE/+ITMsNr/YMAGi8bZaFQaP/thCMMcuY0/92nBxZ/u07/gd1tjHRYVP+29NnpL
    lNdAAYxMYGkQQsADxlTrokoCv/k9cII7VJvAA+sbUYWFfMAE4+4WhXlpP/x6ONMgbKxAC6He
    sBtpzz/0+K9+Ovifv8JV3I9aiHLAKzivSqeTjcA5pGxO8WmZwDl++McSPK3AM1qH1W2wU8BD
    h0GJLtKfwBdwPvHR3dZAKuLD493mf0AtiQdzmJUSQDqTOOMGACFANN9mHwv77sAgmy60+dJG
    wCd9N0BrFsZAQOhRtvpvD0BHh4KR4kVSwDWVyi2AjfpAHduOFRx4Lb/IwHDCOah/wBOFyCoC
    stnAI4SOBwwT2kA4uJsAoJpYQCfgB8Zps0BAKuw6wJjGXMA6+Adyk3w2wCyQhCZS+ofAKEi+
    RJHw08An1u/AvFZTwCCU7KBL1YNAQrg1J1i6HcAhenFQjdn9wCWTFo7SB1xARB6yiyYQCUA4
    taxcL9yZQCiJIWyRDc1AFzKjp90UeEA4gGu2FvJtwDPfHqMlMZXAQEJ7qkrld8AHPf5uBwuu
    QBHdg/VuN6/AJL7giAZqJcAeuyuPwTmVP+CWqsRNh3/AOx5jSB4wE0AzayNw6p77wCTPvmuw
    7x5AEPergeT8NL/1zjTi8J9ywCHSofO54vZAMhcqIo/+1MAYLS/TkN4CQB73GPVniq3AMLY5
    e+EwoUAh0PSLXxnlQBKp2NGD625ACiKvi3WDUkAoyKzk8YeTQB8NeAbNwexAC4ZJ1SbQYD/v
    xjmlVvveP/r2WBmyyWbALWeFD+abMb/nuA0G3L+tQA1LxhbvBpZABEloHNMt/0AQPa6qQYcB
    wCKpyxuB9jNACj9g5t//0z/107jx5B5nQASeiR/lPMTAGTOIyCuGOcAGyjGeU8gCQBOjk0qd
    LNm/0OSRyoeVgMAGlzbSQ8p0wBcjaZUVG03AJ9rbC8flmEAFwgy6tM8Nv/1AIRldJkjAFts6
    YzWJqMAD8mQyp7gxv9+JTvrO58TAGuaBX7JStEAXaSy01JbyQBxGJQy5y91AJkO1ZaKI5MAP
    rSnGOjByQBppj25NHhLAJ2BxF9QSvL/osKSAKJg+QAh271l1cws/50hf0XKmfkATTzYeSMgI
    QAimZAFGPWzAHNwlDX1LLMAEWnFt7MoeQAEoi6YCq3RAC7Zw06DtDUAIwxszf5ZjP+ozpSJO
    pJPAKfGvq4l0EMACdDLZ2pKlwAP5mkp1Zbq/2R3oHXgW+UATXFan+pUkv++F0fp1WjnAAwhk
    tXMLCEAQCn4AMiljv+ezwd3OguW/qWOBOrqI8r+vVxUmBBmFv+YW1F1xgMA/4QA542MDNj/x
    ikEa++LQwBQEj1KvCHa/wFalNOuV2b/VxrMZJ3GXQAdnbFnlUHm/8PJZopLFmcAIDyjlM4Po
    v+hJxtjmT+i/4wTHKFeer0ACgKYO5H0IQBRUmOEOb4LAC1UO2L1f8D/uO1Yf3yTjv/5/BV5O
    /1xAAWNAn1beUL/wCj5uRYoxv+3hvfGS9+I/98zRUGx/bD/6NtIUhaVgP8iU4mdNKFa/1JEi
    jF6Tez/m6o1gk5XZP+fFHH4EtipAB7E2DCnxz7/j7BmhJavgQA67o9D7A6/ABFJOWIglp7+Q
    G6pV88y6v+cMQKvnNAQ/+V4dHFtTGcAF85EDzj7iwAFyh0zGp/1ACpPhr6QfqsAOJyEPiht4
    v/S2sEStMUK/tnif/du+gz/5PKoOnFsjP+IonCxX/EJAIdxQy6zjgUAoE5C8jjLnQCc7fHkG
    pUtALrZu2IFnlEA3DXW2pw0SQDNhVuuAa/1AGoFDJ/cE+kAgiOa9InjXwEAWVBWMx7DAKdvA
    JYEDgkApdEMsLlQzQDFOwneXArjANiHnP0Eel8A4/345X1t9QCAFfyMYE2PALpUwIR4FJcA2
    JIiVhPv5wAmpfxUcCaVANdXelAznaMAtTSwp3g3mwCnHf5g7ojJAHu3aCyNyx0AtkkGFGGPy
    QDLNRe/2YPtANfj1dm6VYEAc10iRTXF2QB6wzLfwmm3ARttNgjcVbcATvAGICg0wQDPjpXDh
    zgXAFsQ/ssoBOMAZHqSpjOgCwDVwVOC94zNAI2v/G3eAccAm7b3HOrWnQB05PghRE4dAPxAz
    ZkT+2EAgg1/5bTrhwBE0ber2gc3AHNyd4L1jpUAmMLSf5KodwAk3PW5RCPLALAvPy39K0sA4
    VskyvccFwCQ+pnflPQdAKsIWfAR31kAxX3YXHWrJwBw+1O0NYV3AIyGng9o988A5rbCdL/NM
    wBnbCZ2RL3BAKEqL8Q+kysAlvPgZNQxwQBRxon7zCjLAFA2tHZlyu8Ax5dIz6fI3v91MiYIb
    WgZADSUYyEOXYEALYwlaxUKyQBlN0ncZ5AFAGkoonr9zYkAAbDifCRxxv8DOUt6cnVK//geW
    dxY9qcACVEGwsVJTQBdkbGdfpUzAH3pMRYcKjT/r+xP5K9KVP//HSM4lZe9AC2vuH42qKcAI
    upaCzRtswCgxt49akn1AFEtKwdD42cAA9TuJ7kGmP/Vp84m0l0VAMdIRI8miT8AXXQVp74gy
    QBOpNnlYAMVABcmHVLqAbEAIYH0LnFoxP/Zi/ZTjQqJAHS7BjTsEncAp2KRiT7qmwC/7uUX1
    ceLAILAR9Lg1cUAdWwBetpnTwB8KrQpwk9FAIzGMpWRhsT/cVcnb/FjaP/rLQN1IeynAFCvq
    omz78z/IRQ2ErYlmwBBBm+tWbGhALMVgJEcFrEAEK9oqLFEeP/cfNdy55io/6cMMmjvlAMAJ
    GoEav29LwBHaZjymkAFAEUsIrzkNYEAJnLDFOB0sP8GlpsWZulE/8wzhr6kRwsAAFbFQ/Xmh
    P/R8GysnxDk/87HZ5Nrxz7/pO5ETFWqwP8b8qa4vTZJABRmPWJkb6L/yMkPW7ZKJwBEm8RfL
    NXpAEGedWkjPQ8AB27IirtzxwA1Bc6IajM3AB27tpQzkzUAQBL0Sops6P/SVxtjBHf2/6Zcy
    KNgVtL/wz+yxiGheP/bNjX3Hjb8/83PF2/wDEMAZbcl0pWODP/pkIot5Ev2//+oB0MbyLT/l
    fX4Wu63wP+K9oNo12UW/1vY3Pgo7a0AESQB65AjlP/ACE2AhKnC/8BXt1sZXSr/iT+G9RPOU
    v5MWTa/tFyi/iz/VZ4OPekADMlma3k1bv+0c7zQqko4/+zu4fPvwVj/EKlBvKrdLQAy2t2zR
    QknABGF58+4TmUABG72URaksP9fnvDfZfgm/59AGNN+sT7/wKHFm8ls8P+Gz+iPfbhq//WIx
    DXSOCj/0hjKfJGSAP+nn9xqD8so/7rs0gzhTgsASbjf1lsMDv/bpAa5OJI8/9MhIfL/t7kAu
    8uz6yREtQAzoOIWgNn9AIG8wVnc9OUAqVsoGPFd3QCDrvr8okeFAAngwOsCYKD+blXrc2o4V
    wEFHM9C1SKA/7IAqZ9YnOEAnd9qX26gJQDT0tquH+3G/9pI5+KvQdcAsgDO8mlSgQByBR9Ph
    iT7AATyoGoaDbsAcavScCjLdv/YM/3WiGP9AHntDSNIslb/znKSFnb8dv/AmVEsCtfhADaZI
    pTmVUD/8CdIpOs5HQBbrdUkfudxACg84guVBoUApTOJuwvC+wA50PS/G7s3ANK6YYk2gU7/8
    /HZ7u9fFQCd0+AcLmSXAHPPcwUy21sAa73/DV5BXwCxv3dls9pbAFz1zSjAroMAIltpzoee6
    QAJUyILzx1RAM3g0gIi81EAQkpasDFmdwCxtKGKu5eLADZ1CzdvQYsAOWNIY1vcFwCUoG2hQ
    ZwO/8kcqmKCjzMANniY1UQI6v+TeKt96y8JALqT+Z0+1GUAgVXpx/OcYwBVNUAQmA3i/2o3z
    H+fZ9MAzIGQVL38Cv7fBc+KegJVAIIuLTKuZBz/p3q58QFgcv/lVDnA0KiJACdedBH93ksAg
    96Qy2cO/wBu5jwUw+aTABlDo3pKGukAZUJDlok5AQBOMtQJCtaRAFfQw6a038MAXnVjNvUck
    P/+TR7jUer6/2E8tXnrJWsALR/HZncEeQBuHxNoOtQxAG3e0NvvrzcAhCAK1p2kqwCPanfB9
    x1hABadDDewFjEAWyzoO0pHiwAqpqU50pS8/0YH+QtwqLkATJOp5jOTpQAlGvnfYXxw/9VY0
    z1v4/sABCRaBgGwcP/o58Tc2bP+/+K/ABv2mdUAGSfDibKguwAUTBKcnaElAEIbd9iVYvz/0
    /a/H3ZQPQAqRLZJrUXnAJVMl3+NycsADkk51yi3ZwBn1csTxAQK/6wTnf8AOXUAiz1eX128z
    wAx+dTFuyQVAD67VcDOHn8ASLHzKQ5v/P9bq9VpziCW/uvkM9cKtMcAFAClwxMjkQAyInIEv
    /yO/+EOpK4GtW7/pOKVLPOLIwCHYuifnDhJAG/HXlRsoeL/c96sEnYZ8QAZ8DQs5mtzADX80
    wtWiJ7/zAAvvAz9Av/mz5o59Md/AASMHEQmVoMAFt4VA5wi7v8LT92dlHzu/z1sY8F3Yqz/3
    +gME0nrjv/pm3sAEKF4/6CEbgiATwD/4ZyFHfsmfv80uBno0khfAEWt5ARuiw7/yC8o9Qh1l
    P/8ShQyCsXc/9cHWdNK+zT/QtfirTiDBP9niAmpLXk4/7c9LK01Tmj/lUq2bojX6v8TOL0En
    wym/9utT0caj+cABgikj34tIQBOa0gMjz3a/57ZyJL7aX0ADYJ2s+BABQBCIr+XCKAS/8DeU
    ALDHfUAGuEkQUtlaP/Sek3/04q7ADgyAhUqEU8AFqbKwYx9JwAKA9YkyJhC/+uPpQjbTa7/F
    R2GLrDjfP/M0nkCfGWo/6kokjDIc0EAHEWiFee/vv+GtM92ERM0//Xl7+8I9RL/9MygeAjZ5
    P/n2BJNs/d2/91q6dyXIksAMVK6LOi+uv+mNxFSA7eI/8T3MhVxBVkANPwAY+c1ZQAhRKGVM
    C8LANz4hMhkDyMBFX2gm8FojwEMC8BJt8DfAQqF4uYtGKMBMQckJKPG1wDe2xtucJ75AKbr5
    sL5CKkAxfEIKmgQZQEnfjn5bXNtAQn+ZbS+/I8A4jmRpCELOwD+2uVoMRQFATBSTBc2OeEBR
    5uIIzc0fwDs5Lzaw3MhAJ1wF9srL2UAM1wnTky2PQCGr/zq74fjANk2Nh4w6sUA7U6Fg5o91
    QDXK34bWQNxALNQJWeblasA9i/CSxs5WwDVGMHtZ+ZPAOsOnfEpjJ8A2ONewbYm/wDF2cqI5
    52lAUAhB/3ceKsArlS+fIzKtwD7NmTUyX9FASHP3SNQy8EBA/zR2fha+QDiLmlcXmmZAI38G
    /Ibr4EBDBjEPxH4qwEFqpK5rr2LAS8Bq622FyMAjJy3y8o3pQCPTOFg++yzAC/8+AFLkw8AZ
    Xw8fxOnEQDAANyBDvdjAQOb+df9eeEBBY4IM3wBhwCLG8scpMCk/+xUaICihm8AwK6Ycnbqj
    wBp1NtVvQOtAQO2Adnd5L0Atia0Q7hrGQAYIB3qRG3PAMmlCKyMN30APIpKwLCIYQBEte6xi
    S+VANF2m2c7HIEAvKGwbuwkxP+swxYudhCnAIuhGtz+AIkAQSyK5PCqlQBLhZhy4sFHAKE5l
    UDDJOsAHmRxwau1+QCVtADY90Q1AD+kO4YZrNUAOhJ/7p71WwC4SZYaCVDvAJ1NMEK+x/cAH
    CgJNNgWrwAiWXiva30nABTHYyHZKMMASQI9nm5LlQClDDDlm1TTAJq1o0YfwiL//Ctl/VEcb
    wAl6HcxMHbjANnzBCjtZwkAipCUQBjFVwCRCxWjzoLXAFfB4DSEj6MAw+1g2P/61wBdBDWnU
    aC/AF407HaHJcUAzTFpDxG8YQDoz4YUAWStAI7iF1JgxHcAHOLQo+ldFQCiAf+UPB8nAMRgh
    k+nm40AbQv/Tb2YbwBieFEqw/VRAIHI3RZKRs8Aadsv2nap2QDQvMJmNMezALXBkQOnvzsAP
    1flM/h9yv9egLAbaw5y/xEuZ+1IJF0AyFGmq4rrVQDHrMRXis7/AMcEg9oc+e7/z76LBcYX3
    QBNg6o+iqBXADiU/z3jDY7/4IJ2XahkTP9UEN1C/hZu/7l9iuBExSkAFK1U2PeVMv8knon9+
    pA6/+r9B6XW2Y0AKAiMToH4iP++pOxXRtUA/8Uq28/NH+b/3DW2cHjwwv/gPPhYP6zg/46Vp
    nSGkwb/8lvI5KU2awAdv/RY33Ka/9hTuTye940AO7ssC//pDwAL1mWTGY11AEWhi7iia0D/l
    w32KwVikv/s/0xoyhsC/8gVHSn0Olr/yQzOtOGuUv8cTdnPLQL5ACqmmwbCN0j/lwj4tEmHt
    v/secTTgeuo//tcSA2lp2sAEDfyB4Q8Ev9I54RuAenU/1giT0um2fT/8aUuvRFPeP/7NsC4i
    0+S/2Lx1uosTCr/2BEYT3D8lQACO7eS7oZ7AEX4O9Fde9j+iSLNklxKmv/WkWuHObaxACpnS
    Ipp/UD/wcD3Q4mQRv+Zka5H8MkDAASm14xjuKT/92VOInMUZwAEWT+X779g/81lYYq1vH7/9
    /hKRtiKWP/j4bPLJ2fBANag4/MLY9EBDLqc5yqL+QD8RIVCYu/1ARjdvg7ICqkBMAC5u7VdE
    QEWJwBMUdGe/6PvwuQe1U8ABxdnYSPOJwFErG9OU8lDAQDYqlr77fUBBrXeNfaYQQEaXBqlf
    1GvAUOIe0bkLksBTNnFHgMM8QEEKMEgaQBPAQFItCvey+8BBdANFm4vuwDXOClSjY3ZARthG
    v/lRL8A3L/g6lN9OwDtGKJlEK5DAFxJTM+finEBCHR4QQn5HQEOWKigNDKJAQt04VIt37kAu
    UKMK2F7OQD5Rq1CEYNvAVG6w8FeflUAqLG7k39dNQEhJ8JGBb8jAPPI/uavHQcA51Gb9+fmF
    wEaXw/pemhE/nheX8cxTAcBAAglRGt6dQEJB8GcgPvZAUB4dp0gehkAvhGr+eppzwCm7QOIw
    9kHAISWb/0QXfEA2bdjrjr3GwCkadYPcMwhABFAPhLyet8BKnj3XbJRtwCAzuhKqjwVAHfC1
    mwc/j0A7dBgSOIFiwCS+VGJ7KXnAQA+H4X/ov8BHIUvm7jPdwBOmAdeusKVAHkDQ48UFRMAV
    Fi4i/tWGv+4KDQacXdJAC6iUUQ+qrcAnrNJ0YbBxwAhr5xcu9B0/2379XCNNgEAKfvVa6lUv
    QACsZ4pBXGhACgDODcnPTD/6EL9uxZZwP+YUo+3td2e/6w9QBxwWfr/5gV0X5AXEQBQuzr+/
    GmzAGIHvKKbefsALAqCgibnrv/befFk5Foe/yZJF2Yt2Xr/r1jej6KqIwBZL0alalfU/+kpg
    lIEV8EADLrMJB5h7P/cbtEdw0i5AIS5jFtckvMACar3EknfxQBP6qr0RJJo//xS6/nMz1T/z
    K5fl+nQ8wAGlokXfnZNAEYHs8pTvC7/zCdXD/UqEwBQ3nydKkv/AFzW3udblz7/rnv8p4LCl
    wAKaLrL4SvJADQ692Zc9CUAMl+Sj+eb8QALaUZ6eBb0/42TlGqCk+sAKeIScs6XvwBAtSVoA
    B4NAISD6bk/jT7/8tbGhnAu8wAI8CB+D2ppABTCWQOL3cT/0UNS/mqd8wAP75Ou1gYRAB/VM
    c/To8MAJGalBsHq4v+lnvvzkzag/3tB6M4IDI8AIl99N1uWqv9ABwcCkJdE//rlCca88gL/2
    3qGoqt8dP+t9vhA/0iw/kN5Q1GhOjUAOx2zwiI42P99qv5qGP1m/0ra1nyn9Dr/6HJnXAs+i
    P+G0LDo3UO4/494LZ8Z8usACklvZbVmQwBD9EaE6YsS/8cHXxAYrAD/W/XbuRrupP/BQcGnP
    zii/0ntZS5zPhD/4I4C/WCo0QBACC5YG+gW/0+HNmmfEuD/+vdOpKivvwBMSINutBZPAAKfW
    4I9rqz/mk1GqKTHDQAEvt8+tmZy//YmrUf9a4j/WAdV2QCAMwAZI0zHWujLAAairPnfrpz/T
    n7XzmN9XQARZS+RadgK/6o+ovFNgz7/1QjgyHyCcQA0Zht25INNABsMrxiQJOkAOjKhMlB6n
    P+tRAwYhUcu/8CtXdBCpVr/uWWeIhae/QBBkeIw2wU0//4VfDF+oir/zwMi+8nkyv+bGF7aR
    MqC/3c/EeBQE/sAB+BHYu5lmP968IvbWh6lANdbhakeKYkBF0f4ieBcFQENFlzyyxmxAR/cX
    lgVkaEBOt0Ru84FZQEBytukqT7vAFoGgStySIMAizfdeVoABwFAuMXs+el/APfIA1uAHrUA6
    36K9DDNzQEPMfPfHLkjAUMPcUIkr3MBWMlTgYEpKQD+wHosFSonAOfR9j+GZtsBAO72zeI4f
    wBXlBKbVDzpAQl+pRkDv78BAQ+11o1xDwD2WALc2V8rAHq0gW6cLhUBEaQoxnBeVQEONYXVc
    BCFARvJzD4CZQkAzNT86tva+QDet+jMUzcjAVlOSSmJzdb/Gc4ltIJkaQEUFImGCrkjARez0
    +Kw69MBByckpW/dDwEJCa1izqPFAH4fXYfvW38BFrQ1ISaw/QD0HhzS2+cxAUfv8ME1ACUAk
    ErA+OEzowC3aqbPZRWA/7v8m5cBOWkA3hSf7c/vwwBpAGlNU7bhALPQPn/ydxcBGOB/bfIVw
    QBpW4WVmNpBAIONhWX1it0Aw3IZ32Pb2wBhYvaX3WWrAP0QcjsrGFsA+ZIfRHPC+QAoA/NYX
    YGq/0IAEfHBe88ADIuDCrtN8QBd83QDmAUXAHi8fNFC9R8AR60IXSFP6QCes5Zhg9FFALnpE
    +Isa7sAHFp5uYjLvQAPCNSNUrePAGJRzspqTBUAA0156p2M1v+53Bcp/Jqi/2Ajr5SAf37/0
    PBrGI9DTv/MFzyLBtNzAFteBVuNyXEAb+Qy3LRQYQCHAcyhq/THAA1k6Dj/iQcAfSkQ86wEG
    wCHTOCfyJu5AGVTqXksmisAO/MP6ktJmwAph/Jr6K0VAGjEJb/BttsAUP5cm+uB/QAVMPmcM
    Gf/AFPKx+Tlz1EAfoVMk5eABQASzzEJvCjLAE9wAaqm3B8AoUwB3BcgHwC0RmRrEGflAGHJM
    xA6Awz/3VUKxw2DtQA+zd9BxK0s/6762lrb7OMAb9V66GvrKQCHOXb8KSSzABAXvZcjF10Ag
    KQddIPu8wBoRUq8vcVtAJ4Q9OB8khL+wja5//d2AQBVXtgrwoyJAFWArfpxBTcAU5n++7ImI
    wBOmqI389BrAGzfZMti4B0ARgyRSctklQAXFTbe4InvADcu3HFlqBD/yV0lfWrD4v/VkYqSj
    qmO/81Jmgjv+DUATnKWuvqLnv9nR7MJ4ehI/+AOVNEfMVb/kWu0SzKnOwAzwhS2Qyig/xONJ
    +2KY2cAGUvebaniPP/ydRYVgK+E//f9P/XOYfUAGPyaUkHdJwAw21Q6ucde/87lVx7G4A7/z
    pUsErEg1v/y3IZ8MYk/AAd176ZgytT/wOA+Gfz4Iv7hyeum8vcI/+61wAV6QVkAQ/2ajZBnf
    P/b99KjXDWw/11/pcJxlcr/xfpXt0Dk8v7zgwcaezL7AB3Ouq2rJLr/sFk50grqdP9q/Xlkf
    g27AA9sDGoIxlsACUdREKhAYP9qAn5aGBx+/07oQawEZD7/7VfQ2i9QdP/DZ5mFXYC9AADMK
    T0G/s7/kyDLT+D63wAF4WyfjQUG/7N6s7pOqkb//WTBxhOkNP+asTyfqnkQ//Oj3tNASsz/x
    0CqUvHucP+WaR5QPufNAASAneWCy5T/7jTzwzSMqv+mvMCO1NpXAOb4oth+4JMBLy8+kttdH
    wEQLi+YG+EXAT0hPLtIOi8BU29OwJuadwFAwms2YDEpAAeXYlbRtE8AGbe9XQ0F1QFvMzqRq
    HOxARQKpivk0pcBHYb9hDm/rwFHCO2CqpfhAVTTP+/kHM0BaVuBwXv5WwET2KYXMbERAQcNw
    zFsQYUBHR6T2keHYQDwF5Y6+nMXATGchrN/iJkA/hRXsuqlGQERb9S3ICE+//D0srZ9+ZsBG
    FOv3Li/NwEz9p2BJUazASh8l/vziycA8gV0eVJglwD//1ytPli9AXftZ+NrNFMAxSfQ90Mkx
    wFExfmo/KtNARKrhkmhkeEBBd55GTnTcQFGSbuq5P5LABbKzEYhC2EBHhzk4iLOZwEcCJYGd
    E33AWXW//DEPWcA6r2ThIubEQDl85m3yj8hALkJWhYq52cA6SHZlzaLUQD8Xit4ifZW/82xu
    v7qEjkBRgdC3eazFQCb5RzD2rcPAM5dq7SjjosBHbgfJeL7pQC2EqQHeR2RARXhq6JjNEkBS
    Pu/lezlsQCdwd2Ycbzu/4l6I9j2IVUAlnha7tS82wCfPqrkbGxHAH3SzIIZgzEAmGeiXv4CY
    wAFtQVp+gM7AG9CtBbqi2r+lqKA4pFqdwCE65u0V+7xAGDw4A9Ky48AeK1o9cFADwCLWHssM
    yTFAAR8MZWeC5sANCZO+UYCYQCFwTp70pxhANxnS8o5B68AO5qeqFKEawCLWD9g0G9pAC3va
    9aw9s0AtBOcukjLBQB+Db5h+a6NACQjj5gR3wEAM7fPXrUMBv/QEoCDVfLvAJC4KJoULJkAT
    6BzAad7swAUm6AWCUAA/90VcvALkakAb+WGLKjQGv/y+oCIGmA+/9nU3vNmKwkAXXALRywWX
    QCNcgjsNvu3AECnUuSOH/MASUOsLP/EowBMFV+1svc1AAO6He5NntUAZvN1/pTKAwB7RBStU
    GQxAGe6KQQxppT/17CEcvOPVwCW3C/qI0W7ALOt0L/fdLsATMzkltankP+WCAJEwpo7AGAGs
    ZYcOmcApuoG/l7/XwCk+GHJAwqRAM68/Iyj5AsALjjxsThgXv9gigUoQhoq/+YLeTNZsFD//
    d92pY9psP/OrH1QW2DNAAAubtClYXD/5rrFG3EfwP/1obfibgsY/8KhiQoqGjsAAa9Ds7ewg
    v+Uqc34Di97AAkU2y8Abmj/fg+KlqWLAP/UoCsWyp5k/+toBEGjZ/D/1MipZoZyyv//V1trw
    BLK/5pkfW9bCE7/4N/FpU8k4QBycnM97BXq/6WhXEWmFmL/5cR7Lz1gxP9O44pyS9fTAA5Wa
    H/vflb/dE0M4zoQgQA86m6uQXpk/u7poXKbTgcANaZL4n4MUv/FPMdk42WzACkG4MolYPsAD
    gbDpyLuYP8Hq95QmW2y/4Ei1mVVH7T/oINbTJBvVP+vXaoFdAunAAKdiX2ruLT/ge3T1C1BB
    P+m/CwEWkV+/5ZoO0eteqkAENelbWXtkP9Hk25t1cXxACtQLNLHfTkAECLodAm88v/BS0pJ9
    wUG/9UsOxbqMpL/moaXjjZoGv/Atl+QyO9m/9jO/BcdjPb/PZfe+kS4qP/ofQMTN7/BAR1ea
    UxZBzEBSfkcXLyq4QEsOJ+fIAZRAVRycSjy080Bf8Eml+uoSQFRcvWHmUezACLH5yR+J18AY
    J8WKrBmqwGIttcB7spjAVtFVAViR3EBJEAgijHJjQFTNycWkZgLAX4qUPMJ7vMBjClMQbPek
    QFGChM7uMDrATWIfTUPMRMBRlOTBu7AjwDt+MNmlOo9AV9tqHAwFOcBQSzpWM5hSwEc/QvlH
    uNy/+UTd6U5oSkBVy+8O2/yJQFRw+iZT9bRAVpeKg66gBUA2xC8JLIqdQEb4JBwjG8/AZ2oO
    hA1vf0AcpHev9+xdQFMPwZcgbKTAUREqneV0csBSCK3nYTIIwFnblDvKfARAMrZvR/6Q3sBQ
    Li2gfVb1QFB59spkh2FAYvvBPmZA7kBBKv2Q8qlewCX+2lZ6Fl7AMq/3A2nw80BFjSxW5U7x
    wDYy4aIShIlAFAmJl3I7H8BZed8FhiO1wDFbdWJ/lSVAQABWHpqgKEBR2ZqjVm+cwBuDM/4X
    3pDASgdzatXGLMBUOUIbxfdqwBLdiynlw0O/8ADitoTBQcAWxTptMzWav/kX1JUNys7AFoYR
    FciDY0Ae73yFiJDGP+ZutS+SQiBAC7pjlGZoysAog56i8DG0wBfzqk+9aVS/2Ui5AV42ikAL
    TajqxV28wBIZeUR146S/4ljyMQCZvkAZOd0xjZyrwBqIAD6PWkQ/7hWGuvLEpEAgEiz2cZNY
    QBvAwKy8Dwc/8VTd4lDkfL/+I4vzBGtYQAnWFoHDdwk/9uH/Smnb38AOU7PIRc47v+w7H0gM
    jmpAEahWL0iaykASLE4DRIR9QAml9xk4THpAFm0Oiw2/3MAQMH/TevHEQAX+gvcLKOHAAIRG
    wN+fkcALtItQ/juewAbCzmE5Q3JAF2RYfLyjhb/eTRJSL15wQAMDZMkhKXA/t8+vzlgj6cAk
    i4Dn4IeYQAQ+cPHaok/AGy7WjRt4NEAWbSvil4LJP9l7NpFVPwhAABtBkpf2K0ATeepTC4IA
    wBWdm3Dr0Ay/8rbQL9GC4kAGmSaefy6CQCBrqe1cBvHAGfsOxm3r97/8n7AA3Pkov7gaIXvm
    ugW/9+PMkInIr0AD+B3soDM+wAOaB5etlcm/6jsB3uO4Aj/3z+rlB6dcQAvN1HgBuZK/68K/
    Uui277/VtGCrf7EVv+KmWgyIoqY/1cN0+a9bSsAIglsr4MLhv9BKEQuqpXa/86lmt+sFML/j
    XlZjCFi5wAIP/g88tLM//x9ZL7u/JL/T2qg6d8SJP+XzWx9lGlA//lFqXt6S97/9sLbej5jE
    wAAa8+XPGvS//SZRzUJfIsAUASKLxofHwAG8CyWoVCq/6+R2/Dw+tj/jTaZYIrBlP/Gujqp9
    AIQ/8qdeQ6ukVr/1nzN2fv5bP+ZhKIbq56+/qFA6XCGKAb/0dppj2ihZP/y3YSLyxlJAChRH
    S7HIdEAMNnzH2dDlP+uG6MgG3pJAA8VmBe+v+T/mXIzwRdOpv/YTBv09uqq/0++fRsY1AD/8
    cCBcsZ3CP+Mr26eqJm4/5rjIfPaJ4b/Z9Sil5cpwQBEY5FwY0KI/8zD52MLECkABgnyrXK/W
    wBIyr5ASysTAKkY8ETRN5cA8yk7xDmoSwDO3WiOdtCjANszK3bdMusBEe+T51qr7wB5ZbveF
    aD1AImEnUvO4QEAjAsjlLboGQD7G2otT5blANESwsYXUp8Ao1tFPAOjJwDX6wb3uhCZAPsQ8
    BgsdQ0BHkLYwmpN3wDape+l4MDpAGfI1P4O/SEAkgZUO47RBQAu/ezD5qpPAKsvPOzmookA3
    H0/dHEi1QB7dpIjs4/hAJP/0d2p3wMA1kuJ40QBAwCaLtjvQNSPANrslTYcKA8ArKtcw0lIi
    wB2JpaMIXe9ARhODJaVw9cAU3VauVYPRwCwqM8ddTqVAQY1zKPhVDEA76G8z9LsCQDRUXaEa
    VftAAWP3HMtZuUA5orVBkYvdwDPYI0EhM3nAROCDC7bfisAkILsAnGc5QCIvUz9fm3DAHEF/
    yzVE5MAbqbjFSMcpQCUUagsPkjrAN4vLXwewB0A01ZJR923TwByGfY1WZve/+IJXtr8E5sAR
    9jZKk53hwBPmBUK80slAKx5Xa4jcrkAgNWFdjmEFQAy23j2/4tc/+MLILrj4skAXjaKvoVKp
    wCjpBUslfXDACOb6xpCX2EAisFAPSqqFwB8y7Ec7cs7AJ24Ad9amYj/pP2EZA9ILwADeDKVK
    PlBAKH5ljpie5cAchBronoypQAH35eFv2VS/8e0pPK6peEAE7j7ASeU3QBkVCaQsXs1ALqE8
    VsWi2cAhhwqpALpzwB+KRqwf9ANAETvtQUh7EEApDcQk1v4cQCiYogMJcSnAIjv0ewxktUAC
    IpgpaTViQAm1N7FVxmrAKOhHbfrcwD/7X4zXNtYtwADaaQETm9dAAAplNHl4Bz/6GRiXchDQ
    P+ISWUaUcURABhecpMTnOEAgrPS6zbX/QC3azCS4qGHAGqdfKSpYRsAYeB2khQ72wArF1McJ
    lg+/5aMRGkY20UAXeR8i+GThwCsEB3oPrb0//woduVmjUL/2OBTbQ/6MQAJ/fx0kdvTAKa89
    LwvvL7/4+wh7OthOwAfDzLVCmKHAIT5b2d19mj/Wtwf8Uo4/wALlulbI8DVAIeMvi+t2y0AB
    5eBXUw2ev/f/48ArAH2//o5HlY6FGz/+UU6jTny0v+QqbXWcO3k//ZXvEnqRlT/zQKx91kxE
    v/qp/F8uBkY/0hVggrkZyUANtgR4O2dnQA52rh+FNA1AAbCOv8U2P7+cmi4PudqywBNYoTom
    x/y/vv/lLvxeMT/iJjCQi6p3wAN89YQSGczADaMm9nv2NMAAhzkRgqEUP/M3QmWOn7pAAW3L
    lvYZez/8gabqsIwdP+UQpW3Sscc/3wKUqg8WZj/s1sTq2Nd+P+4GniGq9ALAAahGHPER6j/w
    gd0+2AFSP/hRaQEu/Jy/1M2JGpkQzb+w686ZRiTIQAVYAR8Hrl2/z5aY0/cttsAHShlxTRxW
    wAMvWZv3GRq/7PB5dHZTKT/gtS9HLrk3wAUmnlortAu/6QQIxdj3xj/ejtiB8W//P+0J1kwS
    XQO/zdOhg7HMWkAG80EG1i0/P9B0IWStzEC/4+/BaFxP4D/iMYNxw8ROP/ZEzS8ST8DAEHlq
    Q1e/P7/WnGDCI4M/v/aadIhOmGTAAJx/RKBMe8AjoQb9jQGIwBU+6842ZAvABBsWNtUmJMAl
    0JwK518dwADA2orjKnlAA8q+4uc7XUAoBa4r86WnQCEEbFWyw8ZAJ085aBaWAsASXvkLhE7s
    wCKu9P0xLhlAAxBjUr2o+kAuxDyu3d+jwCSdEoqg0StAEXnXJNH4isAUGlnElexNv9nMVDCh
    rczAFSS8OBUtMcAEX0wsBoXCwBdME2e57BNAGoEbqu3Zkr/8EvGXdpWKP/KkukvOKsjAFSqD
    7qPvpsAU2kIb0VQQwAM3SCdpZSdACQpzrk1yQ8AAdec2LccHQARrQKL21MJAJTDhhkl1hkAj
    HJDrO3RBQCAESbUPf2lAINIIsD1iWkAS3AkgUKkBwBRnq5gMjm/AEzHT30fp4r/+Xft/IHtD
    v+jHgH680SXAFXGki0fOqEAL3NeYaOx8QCLOqP/64wjAKQ8L5sJNQ8AJqZp4v7Z2wAaY4FFR
    khBADIDQ6+HZS0ARhj8FHc/wwAODq9nSOao/+PYKNZbossAB4pMcc0jfQCOgtVi2wyvAJvB9
    ALwvq0AW2te8lcz2wAB8TO3bS0A/18Q3lrhHH0A09sWuLb5OP/T01OPyb3i/9h4aYA0gZ8AD
    YZhJEqaewCPk9487QsHAHj4EPc0LjL/zYPjaHlw9wCBTcuyiXy1ACF1QNeZP8z/8J7tq66eo
    wCIqIamwBlhAG2zj1uEL3kAEYx+lXhWnwAURmn/lQenAAt7KcgSTlUALI/8nyIVoQC2s8W6b
    R5C/+hIshgn+lUAU/GNvL9QHwAtai74lPg7AMNwsQWMqM0AcH2bAgiDXv/qD+PGhrt1AFXug
    csXQScATkxF4LbVkwBf1InRjNWLAFtDfRkYXJ0AnAdWeKdyOQCWy1T032hVAJOEuMVptSsAT
    Lag94VhaQBfeKU+dFCvAIhBJFRCN8D/475OVOJuAwADN8uNi+F5AEGUq9ZJmeEANbLQDRtVi
    wA2OR1zOKqPAKmmS50rVBcAM7Q1No4/ywCGiezUPnRM/2hngZN1AJj/7k6QHNxbpQByBQPEg
    KM2//oaiAbd3CD/n0t5mAwPwwBLve6PYcnS/8kmNFEhiyr/My29qVJ1Vv/BwubMshsI/5qra
    w3LJEj/6S4eM0d0LP/APaYvGIJg/8qvEV2jODL/7K1tUz+Bhv+nMM1S4XRK/xxQxVkecAb/T
    eRA9SP+XwABiLlTL3Go/lFY20BINLEAGqPX/pLtZv/cW07f5UKc//hFwAssFSz/pea6IpGSk
    wARKsRMxteNABlbnpmmiuL/xHW3FqeLAv+2FuVFK7etAA4xTFQ5wasADgWQ5uoNev+YuZ7Oq
    jAW/9xZkWNgcN7/4XFV91FMFP+ID2zTUXJY/yKbqzl8u3kAGfurpCcV6v/XpBh7fAkA/7oO8
    /sjT0D/LmaaGPGPJP8rhLY7XTs+/5pd1MY9/icAUOr7y53IUP+XaNj0OLqQ/8nni0ipqj7+3
    zF+bUgFCv7d5Fp/E1lK/yHZS1R7LqkAUG4kP1ooRP6ZNHUB2xhk/unedOIeX6sABSwFE9oYr
    v90UURanOQ0/+w9JxLoW2j+hFkiP+cBsQBKVPxMXrM1AOOTymtjIW0BMdU6zX55vQEVlJGnP
    NSJASg+mVBCxIEBVHjZY8yyRQEfjQEdhytg/5DGnnaI44MAwiym+zHygwFmUcUNH2ePARvPR
    TSUTOEA/4M2AuXNrQE6vZxP/au/AUqi7DacIw8BZNr95svZ2QESiuePmvo/APVOBSl0fMcA/
    rq0mhrySwCbjIZ1AA+xARvhACLpdGcA+Fy9y26R5wDc01jMvoyC/4YB3y0uLiEBEl1rzTC9/
    QEZwFtKokLlASK2FAb3Kp0A/y/5OEt/LQDjABfUoJrrAWnogP1bXRUAgE3IbqHLQQEcI5Lpy
    9pzASgM2ztCf3sBHz2F1vWT1wEsyijNaW21AAPj1CxbAAsBH56AJ8zmNQEIuDpvkn05AVuIA
    Y3/pX0Avl8CKGcOKwDD+8RA9ER3AFC9qzhx0mUAzmMegBXeMwDNxRqnJ9HdAKYariJKnlsBJ
    Crb3SD8VQBmNXECFvcFAMZCvoe1anEA9sG/rgrV/wCa7T5pdIH3AQ+URNMxuxcBJc5a7YVeK
    wB58ffVeqYk/9zskQm/GIMAjuQNcZuW1QCGQGtKRkBDAAScQDEmsiMAjC74HqC7OP/5tXwch
    Za1AIzTPPU589cAkqlGgSxe4P+IjefeKDOC/4ervZx1hwEAW3T84RWL3wAkKgqzJJV7ABvro
    xjouDkAQSas/kThhwA5C1RJIu+HAI5KH0q9C8kAhl0wARFyjQCb0hpEeD1+/+i63s/TQ1MAj
    d2nuG08nwAdSdEcPXKM/8b5+L9iJscAYXipNubebv/pCZVXi5GhAJ1XcmlOJG7/+XoNqdLK5
    QBy7ZzE2OTpAIbhrq7SassAYdEdZu4hwv91E0enr+TBAEfkLrqco2sAivhOjQk6kwCyISrRq
    kdtAHqwFBXBj30AShlqcy9btP+3u5Z+aFrFAFTIppFSAJcAjWwsDDsf9QB7lBKqsUjXAI1IH
    QMCm20AF2BHMy2bwv96Qgyg/zB1AKJG3lVtUpUAYUmg0mtshwCErDxyRhQo//OHVtUK6jUAb
    fsQ0dFjiQCH43nquhhfAIR4w83yx+D/z32C+UhI4P/lXn8q1FzDAABOOS05K+7/LehAzHrz5
    QARv+iuIa+e/9vn0zkJwgcAHIzerCH7Sv+jVyDC3CvC/1wDXTrMLGj/Z6gLLo23kwALj9VkO
    oHY/8nOKF6JHY0AAyF2wmvLlwABgfraf6dg/8bZ/rUjapj/uFIw0O4uSv+mr3QhZ4P+/1qgH
    Yy9v3r/zhoROneUIv/VmnJ2uq2O//6mdf6+ZwD+7cWYBPf7Tv/T1P1YllrG/1L3RAD7Q87+Y
    MDuMx1I/v/Q+vj7cnqi/5DtZYyme9z/Ucwj89LQSwBJoXS8fQRs/ygAlFVCEXL/hyN5Vgvph
    wAXHqSoV4Gq/8AX8yeF34z/4eUr6gtYRwAKc7Xqpps0/6IxmMxjlAkARQO/PfzpuQAAgwuz6
    uJI/8OweQdwF+L/VpGqc3c4uP/JUv1lnwwc/4hDmV5t3TEAUxbRAHdAPQAit/2LYFXtAAiFh
    S15pbr/juecDBhX9wAAiifvMH/O/8+F1wQIUdUAFCPyNP549P98T7Zsp2PZANvRSt67amkBH
    oVlAEmQsQECFm9/2sdJATAeoMz9njkBVK/wgJpGSQEa5P+8hgT3AJcTEijQYEMArzF+kVwvv
    wFjFXpD/XCDATmFpYqMLQkA0qAB/CGvLQEooHvnWUDfAUu3ke1xULsBZdZjnxVmGQEWRnhN+
    blzAP017eXvx0sBAz5xuP1+4wCl14OiFsAdASeYZWCym9cBChwVNfKVowDwgWLGsiCrABQiG
    DE+ny0BMbAADwiZeQEZ7VSfh2vNASpw4onix80A4dPltLVRdQDdY16LcthfAWhP+ocWl9UAR
    KFs/JVmVQEXvk+y/LXHAT36jkb+/qMBIgHVKB/j7wEyMelhaBodAGqtKUfPmrMBCiz+/Py0R
    QEgUQx/FMF9AVgcGqZgJeUAwhs9KDKuMwBqgvuOeF9HAEfYjt2xmd0A2TCoyPWEiwCqxedfN
    67JANCFStUE5pcBNLy5FI/EZv/wC7AVaEmpANx7hxyZlB0BDCl0gMphEwAh+cs4+4mHAP7aD
    kXhHLcBA9SiqKoMaP/IAa4rvcm/AIv/4a+lppr/0k9VMPMl8P/0h2fg26V9ALRbmVpJ68j/h
    1rpMBwKBQATx4TNfOwjAB5+aDw8zakAnmLIdu2XcQCGF0/Oi7MfAHMfXks4fwkAXF5vFMK/C
    QCOPXb8nSUQ/6tHEEL3pJ7/rANqOMM4EwBrPl4FTtpbAIyIrKNYMbsAX6WSe53VawCM5fIhO
    xfTAEsZwahvqTsAHlVBYO83sP+d1DLTuAYfADy5ezW5dM0AFb8XmpTs6wBudLWKsTYrAFx0k
    VuZ8yD/BnMTjBC+3v+e1bXyco8K/+TZiaGjCcT/mV+4sfIrJwBS/DyaXHvzAEZigpSWh0UAt
    WNpr18dJQB6Afjx0GRO/9jsTsxwDi7/H1twpxRMXQBA1qqACkY/AKS8iG7mAi0ApVDiJXBI1
    QAnsYoHnh65AJR+40y0BB8ASzObSBwwYQAXGR5RkJOu/+WWznrK1XMAiThle0jzZv/XTWAyE
    nqZAIzqQ8OFSOEAQxmWVZh1iv+JM8gpk1VPAI9FFjGlPFMAFOt3/yg9qv+gr8yQeTvG/9zgH
    lswwtD/zMf57V71IwAFHncEYnxy/wHOZQIm7eMATAXrYH4YyQAh7xOURcPc/8/B1SI5DVr/l
    ur+O2DkUv8PZmCj5zmc/+9NMMUprjT/KWxozsuW9v/UUS5BgBFlACX1x/4iRPD/2cJGqcczX
    v+KrdHhSdyc/wMFpQYtV1T/3UbzExeXzv8POj94aZog/27R9K+xxAL/nehEGYzctwA2eSLAW
    6iU/5Yx5QFSNJ0AFDS3OpjUtP+YUysoDACdAAC3DSCLcbsAAXRqKvG+5P76lndM1zwNABKys
    b/lzP0AAvn5ltN7VQAQ0SxCPgWC/1r00XUDIWz/eBPq+fqfSv+6v/hKP+Rm/0V62XiD5K8AB
    lVSPk42JQAEOcPw89UK/ttHIuxWE6j/9GaeSGiD6v/K5EoK7c7G/9VMwgMTqvb//p1TpxZBv
    P81r6FsG5Ew/9dlddGmmBD/9z34honDWv/EOVMLiJJ/ACpB8vnqduz/lCm4ZmtoXv/7NF1sj
    o2NAJ5Lor9jquEAwxdhb0rosQCus8ASZFG1ANipqnHMhv0A64use9IYVQEBG7VP+tUNAB8ik
    KrmlMEARy0qHBJh9wEQJA8D3RQ7AGreMl251KEAxk+lcSOU5QDYjiKD9uy7AQ/k+Vg5GBMBE
    STXsw2RaQB68PGJfBGbANbqK1ppCNsA+E7mhEpttwBCPNkruVcNAOxDVWDUygsAxFdnLUDrM
    wDSEG7vFtNRAEIz+2fOg/EA7OTWvBPdvQD5uW+tBB5dAOCqr6cThwkAlJ6rwqipvQDQGdMYG
    hXnATC1Kb/TIisAMtQDH9P0wQEEvd2sWlQe/8rRSG1ijD8Ao2V2QZcJNwEDZJ57cDARAGyNM
    I6e8CsAxRFalk/CvQC4xxy3vuqpAQjnG4rqFkUAHIV0SdvX9v90ZVSFX9sXAKcFUJU0dokA4
    kbYFKP0ZQAMpN/XjYyjAKJpAYIs34sA/u3tZKGwgwBbaWRy/IhRAMN/7/DngG0Aw0dVzsSdB
    wCkReCo8XSrAM7R+ctvHf8BDCXEaK5tmwCOl1jP8EypADBJSa/uOKMAipj9QmQ4nQBIBO/23
    Ka9AHvpbQZb3YMAmyXSi1o+2wAR7aHuSoDG/50fZ6iqaAz/0pGOonmwTQCFv8Y5PfGtABB8k
    be6E9UAONPJnGQDIQB/mfUzX03y/8KaxHeaP5D/6/yXjN0TwwAF3xdPYiYvAJZThhddN5z+7
    PRmEpAKcv8A2O6I1O+K/2nKr+f2mQcAWZU/7TLU4wBeJJuPAeYK/9xVw5uFlu8AJ9WycRc2k
    P4rMnUDZhCxAH1dHyjEzb8AGbVHeGhx+QAaRGn1Iz7s/2qJ0C2xMEcAFrhWnXlknv5RKTsZS
    2dU//+ONf7LSP7+4IebSF30mwARqg8ZF3wfAFBdDbDp0ikABGracGPG0v9KXLIfSz9m/4JqG
    hkJEEUAEqmTCzlEhQBCCLatRkO6//T1wCKi0nsASL3CdnIPuQBqGFoOwe/BAI9tRxXyiFD/X
    LVF0+FxvP7phUNRH5MBABs/HpRiNBkAdn4yBp6SfQAy5YwzBgx/AI10RtKGjAb/ZIxuqDyWo
    P/Rb7bC9+EW/90JWAm2ghD/zE2LswXGMv/45iICTv0o/wu1r0k35aj/45yk0YPnsv+ifBkxp
    kA4/98uhcGomWb/rc9ovpVcxv9aa4blnMX0/5CwMC808Sr/yHA0+4yJkP+loQ/Vc5V6/5LI7
    x8yF9b/gsjCs61ZFQAGNUkGf/wlAAQXo3TUplD+0+dEzwih3v9xtvuO6IW3ACUk/VAqPJj/3
    RhM/SesJv/4Nm5ljoN4/6PaDK0eww8AE65ndZSQnv/TT/a+SqNY/8SUz73MHnEAA1mZQM8ZL
    P/8Zgq1CQrW/3tcq2ETwcL/zuPKRwaNhP9Jd6sgZ7Rq/7N0G+3zF1b/TN9+2Qd+sv/jukXcq
    gWW/yVgL7Bp/7j/RmGeFm5xYP8a5wLu3ouC/yBGGicsGc7/8BzGJZ35Bv40YQlahEYY/9CdK
    ARaCer/gPRrJZA6uP8rUaSBQY6a/8p0GZWL9ID/1VgyFah1WP/Z2Ko83zqE/wflytycIeEAD
    EB6fhTKEv+MCxqMoOdrAPWtJILBclcBBmt0q4JiRwEJ0aWRtXIDARuxR4Yyp7sBOtDNcmjCb
    wEaRLVC7+VNADCgphOoFoUAa2GA28PwEQFGUWYmozmVAOuwJQbO/f8A/b4+Dx0eqwEJd0hjN
    EoVAUw4v++U55kBSz/T3Gre0wDtQgsxy7m5AP1v3TIEYBEBC0Vu9t2ANQCJnZFDKbW3ARKJq
    qYQh+EBBfEDd7tHYQD/s/VvBu5hAFEM/1+96ssBHrFzRFdwAwEQeGcNwDNHARyviQxEPXMAz
    DRvmpORZwDotdzwzjcZAWDl74FeFk8AaS3464QoAwEd6wS5gziNAQAyYkELRqUBARdnV+8TN
    QEQADPXKV8vAJHph17dvKUBD5wc8fyvCwDnNExeX32fAUcWCmO4fC8Aurec86wdqQCHEtb8F
    fKpAHLrKxqQX9cA8qF4etYWvv8rOh/45xKrAACt6Nt332EBKr3KXscVwQBLMaXkrOrrAIz5z
    4yrCmcA4ZKVF6beXQAe5Zh9LMTlARWPKlR0wcUBEM665CD3KP/0ke4I1Qc3AEWTIFWGmV0AL
    rv9LshZTwBFddMJLaw5AA7VI8t0AY0AcsQNTxBQwwBC6+ljtCr3AIEPjBoSybb/9azpTRvfk
    wBrJsFaFzFpAFGoCbsUbSsAAe88a3LdlwAS4JPlUmNpAA83+uM2IkD/Ck2w0n8Dbv9TZsu49
    RvI/5AKIV45wb7/MULZVf36yQA3AgU1GP3g/0s925hb1zEAJPEBWrJupQB4Rq0xMjqPAGYff
    CIMDID/05fyUMXQMP/sXS+MfXxDAIiy9KsE/qEAQ//jRJrfzwBCRQXmniKRADKr/dwLHlsAd
    ZfOdVjumv/GuqBzKARI/+JKpq3OupEASfSzMRtCZQBxfX/HMgvdADTm1CmKgfj/XvYodEIOn
    QALKlpz0j+4//ZHC63zlasAB31jJBD4swBoJWxHP8ou/0pHvBnt0PL/59NuaEClJQBI3oRc6
    TuzAJGrI3zHdc0AC0jj+3yQYwBZsKwwHSCPADecJrAojlj/y1z4MrKtNQBXw56WzIzZAIl6o
    UZnJfr/6yUYwIqNTP+llmuQgN90/+Zj/ZdyEfr/1YT5rnn0uv/MRM8ePqHy/9C7e3elUrD/h
    Q8TQWqjhP9vQK1iuf3e/0LY6vRzGhz/biYjn901JP7ztO0vPOCu/7MLZzoNF+7/yLUNVCsch
    v/Jb7jq2YoxABEFfGm9y+b/3SXCe7xDJP/SPY+C6tbS/0D2oMD5aaD/GNA/nvIuqP+poJT8m
    s8W/+CKpye5A27+BqXxPSxKfP9df+lb8Sfa/4v14xgR5iT/gG6I0pAHyv/D+Z85pra4/xLcU
    NOqbzb/ntaQh3P/qP+Q2YYkE3yq/0URgCMaggsADsS7kOWGMv+IWbHNrXiI/3tshinyxyD/q
    +Dc62wqCP/yMIgSBx6nAANS/hTQqib/Z5yw2GHJ7P+j31nSF+Ao//rWK+KsHpD/1NpEzsbN6
    v/FeBLHVuIO/x0V9gGzyRj+lWc1ikbjxQAMNltUSBQs/+t7pcDvNcL/1XP1qjmjkwABM0Eyw
    J0A/t00nsL19vEAC/QYENWTXP+xM/uYrXO3AKh8xyxGfzsA7LWpPs/gTwDFY157thDbAOH/j
    cuNl7cBGYTHxsrxdwD24Z9H7/6O/6f4pNaLcXUAYyONpRXK7QEqQSx9jSxFANUL+d3pPBMAy
    gFT1ZmfMwD460iYErpZARs/U+5WerEBJlxYuWaamwDbLF87qVSFAMYp/sEsxtkA3Zcy1phgJ
    QCVJ60hY18fAPgjKDU71IUAxhfnC31cWQCjXzd5OpK2/8b7cYU3LZsA5b9E+wwHhwEAmF3PX
    UMrAOVaTETM5D8Ah3arFXXrTwDFuR/AZAmJATi7tc97OfsAcHb19l3KswDr+V5GL0ehAMcSP
    MqKtakA1xk4dTFZ5QEGincvfp8nABFejgdJbhUA2Io3j1hzcwDbqwzq0zVbASvToUC/1QsAd
    7XMnCtagQCgQKr6ps4NAGr6lDO0PC8AsTfjA9OT9QCCHGo0dLou/OS+hQmgpjkBBc9ZkhEIb
    v9kINiS28sPAJUsUU9azKMA5pht0uwyXQCGLxAxf7RpANWgD9K8p3UBAc0HNXnOaQBHwhCoC
    LGvADegxPeoRcr/Pps949S8XQBCWKl0Dp8W/8aUrtgtWp7/iQnimGiFFQCAb+zivQB9AHHTV
    w1GOCD/v+CPr9AJIQB0YWKufug3AF9871gQSiT/BBoIWjCElQAnaVNz32My/12LHJh1LoT/g
    hkxZwdCzwAq1i/C4s2g/5O1FIUFaZD/0uaXtXf3rv9EgJYqA76y/8x0+i99Bx8AQb0tFYQX8
    wAe8lRLjqtJAEtXvDeshZsAGW1HH01s0wBTvf+9SgiE/s7GcQvHq78AQ/LPtfuGpQAT++hFO
    cHLAGJSdOEX/OkActXAMdUzrv4hKsQ3M3jjADCOq9YgBXL/jZFhMRZfKwAl0utJE4Nc/9Obg
    uKcxGL/5nW1RGfE3QADYijxmsBrAGS/iVXT73z/GkAJ6cjs2QBaWE+ww+sQ/8OEKMEul6kAL
    xzKs5QMpwAo3zHj5q6lAFEtg3z6+rcAQPI6GIlVRQBPk4mOmbI1AFVxZbCdCLr/1iPEbRvM7
    wBQ1Kl3BqRbAJM2khFMtT7/yOj5UvrKNP/HY/dEkswa/7fSK+MgGGL+WY3brg51hv8FdoYur
    K1o/58SqF3ltBj/sXgqrqldzv+S5R6gHlE8/0JdP4xM4Lj/iPQTe/4lov7mhbTJAPt8/xz8B
    rymq37/e5B1uXCpNP+RpkwloU70/8r53Bwwa+j+rYbGpXioQv+HLVu2vRS6/+9p5aU2v/b/B
    Rc5o6b4yP7nsub/SMzg/4LMJ4cfbQz/85acltpc+v9FRql+VV2q/sawdf1//hUAEbgM7N498
    QARdszJILiK/82N42P1c3r/pApv6ygr7v7bhjRCkk0pAAgGqnvm/B7/4QdVtdP47v4GwwJ4K
    8bjAACTTvsL3rb/lo0yqA63Dv/N9HMR0qyS/xWs7Y4htwb/4D4DTpdyCv9iJHLFG7HI/5C/C
    8ba2pr/l/e6M72l0v+nl2NNTDMA/9u98gL2i6b/p+ebOvsCKP9QMpufXdZY/4VsKhKBVBD/5
    OXkzX/4pP+t7j/TUNRnAAxsd/gEPzT/QqESKQxrAv+BBPqEPTGBAJErIZtAbhEAo1aWMIPeZ
    QCExbfn0ODBAL8uBZ/mK5UA2aPkjb0lbQDP2Gth2dx2/25rDm9+uyD/Bgn4IlkyswDskCDmz
    mMfALJBan7VrhEAcC1mHstn3QCXamR2RigHAPk0cMogXxsA9sKcm5cKfQBxHmJJZKMvAJ+3m
    H0RBv8AwBH4OBLtZP/O2d04L2u1ANFYfKlK7dsAyYgxb+9akwCSYSnjW9+A/0tk/FRVrk0A4
    lMUqCJ7bQDCHDjb71U9AMhoUfs018EAEBhAPdvu1QCU/R3q497fARJxe9AUbrj/gZxtRSi78
    QDE+ljN6OjHAJcDnO2Q2msAt9XLIp8iqwDOQD09Kl4BAHs3iR68f9sAmWFjbrDWqQCayfOiF
    h4pAPLof+ybrqEAPaIAnkkJvQAHoj4Fm16TAFGP4g1iBPkArU1OgMCqMQAkdHbEHWPi/9wyM
    CjhTtMA2jG8WpkYZwAe9JHHbaiZAJdEvgWxLRUAkLmePfBdywAMJnkF3wjXAJO2yJ0ouvMAx
    DdZUoyHrv57XQ9mRXqHAA0kv4TthQcADgkKeEj+zv7qQy3FZcNY/58w6Tfhrzj/qzNMS6Bcx
    QBDgMBwSxEhABUgW/txOcj/0F60W97C7P/EULIGQ7GXADluymJFi3kAW3Tl9nHFuv7ODEA4x
    MkS/nqVhCMWh27+xNmtfMndOwAddpuh9uvnABI290T3lrj/44piXo77nv9JyJh/8zMy/7hWw
    2qFw58AC2eiKGgdRwANDZzyco9RAB0vMh1gweT/Tn6xlsrrKwAuBZFa/fYZAD7fbSoPgIL/z
    bV5mwbZyQAKE/Udf1Mg/34CnfeNJC0AFvxXXo5Mev+YwLtH8h0jAC/LLddsHT0AD0Yp81Zqc
    wAzqxe+rmq+/sxzDU+b4mD/p/35rVl5RP+uNC5/fQgjAC98983yjoT/Xzo7pAzEiQBQTy2G0
    Xa4/++adybt5pz/6KJgDXFuqwA6LoBgd4yJAAqwzuwgeh8AE0x9wA+DAv/J1/dH/fzpAGNcd
    Hzn7scAJFlbNzJGywADp5QtKZhzAB6elf+EWnT+SKgRAJg6qP/AibfHW684/rsl8AimHXj/g
    JH5kY+1hP+Uu9eHx2HW/7fkdLmfctz/5iMMFQcinv6cy35AbiRC/xaF32ZOYYr/c0P7Ge/DS
    P+AaXt43RWs/wW6cBAyoLz/2M2QvWnMXwAOfZRTqsVK/6nG1mQXaOr/8T7pHZhR3P/cvEpRF
    072/3KsWy3CIAL/v0PYbzOdRP8pXiU1jTZE/6Gxt+6dWeT/sK1/mGk57P+K7PB8Ft1W//KiY
    4IfrIT/ngPtcVnBov+sYz9yBz1I/5n3eplthRT/roqVpBSvRv/xKbUDZiku/5a1Oh3yMHr/A
    LRVcHBMmv/B/peUDfG2/5zlAuMRIKUABCIOwHEuVP+DrUu3v1gS/rDWmSSsQKb/N5aY5dr/4
    v8XR532U/2jAA98KKdjUgT//Zb2ppklBv/Qtty/jsUw/8JTqqWd39j+x6WtM3ysbv/YQhM0P
    ciM/tjU/YSRhDT/3ZQbEgDp9P/WQBrGlTWC/mTFMg1+O+z/bsAElFwa7v9y/5R9pBvZADLgi
    uolAf0AfnfhO567lQBESvbVakJNAJEMbSdO5MEAiKrrs0NmWQCw93IKgEf0/7pgxsjWGd0Ak
    D+XIvp3OwDPnxGg8YjfAHra2m94zvUAWgBypP4pwQCXog2DMBZLAIkP+nUq1PcAsn2u0uwMP
    QBdDe1NzNQHAGOq6/YJO6sAplBnI12YpwBXgMUege8xAKKHOqgy8NsAYqAYQPU7IwBh0PLv9
    NWFACaLazZRLX0AgRMpvZ5FGQB6gxSfKDHFAI633zjdcJkADvjUTV234QAmsNpOg+KrANAG3
    a2bw/b/tAd69Y10oQCl266/iBnfAByr1kL2/Zb/fDiRb/2LpwDAJtAZD8hpADpP2GmzalcAO
    CAHmvIwxQCFJcBdH87xAMLNyAd8cYUAdBLJgwTi8wBn3KpOlrRLAHorcbCbwqEAP1Gx9ktNy
    wByrpo/HRm3AHa1JBIsnlcAria2Z+o54wCNGNU6+grNAIGOpyy3YjEAtD2zEBdsjwAdIcz6Z
    qy6//mqbjLDobsAwWvT4Ljb8v+euMWi0pc5AEfor/pmlHL/nMzjFv9jZv/gGKfrCyunABV2m
    kTE6FMATGeZXNTkzv/QyJdC23iU/7Qmn58F6/T/IirDrdOOEv+gsDk6/J8xAAEdBiJyVED/c
    b2dFsCv3wAQnnN3h6dC/7cpHFeEYp7/336Qu2/KXQA16pImTrTQ/8UzWqgz9Br/72RDNzy2u
    v6BNJ6WXR9A/9LvaeFkWCT/0vNp6G3PswA3bFO4LBaJACzZNs8SoxT/12KRHmTSFP+UX3KRx
    Ur9AGcJQfMsiAL/saps+I3RtP/uTAoa+MVI/8GMEGeLgSkAHD7WcSI0+P+9pSYs6jjFAB4vl
    BaS/xsAMm8SKjJ+EwBS88omPnmvAByLiT4m5Mz/1TmgV7kG0wA13rqP/kjZADIokInPVBb/3
    4w3xVhllP77lYfnLd/m/4B07ePWyoz/UP/K8vzQSwA0SSjr8EQ9AA3pfHK038T/nq1CgaYGL
    P98HCjQu9eQ/33gmopWRn8AOyrG7wMmowBIj2FNJx/dAGxszWpTewsAUXnmORiIWwCkxISW4
    tmJAJpzEQ07I8EA3XYW1uMVgQAvkGF+krehAEh32LSo61cAEWlAA1mPuQBCACWoqIB9AFkIm
    5eYu4cAwC7SrsXATv/XsJO8Gyg1AIIFBw6+DKkAzdQXds8WUwBjdhf6VnBJAKa0AphTsGMAB
    /qQ4OW2SQCnUXG53xCTAMZNyCDaZAUA9EvYWvQmZQAKaC/TnhGjAKJ8f/W9P30A1NcM4x6tg
    QAQ9RqTsfAXAM2izhbzVuEArt4WbprK6wDMqWdn20d9AI7jWBSswkMAz5x0EiL0tQCFfuI19
    ZsvAGl68IB0/HkAyVmxS9hmkwDLFOEho+1jAMHRJR0pjGMAHXHq/46QpwAo3MFTYK6Y/4hkQ
    ElEP1kAKSA7Zmpq9P65ViAuSQ8e/9ePQoosxVsAWXtGndhcrQBcALAuFTv8/9KelufvCYMAC
    az8SLSjAwCa2JalidSbAEPtn+BJQzEAxn9ays020wD3IneD7ugNAMIEDt0rwBMAbMKBv70dw
    wCm6aHyf/wBAES4d9mUWML/7elWCoJB2QBjfBJcD7qPAHKFdDsOdKUA2ciXobzk1wDE2/0yD
    Le0/9se/WqT8y0A01GcoP06fQAyhl2bJX3dAOhH/qHJN4kAEw/JZOyi/QCRrb0Kn4x1AI89u
    Zf3xs0AiRLsyR4mewCKtHxWIqyxAEr2qfsWJl8AcgR5PKNFfwCV6eMPrYhvAO8+XRqapqsAi
    YgRyrW5OQDKRYvrAG01AI1MK1ijB50AbXNyMpUFDP9RjxczTBPm/+M1nF2IWAMAml/0AM79f
    wCqju3/53++/568qP/pMsEAPNdmJALRqwBPwSQWSalvACwqHjw8Es8AUlMND3l+lQB0EmISE
    pkXAIzkgKcFiN8AHb+8K+R7gP+6pW+YwYSTALz41WU86v0AnopFZ9dONQDQDobeZeXzANfsD
    OrHEosAKjoYXJFxSwAV68rZWKfFACk+2x7Xyo0Ak4qJT0LMSwCQMyAVOiUtAC3xWv5ICtsAe
    7xu4Wsi7wBgmOd83abPAA/JM6AqsEcAS+irrXYYUQAV+uPJfJQo/+CuDvwReyT/5rGrsLiZq
    QAbb6+MRjZS/u7LJHqSHecACah0Wq8dBP8wULmtRYWc/45VOg4OtrcAEPyQkotslwA8Z0ylL
    ZAQ/9h0yYPEy9cATwgwuXDH/v+95v4p66tlAB6rrtgolP8ATC1Jv02ryv+L4BOlWckFADnVX
    WF6xykAOaNIRiGjewAYOycHfs9fABEHxhoprF7/2g43CkXFhP/6Ak2UYSLE/+4tlI+qi77/3
    lfamZNl+v5NXBGREG+G/yf11Nl/Aq7+t/jUStdF9wAAaaNbBp4rAHz38FpL8bT+xJZcK72Yo
    wAKzIQ7xoVNAE8aub+A/4MAGm6zcUGIYP+wk0ncWTmdABOsnPSPHTj/xaGaqijxUP9BuReqT
    FtJACNuwMMh/38APwCQ7ixyhQBPVox16d+q/+Bpg3+icGcAC8YHpurEwQAWmSzc6D3+/8XKE
    Y0jrOT/76g4PY1j2v9spVcaUpOY/vgEunZZpIT/xzOtV1BTTQBIErhnDGlO/0RzdQHCpVcAg
    gGo+c48rv8qgIa5akbo//+wQd5RfUkAGmvgvWNsvv/oiUgORyYvABnxw6AW1yb/1GTxWhWcT
    wANYb0IwWPpADI5FRphUh8AZVFP/e81Qv/15ZUa07L4/zRa282sbA0ARfrsgLzDGQBHUta1c
    vaVAFmOigTHvbcAHIkfpZb0+wAN8gGIvkLZAFyKBIFaCLb/y2Ye8hm9HwBGpCQgdJKTAGZLn
    h0hdlkAk+mQTH/R+QAyMTRNrVYbAFSHYJoC6bUABGNNV/pA5wBDRpBPqRpY/22VyJkrWCD//
    Ef/NxHwnwBI35Nnx7/DACVqI5crSdUAJJHLpbP28wAmu8nL9pv7ABIAa6gepDUANzBt5hwiw
    QBUqOW7TK+A/7/Em8iyZ00AUffc84jWiP//DYxvoogU/9sxYwL03TMAU5Ov8gUFCQAOCFFc2
    JVDAEBy7osW+icAYWURMPGW6v//PTFZm21tAJU8QMFx+MsAJupK90SFdwAAglaEBINtAGGJ3
    LKJn9kARWR8MR1YFwBPBXFZzeG9AEWUIk8lgAsARC3k+zV2vQByj3O4ABCs//aXaokLowUAi
    WHgkYqZ8wCOEp7uqPaNADB7DArTfrkAUvRmfP+gyv+aPFUQxXBhAFn3yIzPoNT/RZc2FxF4M
    wCAz8+Xft/y/76UIV2GkecACR93bPS2FwBZ8Hk4KjnU/8U2pVP2/ccAHJYgF4AKcv/n3TTOt
    WIzAFamMYytnVUALHwxzmIcQQAa+ORQJgj5ACCAWjfMsykAYZIVZNaqmP/Lqu1u2v5Q/2pYT
    coklysAM3Ojgju+LwB72EInGLldACtmXmy3up7/esv04KQToP+srNUj37XnADRIWGTqoXsAE
    wpVFwMrEQBs1kKvfh3xAEF8p876X07/oBK0btMyGQAl1Kx0vF5u/15jInuIchUAQNXQ9ucCp
    QBpunY78Xb/AL4vTID0i0b//6PdF0m4RQA1YRK+LxqXAIziu0LJOm0Akw/Gj8nD+P/ReACS6
    GqLAEm684IcUKUAUpQzrKvY0v/MkGJVWVyPAFc9MjDdLm8AUeQhIaD22v7y2/mojzbzACHyn
    ls0pjcAHLfUKjszZv9O8/M+b7i1AFgzeqg4jVD/s/KoSpaXiwAP3Kjc/WH+/9cnmdpUDtL/8
    AqKgluTLQAN8ACzFghs/8F4g094AU7+75ouiIW24P/lXoEpiHNW//xycPlv5ssANeNa341eG
    wAL1QPUa5+lACVWOmtIUw7/5pUS0jahsv9jNaI6iDh2/9zPDg9UL1D/laG51IeXlv/cvrPhR
    h3W/2Fyl9M6HwsARf5GZSoeQP+dRK2CshZ7AAxOJDX8k2cASC1lKWgjwP/f4jyLrWCY/49Qq
    dLFK6kAHmfH3Hs8tQASuh8bA8Lk/8FhwRIeC0kASFLTlyIKGQBbuZQ8QP1q/5URsFYU0ob/7
    tRLzm4hjQAHxmBnf9enAECeHy4oVGsAC69v2IkuqQA3FDtRyhga/77SEGLn1cr/ouTjb3jwk
    QAhWOUsfEslACbtHXXA8Sb/kBQphebeRP+M1zHPlmlJAFfJjtZOw+j/Wmc9aqlWvwAVNNR+j
    fSjACQkiTe62Y8ALZ7uABz7uQC15ryY/zsPAMw1eMFdS+8AazJ6T7CrjwCimwgKC7mLAFamG
    OmkxjEAi3h/oh5TGwDAm05GDvpM/umB9dKvF1kAksRFCfugpQAh5fPKcNCXAIKwHzqrsRsAe
    J63TAxuOQB/fTG7Al1zAFBdBS1s/D0ALVd9snMLtv+ss2dL2Kk5AMO+4zmDZl8A7sriLNZVa
    wBiycOTq1SpAE7MwWBRnP8AY2jw0vWWqQB7pfiFdDTRACSaWbeH738AZwJwG9n7PQDCR8MJS
    6MTAFj0mCv0YcEA1CDscqcYtwB2WjJBgb9dAIuDDQKF44cAdN+9Yca1JQB9WjrGEdM9AKwDE
    nxfjAcAbqtyng+WXv8Bh3Vj8OqnACoQ1wdVrDkAgMNwYy7tfP/0/q5GBXDTAA5EQaB7RnT/6
    Qsd000KtP/Xrk842zcu/+EYnyPn0CMAa2RyUjCriQBmKjNGCLa1AGotof4ZgFMA2KvZ1TdDf
    QDS7dEkTQ03ANkTl57E6r0Aixme9v3U8QCWlEceKExDAD+fIc1RMgL/ga0S1BWcWQBW11zGV
    Ry5AGj7N/wyqJEAOpApFr4UwwCQBFpDiothAFOyfPuQS0EAobIcclO2FQBdn69KFUuk//b4l
    tnRoLT/mmKj9fuKhwBl892orNbTADeJyrhMQq8AR1GiHmE33wBA/3lK21nJAARFEM27XxMAQ
    D30F7FS9v/h7hk8Z1U5AAFwAnPMoxcARDiNKEbzdwBfN10uo/Yo/h0HJpyoWjT/8luWZ/WIZ
    wBEi2uaGXzXAE2Cj5sm5BL/D5XZfmPfdwB0qEe8hgmdAIChSzTZoKL/WLDN6eoW6QBAwArIq
    DWJAAESBxwCQwT/5vr8AvutuQBxmdrRBssg/qMhOfZ7R/EAK+Pt2k0EqQA2KxfbgulLACgVX
    BYXYkj/56ZFe3ilrQCeMnl1HAHm/6Ll7xQPXf8Alu8850zeBwBG2TIEec1RADBhbwt2LtD/g
    Jien2j6PwAW1biOmyJ2/7WKGVdX0gsAAVfv3qveHwAKt73xs/hnABsroNwlZiD/uMHI0musO
    P/TmAcMmE3NACR8ZBkYfScAJkzZEkOUMv/Lfx22FdCRABW3T8Cn2DcAQPPVhPXUuwBB6AyBk
    tqk/2RJUfkI9O0AF538Rnoy4P8dSarMYFfg//sB/ZThhf8AB6HNczksZP/M/HneZAc0/rISi
    ZpiIY8APkkVfW0+hQBJDC7QUQwg/6Y0P+3JvncACketKiWkOv/2rKIMFFtG/ynN0tIc0Xj/0
    8RmQYPOUP+MeZ6oc9DY/8oHvPav67b//LJ5jIyIsP/i/35DgPHBAAVoiM28FcL/RWPp67xDq
    P9Kv/P4D8bs/psAgCHk8DT/+Z0D6WuqpP8xGG0Tz2J8/7VTBHQhJI7/6jdz21nYqv+wmmxbz
    +tHAArZHWKfSFUARJaHrgjQCQAdz2D5+wQK/8FKBGpvCkD/9VxyOz3JvwAFc1C1sjVg/8jE5
    79eEX8ALmqqPavIGv9Tbcvd2V35AAlgtDMBQv8AHvG0tke9LQBUlauAffIHAE3SvKMpEqsAR
    zK7dRGI1v/krmaVkB9RAEI0Qq2Gl6j/eBKwBqHoNQBoCAniQL6DAHlHUGPw7rcAOk+k8RfZD
    wBg90nOAe0pAKOelM05K00AKgs7mIvfcwB9w28sFo5G//yguI8ucUMAYH9M3JZyqP/mWyoFq
    kJa/8Syw/lCtQsADlaw6VwiRQCgzOZ4QjuxAFDyaTZlgLMAMtq2C67uTv+cQHqC+xjU/mop0
    o+rPWMAMsxF9i5qgwB7bxy6NMIzAGvH+UVpxVsANdE1qtRBSwBRz8hVBSAdAMRhjGy7tKEAa
    Z21GIHDAwBXUM2bGg/dAGY77O6Rn2T/hPJo9lLxIwCh8jT1aGArADcA9rM9/r0AXTCe3XDOr
    wAxD4TEWbSpAISQ+2E876z/neE8m0qZbwCAZCHRWeZtAHtWKXLXaPUADPb9blTNJP8ecPb1R
    wwW/6Mn/7ddskL+Zfrvd0jlyQBzMysTtqzjAIbho3LVRTsAJNgOvP8JQQBHpIcwNcexAG81H
    A9Z25MAKP+5m8SncQBFkqt1JQkxADYf8AQUEWsAYH2To8KjAv/JozTaa3iy/+mxK3fSXu0AQ
    VhqtTw15QCHU9sBBvndAHX0N8WgDX0AtlD92ojuxwDDUnR0SNMnABPssld7Wn0Az6v4IgrXZ
    QB9hf4bIW7NAJCri4rlMMr/zjUeGxvcsQBypIW4XwNo/564NgGoYjj/4PJSvFfCwwBJjr8rY
    5bvABHsP+XAgsMAYZFWy9ceYwAWDjw5FHCPAMxW6JmKzWb+z3jAz2ndQQCK2Z3nGIJa/6xYU
    fF8c9UAgQGOeooTpQAjQjawb5/Q/9beCqoqXfsATSClAZ3HJwB1CQOdZqjfAIW0YvzpTbMAd
    LhSmzb7WQCALw5khkBTAGogvS58p/kAGCXFQp2iuQCEd9MdrI/3AJN80IODq4UALWafM2gi/
    QCBUOwuKXxFAHzKuN8BtTEAg74RyHFzwQCkSGyfm28LAMVTW56VoX8AFEDiYCJw/wA2FJyvX
    MnlACscrHL/7gEAKE8T8uzXswCg6uTxLWJvAJfslnoXZZsAGJwaEn/s9wBBz4RbQhHPAIinU
    9SqXacAR7mm9q+PNwBF62hrQ3OpACAFfR9MpaL/td+JNuEKvQAMuErhT5hE/+GCapCNuEsAN
    7FIuMefnv/mLb7slNzzAAbbeouYjIkAGkXbEtHhZP+GRE8wzW6k/1zedES0itkAA0UseyPpM
    wAj2U0gmgzi//7eAPSDJDb/+HV5Re+pHP/jpt/aCb7HAEy7qYITowz/03JcZAWa1QAHAtm7G
    lNZABZ/KSJtG2UAAeMU2a6CXwAJWEjTeKm0/6owhLGqhi0AISufvlmj3QASiZ3p79YFABzpF
    iP+HIsAK1BMRiniMv+Zr3gb3tyS/5+Wo/on1Nr/17syTAr8+wAIKcUn5iPA/8DL2rBpL7z/3
    WEUyVDiVv/CpQgNovoO/9LwAUFXBej/Igd+IR9wlwBDpNWu7Whc/o4MRsse6+T/4NCHc5emX
    QAtC6krtovFAAkEV/DX+IMAVtvDabNf7P+IHr2fVHfw//1CeT5QWTb/sFq5ThZcJv+R98cBs
    KyA//4OeopCXPUAL5g5nFFGKQAkb2faRnSHAEHR3umNAab/11cVjC14kwAUA94I5Z1hAEYvt
    0nREa0AoMz67Mc+xwBtTmbDSL6JAEmuSHM1y6cAGSrqGeWlTP/aa7eiKS8BAFAJ+DkJqQsAe
    PxXF0p5MwAkPWbPPp0pAAK4jAcIye0AZejJ2tgqpP/kuC1vrSs5AINDOJUiMkb/PjQiQd6Sj
    QBbjDtOXiLfAI9XUAu5950AqKlH987i7v/zMd47t3ULAB9UajLtF0EAkpOwTgzaUv6bpjDno
    J8LAGnrvdvQ7PUAg5wU4eCWwwCX6I8IL28JAITe8tIqft8AmOv7nkwJIP9UrievAiwq//FGj
    VJaDeUAhFoUKVmOswCh+TP5EBcDAIVnFni/1YUAPL/yVDk0JwAKT2Nn9gNNAAwHZPFqwncAI
    ivomNpa0QB2jWzCkvco//JxZn2DIjcAUv72ztKh/QBbp4SZb6+s/sv+ks2fxF7/7yHtjqGtu
    wBhVP62CIhG/zcMJYZqKQ0AbkZOp+MVIwCyKFJ6if3xAJys/mxUk6sAmv7+yWSzYwBcae+uJ
    /enAASRvarelPUAhx4Q+USIzwB12LvK7V43AGcj6Zjm/p0AiCZp/HieMP8djDJcCdjvAJH4h
    +fyji0ALxI8w4OQewBC90cvesmVAAbN6OsKrtz//NK2gv/kiwBkY1LkO7cNAGLmb4FEp9kAR
    wbr/1vXKQCNhUb69Py/AJXwKsYHDSr/grgGSjAPWP+pvcWeezcTAMRMbK7Kfyz/kZLECsWUU
    QB1ly+ZAEla/6aTjBkHY1UAfr1/e6ookP/pFi2hn8mLAIGQPuLFRFsANQ19vI2PMwBXmBdAs
    TkBAHiCHNXF5O0ARy1l+76kbwBT0J5mxeY9AJxM27xgWjr/pOVT92UL9wCGPS32ipbU/9G0e
    Rq/3qD/zO6G6EKEewBDUDxeQYIzAEzr+68SGLsAmveILHjKoQCl1MtvkdYDAMzLjvyFgHsAh
    G9dKZHJnQCBUuHZAf85AKUkrQTl3vkAxr5DqvtLvQB6OslRndPpAD0C9XvumNr/37Jxq0FPT
    wBmKyGHM1oFAJzLx10mDVMAlpUfutGswPxKDPPnU/nw//CbfIm8LkMAQLKfXRzpPv/gIJIyd
    EVPABjEB6Sz83D+ywc9TkkGNP/BU/c+aRDc/5fxovsi4r7/8XC1Qfj76QA9wg2eyX+c/9yak
    gtjz/MAMxNvjm4a6QAe7x6INy1E/9WMvgcE8Ej/4JIAwMIz1v+B2Qly4PqpAAoUzHcoUWD/6
    YrR3pbK6wBV8RPF7d+1ABsXDsiRVFj/Ut7tM3TGtv+rSGlvDZBU/+xLsGjCzij/J9V0Ee0Mi
    QAY/gBulCTg/9rZpu5ylD7/m6ViTU1AoP8hVqhvMhR2/wSuRU9gihb/51qP6aokWv8NcDpDX
    Gzu/4refoZf4T7/3HjKevk7pQAffjTIS3sLAFDMDTRq5Z7/9ZnTQmuJcwAnUfjQdlcjAD+po
    IFKzxD/wR8UjhvNzwA7IVgaRuyu/3oQ8UtVner/U3nZsVjqPQANxdu3Wcwo/9glErQsdFkAP
    JaUZ1ewkwAJOiMCFHIK//X+mdxlCaUAT2jmRTQH2P/8pyXXXEFc/8u3ekkXltEACkX23qMvT
    QBQhZ2Cf6XfAHmEnwOL2cMAAi3X+yv8av/nRXAfsWj7AD7VJplSbXEALgx9xdEC9wBKZTabp
    iLM//JDuL1k1CEAMhZSbKTQoP/M2W8Qq//XABHpun4HARcARLe022+xnQAP6JvxvDK0//HNB
    HKBq5UAUckj0F17bQAIc6tZH9kNAEZKJoDAr+8Ai7BBw12+5v5XXR1xLkaVACvcxCyW6TcAD
    H3S8vPS5QBZMKEhV9eS/9J4pBceSGMAA+DTsnjP6QBF9L61C7Ka/t0ME/jrkT0Af4BFBELxS
    wAvbJchxYopADmX7BIU/psAWMkSXw991QAC54BnVESxAAGnQBZ5wLUALmo/Yjnn7wBBkk5XO
    eDHADGKz5nYajUAEERD5xpFuQAhfQmBaBbO/+EGvTbm9Zz/y5jUeL08qv81zeF2XK3k//J8t
    juzd48AK7TewNdh+P+nrNegOZsC//jUh639/o8AZPubLLDvUQBbYovjFG/TAInY1ug5IVcAG
    FhBSIbeDQAfhKz9/tjbAMXw+xnQpbkAfI6/02xI6wDzz3XAnClBAI31MgEuw2cArF6Z7cLnb
    QCmArxPwQyu/xl7yfdpzZcAeu7puKyEYQBT6b0PekI/ANRyJr4JCb8Agxu3QMz5kwDPhMpZQ
    zQtAAnKw2KAaLsAsAKM8jOlFQDgiL17qRgbAM3Y10uMuYkAjU8KtEL3FQCv45q2VSrpALKEm
    3GHgQ0Ag8ng7Klj+wC1Qisev+ubANtZhUJjHCEAnITEWu1tOv92X2iz121PANF6JKxbj3UAX
    s7GAvs6yQCHZKXH4cmxABJw8qBG3rsALI+q8ANxMQAoh7TqqVshAOCainD68NEAS5wMTdDql
    wC29TsL8qpxAIAyv88Gf8UAwzhiNADkywBpHqHaFr85AJ3Fju+oS58A25V+nlB6LwAxU+iQ/
    8cy/9fPYHiLQPsAYj8Q/LAzPP/Eg1qEf+AtAM5UgfOnB1kAf5n1rkTjjQDKlO48nyrtAC2Ny
    pJ9PuD/pqZQZuYJ2QA2NwVRpIl9AHORoxetKpL/mwPyCaJ7OQA2PSal7gmbABMX8ybaOJz/8
    IznzYFfsP8wOEP/gbtW/8aFbY8+sBL//gjdzTT0/P8sVAeiQfde//yH6QFfX+UAEjOVD6o84
    QAIu7W4wfyU/8xCqQ3B7C0AFrv+y0Y6iv+XM0LWqadA/8WwVVFosuL/15cPIW4sYwBaq3wl4
    iLY/6lYT78a05EAPxNk2MJopwA9bc+9hdv8/+iMoVRRhPz/qmt0zfJc7QAkBoMa5FBc/+uPA
    1wkahj/0EvSujdgwwASNqbbN3pXADMZyIqTSlcAA2DeNMSekP/MhU7eQLxA/6CP9J6GUUT/A
    8d9vNAV0v8V/jeRnhme/UyZ2cbqsgUADZcafQ7a6wBA921eRrfS/4K5Ap2yqfkAVH3fHanFF
    v/TsjZg+p3A/2ARm7NSACsAKBrPbOyKwwBF60dfQQm1AA77s92XCJcAAnereUO6Uv/ov+ajQ
    LBJADHUHXmem9z/RlmzfjNrkP7f1TFXSAJU/8izys92Pzr/EOYEQBefSv+UU1EE09i2/794i
    LM5mtUAPAuwmb6NoQAzprVewEwnABCsiqJIUC7+92tZEYBk6wB/t+Yzqe+dAI3W9m9Ca+7+z
    0OufW0jjwBhTkT6iYgk//Pp8xireS8AOtuimYgJpwBSeRCdhVxA/5xtI2e0Pmb//IwgN9V4R
    QCGhBEuMyIBAFETHaiL3/z/gbbht4tBYP/NKB1ndb+TAGE9WieXGG0AZzQHZlSs6wB28bx0A
    mpXAHaEc9fyCD0AGVaUwH4+6wBMTtPMbB+xAFyImGIssBEAel/4X05GkwCNUMwvQtEJAIKIj
    RCtbU8AG+wuH+T8MwCRUXa+vQOi/xqY/DuHsTEATnXOyavB3wBWC2TLpRu8/9fvVN6ItiUAo
    KMUW8SvZwB9Yn++RqzNAK6H2Chk4GMAFYjJFnvuMQCdvGCkjPS2/5k6D4b089MARARXEyatu
    QCGQrwdQjDHAGW1hV/2K2sAVP1FiiEsjQAwys4hwHKk/+7XrGH6wP0AWkaJbGrN9wAi6gOm6
    e3BAE6U1ptNIxcAvbTSiDZBswBzvpyApnaDAIHdii/0WVUATCzr6Lclov/FNW0oRpODANciK
    VbFMMMA5ufuwI6mwQCww+VP1WSXACr4X9NPVX8A9IzAh8PX2v/nP7UEc3FjANfE26DgIxT/8
    i/GzYX0qQBJWeGr5SAJABHQL3kpIvMAZEW23Cpu8QC/MZE/2blFADqq4oc5q9kAv/IkmsK7m
    QBWNCODQcdBAOpXCYJzIyEAo1VgK/20qwC0SATh0yt5AEaEePMCD/MAwsHyPF6C7wBitBQNQ
    nCNAF7pPMc/gX0AnUWbyjoUmQDMvpWipmX5ABq0fPayP8j+KpvDiAumDwAZ+JAGLoBLACkln
    1yodU8ADXZOkLqGvwAfbm03POORAAg3PIQQnVUASnbyG9XxnwBIRUv+RztzAJGkJBtpcXcAO
    RI8x2Uc/wDd+EA3kKytARG1a1s7X10Ao5MAclSygwCFcSs72lTPACCa6H6b80sAxPoqTQPbr
    QBpnM6iAX5BAKcQJCN5iLcAixLTdcezPv/pWWAeIiVo/5drt68wYJ0Axr2xKoFrSv/7FHdvy
    MYO/6zzehHhbRkACvgQ7X2yoP/+awCCn87Q//+lgEWMg3L+8V+XZi7VzP9RIKclUUQxAAPe+
    RlomTUAfBHmC5XF5P/Mw9ncMCDC/8Mw5EUVDjD/7p9nsextMQBDmbezzlNRAC3MROCCMYr/y
    MHtnIkGWwATXAvTFKDe/9guJEBhD9z/j/ZwuRgL9v/LPR6K7ZR3ACyRt154rNj/RXGREPUFO
    wAKwMfxepJw/8lzNxR6GOr/DGWreLiSwQAnzi/EkpgrAEhrXn0o1Pz//1Uyzs2rSP/NtEqtH
    oq7ACAiy7RylFsAHbd4C+Me2v+Sd/axXVTS/9W1ctIt5IMAANqcWoWYzP+dNRL91+gG//6G+
    K3iFij/nCMjUTbHnv/pxGQNsk/nABSY7O4Z7rEABjE3EUvFaP+Kxv2SMhB6/0vRo9ZH/Qj/p
    Hxnfh4eQQA1Dh7aeJSTAEiWBX/TKr7/35hS6BhahP8whGBqR3zw/8ys9MVRlCcACGv9ykJ8k
    v9eNic5TFYk/wiEw+6+Ru0AQWnQiXPBVQBgl88DZGrTAEoh14ZjsGj/tmtM2Pg4uwBfPOsaW
    CxFADUynaCNIWEAMN0v377itwBPhw2Xf4aM/5bT/Nwu/jcACyskJxfmywAUNG5FeW4K//QUT
    sK/lpcAEb93tZHFJQBDexi688CI/+iZONoJWUz/2Stlem0yFv+1dfCc6W7e/7uq6Gr9lvD/M
    i+eQ/qOsv/H2VvOjrz9AEin0WAv+xMAJwBX9gdoUwADXV/RVdUNAEaFtKnn8pkAXbzKy4jTU
    v/LSlB/3voBAEN6+caNmpL/zZLxD8QjMwBfpLTtXYio/wZkrEBBhvj/2IMw+nvdcwBRum9wu
    zRY//4q4Dr7kET/8HflJDvEZv/iu77wVTbJAA1bdGHAcxr/wronbgHMDQAWv5wSa1IE/6lqW
    b8/TQj+mgng5SB/LQAY4ilexPXC/0rNhKhvL5L/XF3wTF6vtP+TeynD3SO8/0jY3oP2vKkAK
    vm9lwrYav+Lw509HvNvAEhsCJy9KJsAiIB+NkzEGP9qTtIk4xEjAFia1m8qvgEAfOVWQatlR
    wC/YwrepNYZAMZQEfm0NEEAy1e1EDg/1wCCHozfcXyvAFB00eOrq5UBAHBTWV/Y9QACI2lm0
    HspAOBGvKfLSjsAo7SqBVB6CwBeLbNKcYKhAFvGP8+je5kAQelV4nDoewB3x3545HJbAILux
    iTXTY8Av5QF0203+v/iyVX/QBtjAP0UjbvCE3sAqMlFZEme7QDCqdh4lDuPAMDeEIV1HaUA4
    mBoan7p3QCXeW9ZADcjANfp6/14EK8AmGYZUxXyqwDU4+yvtfGNADFGJRKoixcADOVaDzzl/
    QB/kgxehC7VALeVp4oMsYz/5SVlNbATVwCgMQo3YhMZAAZitwlUZsEATjgL/Gj2Cv/+wfBjT
    cE5AMU1CzIothsAapSE+raVZQDRPRZCeF7XARux3xRQtFsA1FW+kYp89QCUmeBAv1IZAOJyt
    17pBUkBBqnvfL6EJP6E8/DpqFmHAL3IO60CRpUAI54DtSqq4QAUruqbSRaRAJX1VYVDv6cAx
    ap9Amr82P+I2M6K29YvABMlQP1NTukAMpLdD+JKmP8SWsh+rIMrAA3ti5AU977/woFo6k9+K
    v/NBR/+FtMs/tB07xKIdJD/Xp93mjdsav+udPCB9r/zAA2Fu6qFsKz/8D7ElBroKv9ktOiW2
    idbABx4t0UIWAb/6rkV+utwBv/zCvTz1FepABo/IDvCuGUAHLZ1s/Tk9QAksPbM0w+g/+z2h
    TEdhsr/FHkVKrllNv/0GbQFCIGE/9JeCmsLxDsAWVTlxYRvfP/2CbrCfFH1AHD0oBfffpkAE
    lOrnsYigQAYCyAjAg3o/+lwgM5Imo7/4nY/4uFCJv7q1ed+t2P2/0JJ5Wg2QbsAUNCeFBJ+H
    P+DIE5uLp+i/0AtKdvIuoUAIKx4/iGIjv+Ck3+D408DABPOVe9D51L/EVQEAb1BKP9oRb/Lc
    L9a/9t8InF/aYr/2JFCMvjpWv+JRSsOwDps/7P8IpbMbpj/9pw5Q/jDkv/ey8t53nmM//sUG
    AAead7/gCWv0LGwuwAKJXaY1gtI/xz5gahxvMcADbJGqSUV2QCLRlV80xdvAIsuLD/9VwcAp
    IznnrCAUwCPKlJ+qOtpABIAaTAY9mr9FdbDryj81wCa92PK6tNU/zg1yX9ZTIT/5B4SkgNWI
    QAZzwVwE1Ne/8pPFvd7tjMACbTyHuW5/QCpuWBCIH4y/0Uni2ue4McAYtrutpLA1wCMqKWZQ
    4i1AJ/2vbiGuLcA0Aj3D0AVmwClpu3HX+wvAHU2nhGrm+L/5dCaZ8df1P9fya17SIxxALD5t
    qmx6fsAXLNDGeu+lQBHVxTJ/9JK/2QlVnj28OUAuhIwQktrMwCvzGpFjXGBAA/5DdEtkzcAI
    NRVn/2ZWQB0rn+hOWMVALHPhIma25D/3jPZWJkq1wAXyBqlKvedAFa9RTx0YVkAKJo7MZ2kK
    QAZnMVOT6mLACMVTIYO64r/mG7QhVNLmQBH4GWULzLHAIJcMu03vXsAZG5mK6MDfQByzgCJD
    MU5AKgZ5FqiNYMAwqc/qHN03QDCj2FAsCYfAA7Tc6vFyQ0AjtPrbojQ3QBgwNl1NpH3ALCIo
    0pdWX0AcJ0Gra6OHwCvm0VlvkdFAG4nmexCh6MAouPWt/nKjQCTG/WNMrPXAFMcGb0IXCsAh
    NgwJby05QCSU9fwcTGXAMnqK0imvr8ARrS7OX2XXwCMD7Ed5fivAImgofaA/5MAsBmD6lYQX
    QCcwaU+/URfAIuFRuZmYHkAb0rXjqqOmQCiN9fKxVSRAL1bn7P7w6UAk2uuOWuOqwDGx7Zi4
    ZsfAJU3hg7l4ukAHf+jNg+52v+uii8BQLyjAIGyPpBNku0ARYOPzj14PQBsWIrhvd71AF3Wu
    vqsN/8AeKRHLHA9eQCOTvPBW5opAHr5f0+aQ70ASAdclbFdLwBYmVbceKE5AIOQG8Un4IkAf
    stI26pvDP+q/O5kZKJFAMLoH3T37P8Ahudzh+A1twCYot0Du6spAKHyrqmmNs7/yAy7NOal4
    wBUWx1j8X25AEs/vu7by9L/u4u0p/qPMQCKMMxzEa7m/+giY0vaFF7/1Q9lLn2wCQAT2pD5R
    yO0/4JmY0dDVJkAKTZ/s7XPfwAD+XW5V9pLAEl3Mgp4O2b+MkNXx+Q5sP+/O68YAkSFAEFsu
    oMDArj/+PjBNDB9rP/Hct0D5CtS/+/fSuKxnQD/7lw0w+4k5v+MybG0Rnd4/8iu38r/DqcAN
    dRAxlvWrv8weVcB0hGg/32uQGz0Rer/KfJ2rSmImP/UB6hxjOQo/8xrQnUKxDMAA5cgmDlbN
    v+iK7YGYMq0/0eAqF+3q07/RkzvHTp8swAU/+WmBnHDADdFd8nhEfD/3Smt7LxRev5/nJQLN
    4u0//pGe6n3CZEAK6uaYiOUxwA8ICyJSDl5AAsQVEG00H7/8YYL+lfxYP+5U1kRWtSdAAekU
    z7bCa7/Vi9fWBvMsv/SYdMVhaUJADNYSWrokjEAGZSJqa512P/M9NlMJIAXABjbJ1H7ciMAC
    gSNB4vAuwBBpht23jjtAB4EYF10R6r/8EP/qDh95QAFTclQ+Csc/2utxVEzpSb/xjutN9szX
    wA6TWIvJvIM/9Kp+48MPAj/fHYMpkJ3wQAt57b50LUs/8QfkguH61j/o3wb1K3gcQB6Zbvgp
    FzLAKBDahob/CMAiDnB6I/TDwAmRhzJDKAhAA4GDmdTUSkAf8G7zptHqwCcfHBPkGcI/96NY
    kk2gg0AamTIXuKTzQAkoh57HIWQ/4kJX/vbgG8AhDe6k1wJoQBgb9t+vhBzADw5e384LX0AW
    UntCB5c/wA1FfNTtGbhAJ0MTS/bUxcA0dCBMWoHEQAayXH7kNa9AGE6B83cNXcAuL7+BJs/c
    wBLXrMFb97FAGojbZUCvu8AemjUKcEmdQDCCYuzIA/DAFU1Ijxaq2EAmNYW4UMG/wAKQhWHu
    wdRADpVR0zW/q8AXvgzDPIoJQCT8X1J2cYNALDqtc9nRCsAdgRSIGmpAwAZkSvaWoTDAHWwn
    G4OJnj/+jYrCTKxzwCOPpMuuae/AEZdbjKskPkAiSTJYj2JNP9L94d1TLOnAAACfa/lQCL/h
    IJ2wb3DUQCZKYIo3ZCe/35oaXzmFlsAmLAEK2zjwQDC+kTSUEl3ANZGwW6a5C0Agzeuyq72b
    QB5rjWgDBRM/pBjFyaGefL/22K8dGTzkwDPW/ntuNtRAJLnNO/4zfEAnb842nAE4QABx8crS
    Hre/5EhxJVbsJ0Aq+vU0kldWwCS+CAW2Dp1ANDWVQUEs0EAHCYrUIFWuwBk2fJoZTxlAG+w4
    iAoIhkAUiVh1O9F+wBHJf0yxV0XAIP9MRMeEEMAe0v28+U1LwBwL6E2o/dbAMur7slQrxsAz
    k6Y0YyuAQDLpu5lyUzTAF+yXQH/Jn0AyLbada+tzQAeIfovCpi/AME1k6yE4v8Ao9FKobiu0
    wB5WsSOYPyLAAXhR71EfTEAkpuIWgASJwBbCV0dIIcJANPGnJh9b68AgWL4H6kdAwC1+28IJ
    SQdADk8iYjkQgUAWSbgPXo8fv/P45liJpYJACs9jiuCIq8AqksuNxF5uQDENbMunh0DAQpWN
    dj8sdsAxyhllB5HyQCpDf7LBFI9ANQ/BCfIu+kA20rldzICmQCOPB7/x24rADD2SVZTJ5EAV
    7D03jPFrQBFZaOvXRhBALjb8aAwuU8Athl+2kGaaP8f9fpem/YQ/5vrH6EV45r/vi2ZR0aTn
    wAWjPyqkf9I/xFmIoQj8XMAOv4DHD2XuwBJYmcbvFXE/r3PpfGd4ZT/wD/erPjZ9wAEaFLM2
    3/hAAtHRqSNjnr/tMwbZb6HfP+5ZR19WbAnAA3qu2zwNfb/Sc8cKFq0ZwAuzayff8ozADh7x
    D8Uwxb+7o0GIB2SJv+jm7pe3gLhACJHj85NndsADyIrGUjZHP9J/PIyCM5G/+c7afr1+Cz/o
    gxeHuSIHv8a+TjVcor+/4lCgMKeZFkAHY31mVwRzQANOnLTc/ZZAAZ8SvwVTGT/rY/HgwF3I
    wAC4BTga77I/9ZA31WVlzr/RU9WyYEnpwAbNmFtwQnk/423ZIv1J0sAFtm74CcXkQAFZcs39
    C7m/6YJH+z0uTMAD0XfqkLzIP/kmwdoRo1FAAMwLRBWz9EADm3LN4vrQQAw3LRiudx7ABXyW
    mFljFkALEHs+WfSxP/4pD04+kyRAA2MVWm4Gs0ABtu46S+Oyv9HDYNCwkQJACwCyP9je1UAF
    r1cKHBcKwB9Kw1ta1NBAJSDXSvHLgz/4T+bLV0sqQChi9ojkPWXAAH6ooB0gfMAMruMUiIes
    QBuSkV16hmPADH4iSD29A7/jVE5z+oXjv/58ftgiyYY//C62zzlANj/ksOqLQqpCwAyZYnCa
    LhVAAHWwz54mPL/l7E0Vs1i/v9CrR4TXIE/AA0ztRnY7MEAZL5MbHnU5P++1d64QRNG/8Dbx
    jFZU0D/eig91HggSP5npCmVQ9EE/5/rrIjsFAD/6Mb3aic4/wBeJE+SNbN6//BMoqzAA5sAN
    aI3kzPkdP9k4kFiz+ZvAB4TuCWVX2j/JZ5rHSSmPv+AvQwr4kQ7AG17BrDsk5UAR/w6FN/FE
    v+NyKgVq1v1ABQ767irGlsABrPIS2K/ZwAEBezP5SkE/83rQVPG9ZsABw0sf4vLbwBNYLmP4
    HMLAA1Jv2iIJGj/xv04A3AWTv9dV8u5h62y/+ovU4UW9tkAawmr6/obIwBVAt77IrjRAIa5Z
    rS3Rkb+2lo7jwriQwAli18+d5PHAIkRrfSenxMAZpYtCqKdewCWjMFMekY9ANIWgGq2bK0Ab
    K+y2sqWZwBR5Z6W6/kdAIYGnpPf++kAoURPmxovLQBELqXEx4qVAMb12mcF2gD//EJCBH9jF
    QAxurwYXrrlAEN+oN7wZXj/xPZQoahsWwDV/3Z3pGNQ/5VSc0wTvjsAR824I1zzswB+W4wMU
    CHbAPHJVwNUaScA2QGEz8OiZQDrgZ+Gp9KM/6lXm/tTyqUAvAg4sKN5nQB/PzX6Xd57AFHFT
    AFUBu8AB0Uey4MzEwBS3cE4pQvNABJAXmgxunkAScECXf2LIv9Q37Iwa9mtAN0xoWG1Q2MAs
    DHs+o6tFwDlyXmH87ihADYAUvNdND0AoBrKdqVkwwBB5A78Jw6c/3JQq6LQcNUAZnpJZg32p
    P+wj1wVIqa/ANt7ridWYTcA0IEAtjRDlQCNY+lFpoCJAI/GFjjaDur/1wa0lwEmawBhCjFyx
    EkJAJ0xxKwitwL/iV77EyttmP+wfjbgwQfdAH3py7ciRi8AKgfHAJ35RwA8vKMUMPa2/4aVC
    qEBbqkABbiyCQIp6v/a98i01yaW/tlNr7eynzsAM/JckiObJP/D9NfH9aYE/xxUDJpRcYz/8
    5vS0LPqaQAzudMull/Q/wlnLyic21D+oWeoeiBwoQAM3VMS/Li6/4Dq1bq/bHEAE1Hk1aJt8
    P69ERQ+ub4Y/8meBowA7q7/xugdOckuawAQrT5upk3W/rz6mwlq2jT/NubWoLNZgwAQnxn2p
    jmjAA32vIrPHvMASPTqX2lrHP/isPjQuGhK/tuQSa5p1QUALSaQEUXsfwAI8dJgJf1S/8VUA
    kQ8n+kATByNckyMcP/VWLEs1ywm/4uQPvdV8Sz/32zKn/Nugv+4wggn7EM2/+NpLdvJ4Zj/o
    ZbEvE+jbP+DiBzO0mIVAErl4jC5U1MAEN2BEE5RdP/sNLwJSlt4/0YuEdh9pbr/sKE3Szf+r
    wA2OEAYaVT2/6D72QYnOTj/+GHOyzxDEP97H+4l2APy/9MAVQYS+SUAAVBLQMk92P+dE2NEc
    eRTAAMMyr2NISMACMndiiIU+v++zxUcWiXtABv6U1NRclr/bCMVwcZsSP9u62so+KMpACg/2
    Ccxdnr/p2sgMWrb0v6xrmH3sF8fACY/GVOzGT8AgY5k30q7LP85J0P62F+e/+sR6r2hX2EAN
    3IC3cUNJQASH73bhHR5AANSsUOsIqcABIEO2Y8SUwAEW14L8z7Y/923rX1JcxEAASfqKThil
    v+YfEE8/gp8/wV7HTYOI2UAS2qVW60GgP/QOI9EK436/oJn+vY4k3z/7pIF3XEkXwBhnm6Es
    n4m/98fHpcyUIz/QJ12yrY8DwALRsPC4Q0HABhoZDb/odkAOdbh64gORwA1QgWAgOqa/+eFN
    x8b7Aj+ynXj4m+Z9QAPDN4DhrS8/6T43XQrih0AXfMSCHb6+P/YJMG6QsK4/wvp+Jowfir/D
    I40mpkP+v/FDL+bP6MU/4bLW241mT7/y1KrPHQy8P9gEuEY4/MhAFGXy38FDXj/6O2kopErS
    v/+hzE+rq51ACBGlfp27dsAEmppKWZhVwBHGv5smQ/RAFMYo0xMOND/x5+rz21SFwBUdRmzL
    OU7ABRwq5wp5XsAU836sqc6JQCv2Jf1zX7e/75DExbhM48AgIo3Tm1TawChUkVxo9tvAEx0t
    S1LeJz/zXwDF4StdQBCzoyVmC20/9AG60gIsZz/gSTJ419o/QCVNA4Seo5fAHVrsdvZll0AH
    hqFyNkZJQANF6JAQe7FAF3W/n0q1sUAzznQ3pk2swALbquWQbPG/6LcMfKdqD8AH/V83qHiC
    P9UxAfFAqC5ABpE7eNMQgkAmOE/hw9u6QCMpylgBJP3AK27fygxmwT/zL9iWP1MDwBORbkWv
    rxnAFs9bYjrOQ0ABLSt8saXHwBOJ3YXLQrXABxQl3muc78AT7ZPbOW+zwAFqavQ49EtAJaBA
    3EldScAWCfEtvpaRwDBuSZ7RvJVAHC7w6juEqEAxXwM0JuoUv9dVYPQ6/q3AKORczuQ1usAl
    hi3hJYt/P+Q816zn2si//KhRqMpzSkAb9l6cDiB8QA/1C5NaPR2/8ji03VIrLMAGw++R3X9B
    v+mr4kl5cmy/+I7waXNatD/yiwyg5WaaQAPsk+mTvqW/5t2QyQNyacABHBV3juGKv8DS9qEh
    BOTAEHVr/dpRu0ACL2v2/dnNQAfc94IZcg5AAAV4PWb4qL/7CIfOb5JPv/Sl6bkBbZRAAwC2
    af269b/TkG23SvdOv9O4E/Mq7wpAALG6EvJ8eT/wFaLzyIgzP/meY2WaQrM/wnBSvocAhT/1
    wZsPDcXZwAZzYZuwttE/wP40BEFlNkAA11/ZYz4MwAGoA91dGQk/9LwuJQka2sATj4KZ3LUF
    v+RoN1YgXfs/5b4Tq3cBasAB6ufXwLbeP8MU/MuvPfQ/1vlwImfbG7/vmOG29C4+P7DVijLc
    4pvACFNGTGvGYcACNGOJbUVPQBf5WPPfSrE/+CZuNKovvj/gQnmyyB8QP9zS6DKZZpnAAQ3c
    OsYdeD/v+5U3jPtGwAmTM1xPRezAB2g3/u1VpT/1qNjFN2hrv+A4jZ1VIRo/+q3+GPXrZj/O
    ukKcSgbhv8zCnV4ur7BAEHH5rsCdRL/qhOr5YHX4QBorUZgTRH3AHNdfiNJ6NMAiWHjpkWMy
    v/+2dcd45tHACnIcuA50jD/qFc+dWW/8wBq0ncALb8E/8puYKzLc2kAWdTVrVACwv/e7R0C2
    6ey/6c9tXA/08r/3yYCah9ZgP8vPGCMrosDAFRjW+Ui4i0ABfOhdryvPwBSLH9Lqj/5AJgjD
    pUR+vsAxyLQXzfm0wBnFCd37joY/7KuYMmVheT+zEx3vrC63QA5Mss1RJpo/7sRwhOBIecAf
    j7C1LQmdQCFggJwOQH6/9eZRQlutZEAqKPeb88fTwBbNvWPuxCtAEI3bkwteUMAYhJQz/oDL
    QCPuMTe/JuBAFkZTYtgJzz/pIwfsN1/Ov8Pbfk1lshrAAHKXNHQDoD/8z2R4ghsGP/UlH/3T
    SbG/9o7Zvh9r4UAUQ3/dT6D9v/kdqS5l8bTAArOIZcCMq8AKcyxCZTK8P8NSbYu4B4JAHPWV
    huJ1tMAp5TzitcewQCxS5NRSGD/AJP5Y4NcCeUAlElmV+XYAQBy4Ie4cwVDAEhR3i/Jzj8AJ
    jSU0cfESwCtZdNUptU9AMsgrAsTeSEAw9/PnVZKOwCE3vUnb5kRAHSPovDs8XUA0yWFx+S6A
    QA3R9Tg7rIVAK7L2cHHrQUAO4kvQmkUHwDAsYKl56Y1AFDFYFxbs18AAwXLCmLtiwAuq80so
    yLbAI+rpb+3iIcAcsv/TMfOcwAPpgwNDyA/AMyh2ueej9MAshtJe9SiKQCOPhV9PCdTAGPrF
    1KBU60A0ZcoYv85AQBCZTWc/lr7AKAOlIeBGKsATL1RBT20TwBzpzXHwXg7AGZ9YK1j5sUAJ
    7AbKiJXDwBCJ8zsxPAtAMYdDMYjRXsASAOhsDk4RwA8qlx6tsaW/+y2s5ADm2kAlP67MQUcU
    v9+hJhAJEpNAGtlri893d8Aak9Fc9aKOQC5mincjHqnAQiOtt8nZgcArwxx6D5P9QCkKP4OJ
    jrNANd4sgK3TkEAsbgyf3+WRQAdXjCsTb8zAECcf6mcv/T/3PnKtVirKwADx7xHP79M/qvDr
    ZfiMzcAnqiuNwz5Bv/SGTvXNt9zAA5chMhYvBcAOn71KJPrtv74gV6eKSvK/77qPSqcUeUAD
    Ewkj2SBNQAgN3HCObfK/+r6Y6qeayEACQUCizz7HwBFQzGPcc5c/58gXDVIRCT/Qrw1nybZW
    P/yRIZXOkQg/5MCzUtyOYj/NYXhfRw68v/RY67zs3ay/3Tpr35UlJD/y8B1FvC8HwAe6EhXA
    2hNACqb/CZHINL/9FhxTUl4Uv/W5wSYa6KM/5eRjVnAAfr/xuHTM9XjAv9JZLJw866FABLpS
    4Kr5VcAFnArtq83ywAKLCmH3XrQ/9Gzqx8jw3r/Z5+C3B8IUv/k3/BOOVtjAB9l8KqzH/7/0
    Y9D8TRxIv9Yy0HSlbz+/5EMsN3Pp00AA0IJLNviaQAV1ePoYK64//d9qjiRVHj/u/Ma6pAj9
    QAX4NOmxoUI/2hbTLElbx0AMF1RU9YojP//x0+LNbJQ/9p3fyUCJCD/hWLkFXXwvQArdxC5l
    /oO/8E0DVCMJY8ACpDzZJcvpP/mOuZWxtPfAEFOZb+WauEAEnAtcPpCjwB7mRLcNFF5AKim6
    4Ipbz8AKSxL2un02QCxVrcyMrfjALM0Ke/E56cAaH3VM+PFvQCaNM2LS8TXAFGk9nmYPUkAU
    jhO1g8PRv9qu5kaAdSXACuoOWMlJxMASjJTwiuXBwCgjZTc4qjTAGcxDNccHYMAASdggA6RS
    wBOdVVEXQyNAEP8ebJ2uC0AKKu/DAK2BQCUTqjOr17lAJjunCgODRMATm+sM9/8PQCH6nw5Y
    x/vAH05XZF+vRsAhcv/yLcYvv+yXrMMY42LAJHfdmcMMPEACA3sq9wjTQBo3vKWNwj0/7naX
    53WK+8AmbTTaLnnXQBtsS/PdZ5nAGyOShLIS7z/4GVi8CoM1QCp7yKN0O/PAGVihEx4ggT/I
    jvuFXEjSv9OX3lwOpgRAE4PlFgr8PT+/t5A5DKiUwDAI4v7K5mJAIJz+40Y3EEAfiusSJf8b
    v/m7w8/x/rDAEDbKnHc37UAFHHAycIBAP/PGdD13wp0/sRr/V5Lju0AfNnxan7NkP+4s1x3B
    S6I/49zpxZThcUAFtCSV5+BgQDa2gF0vegbAKdKMWY2PocAqV1M1eNHyv//efNbEXttAIDh+
    IhLA08Ao6iUwnwLPQCmSLf0pOU7AIagGFXHu1sAWKY5cCxzsQC8Y1S3/8hbAFgF+MDjnwsAM
    HiyZ2rwOQB4CHWLMsItAHt2LUJviHMACjDODsoSMwBDKWtDdlelAJ4fuWbyl+kAwn0oqw0/y
    wCl1R3AiW7xAC/qDMSvPpsAlwRbBTo+Ov+fQDeZvu4xAMHGQvFZ8rEAK9qGfzwLIQCp3UgQk
    qVnADE/g5O/tisAlSTwmNCPkQBNVp9F1kUPAND0O59i9FUAhsHCaSuPpQClxIZO8I8fAEYam
    XxCSqL/iM/V4xQzQQAEn6Bu8ZCvABhAnWSebJkAke5mnQaR+wDKE5FnCmqlAPmXmYkGkIkAw
    xpuwvwQTwCYEqXjZVCbALTpPceu1ssAy84n1cVdiwBosLJ79Ptk/14SfuVFTZsAq0/ih1xw3
    v++AOYEWK0LAMeQEZDICg0AjvNQw/5l2QBJrHfsgEOo/zZLiiJg95b/TAj/oUatkP95dH+BB
    2N4/8kA6pb0hEr/dPfrxKKnuv94FJJGUrIM/9HhEcoru8EACTsJ5kLe1v932EVsP1Zs/6wFd
    pU5pOsATBErKYdQQP9CstE7BOnk/+4eqvnj/jb/Rig5Cz0dMv+fF/BoqpOLAEki5QkkoRz/D
    K2xQo0l7P/lItzod4Uk//ebQXRJxkkAFIev0gD9+wAoI+Vfb3l+//bfHX0k4JL/9tvlI0ZOY
    v/5kGt9Kon7ABQum74k5Vj/ycFJ7cNdRP4x21CGPtT9AAm21t0iPzb/9KckM27OxP8QKOyCH
    OB0/1pIhPko0Uz+y6pPko8GRP/O++tAaRmE/8n16HOYk6kACdOrHTdbEv+9ubSF7s7s/+EbG
    WCLr6z/0eYF+rT8EQAFolGNcL7bAEmDUWLwnZj/p5tigzeb/v+163s1PNJxACbQMBcL0TD/l
    VfCDLgNtwAHI6Dv4ONbABOJbuJxvrkAE8X7q9l8KwAKkPBsTqu2/8Y2DYjwvHb/zs9EAbuPJ
    QBI2TIk7AIHAEG4j0aReK8AnYXkJkb1UP/p9PJ7jBuXAIdhWhFTwSEAFOL2TsKrKv/yCfurZ
    1nC/+E88rWbLyEAmJQb9nFVqP+fHXMUw8yy/3OQxYVgi2MAUA+U0DXEYwBc7QRzM6GTAJSZJ
    WeQmG0AOMXRbBZwCwBIbtLcA4TRAI7hnq7b7/8AxRgrPVdDPv6LCBy4Xd0lAG2w1W0/ve8AX
    78qd2v6hP/19R2rscpDAAd65HYa2TsAkM3Oxewc3QC9g5bTVJiHAGNBTOJ7n8UAoNo/H/DLK
    QBT2j0XQqI9ADRl//8unmMAk4weThowmQCyYydL27IdAGuAtWNuyCT/YghRlFhyqQBSUKa/Z
    4xXAG2ZBip3keMARQYq+7LLzwAmcO/EaTMnADdfpbO0n+EAdsgkv3oG8wB6oYE3ZBupAAWeU
    CVFOKj/0pxWeVa2gQAogame95RW//6ANTVrO+8AkdTGXxz+FQDAnqhx1OyXAK0LCCzJIRUAn
    wYGIwj0FQCYkrldY/iXAGtO64iKuk8AB6m/MmZJNwCO898kGu7JAJq+ul+dzAEAVfYvUMGYJ
    wCq3ffsL2uk/7sXRciCqAkAnQcuL3X2cQCI5XwYfIlZAAKw1aQftaEAcHCp/t74TQBNYD53E
    a+dAAwMCAJpVjcARHwYAzQUGwB5x5s20jgK/++tBtaPFs8ABnyoCufLbwBDCQS1f0w3ALprk
    qzgZ7cAkgjlGZPH1QCQhP8WF2BhAHFSUyO0r4kAQw6vWtNkSP+AMByimB0+/+lIvB/ONI8AU
    WRlLQWTrwBSd6YCFevK/nuTl3nyjjcAHoQp7Ir0aQCiW2k3pdstAJvIGj1EWOcAUnyy0PIWH
    wAR5toYwQ/m/5xQQCzAKi0AmD/XqJxceQBVf/fpEBPA/5xcLjjW+rkAfPAm9W1umQBObe7bd
    4ybAJNzPmUK3WcAiRwx5PN3Mv+BAmdcb1PtAJXkfusQltT/dDGo5yybxwBwxqlEpxME/c1oB
    vVY47MAihdUQYz4Vv/wEFyhyN+e/+djvgmcBHr/hA2Pf04m6v+grDX6jESw/yQQrJMT1OT/l
    MtO2DKsvv/5sj2XrrRu/wpQLh8XVu0ACzFM1VYXEP/ShyHa/FWNAEqEviB+tpr/wYHSeT1VV
    QAX66Nqlf/hACpHn7zl137/zvQZvlktIwAF4j2w2PAo/+axhV8zCzr/xukbnHtH8P95zT8m8
    1qI/48C8OBA7sL/ec8dXXZaPQAg9O43EqUhACMiMLYf/kT/8btVaHkOXwASmwLRcgg+/1jOn
    zWetf7/92e4Rmff+P+awL38Iq6S/47nfGUD718AC0c4muOWUP/VHp/j2pAnAD2/q61J+J7/U
    /rmeeqnjP+79WEfD3W2/6AuSZ4qLZcAGpjOzMMo5wBXGoK4z0Wm/20iEqyV5h7/45EDg9k9p
    P+bBOMI66Ls/6fn6nTZX3cAAsyjctt36v89wCfcsS4xADOV5WCTCfT/9dIc31KY8QAIr8xmJ
    ezc/+RjIxmWmBr/8YTuv3hSev+KBqQF9ryc/xGQyzzIgKb/IBZxbIfJawADasnXh/wa/7yIM
    KwlH+8AB6Sr9QC/FQCy+IHaK1b7AMQvQTLf85MATjeuE+ZAuwCMLzqgw6SQ/2oBj2LXyxEAb
    mMqpZ5Z+wCw+ALPZqHBAGND9pOrBXUAbQsqbdHfNwAD8GX21X2O/6NnozOKvOsAMGvlLOpZL
    QApPJmMckAbAAJBqwZEhZ0ARd2LPSS3fv86NcO0II4tACM/EBCjd1cAwK/vgHtQjwCKNeL0b
    0iW/8YFl/CfH17//RV/IRzHev/dAn5ElwbtAEP0icKe9kD/tW1IZWWzLQCeThCVkp8ZAD6zr
    b6qjb0AhmY/aOhjtwBdvyj8nTT8/+1VUP6SpKr/YoBGIUxw0QBjRpbJLpWxAJJSQBo0i7cAG
    47Fj6yxRwATBty8tis2/2QQd+0LE0r/zqd7lULXbv/EQQBNU7A/AEvcG2DgpqUAD1sdTiRGj
    QBwpVVWOX5DAB3cW+rtd+sATD4Q03fLxQAN+/5aoo/U/+Ge2+czcEcAfbRgfd6H4QCkeFCyR
    0E/AJgsm/VIZhEAF822Hnvs4QCQQpch9+VJAKCPjI259C8AoEpvbyNTZQCL1qM5LNQxAOvE1
    SoNqz0BEjwYzrUsUwEdBrnX2mbRAI7oR8NSzB0BJ88u9x+v4QCBmPC8rt2VARZ8Ci9kJbkAB
    BgVOxnKGv/Ux1MeyIkVAHfIVTPdF70AnRNwts/vmwES9Q9gjLfpALKOxNjLTO8A3sLVO+ppP
    wDExfzUbiRvATJm2FnAAscBDuKMRShoiQEBbo2fY4x1ALYYedrA6jkA1KFBFjndIQCXiUt0r
    aM8/zkJQ78cccsA0gFqMWXbTwEICnwdA0ZtAHO5nFcgQoEAOyt0pfGyuQAZoQtHPwBBAGzbQ
    qdSDSsAlkCxd14YuQCvBELgbB2/AFNeG6W+N/D+1imKwguoBQB1SZ9h0fE/AJZfrxYzW+EA4
    dFRh0sNQQEOpHJaV5J3ATRRZxslmyMA/PLoDVRohQDCFHYkC8aZAJSuJq8OWLUAyL6qEZS6T
    wDValwAdigzAJoZ1k34X5z/2u/GFg1GmwCA7idXhMfrAEnPk3MP7ScAreFP96Mr3v9IyzxVc
    Vh2/9IhiVjC3Rr/gxwMJFF8BP+GVdQhNVCHACaW5A1PYXUAItwaAJdnWv/fPmqkqY6K//dDx
    0c/vtj/l7u2eiFPSQADzmDW2ZCPACeJlbcjrwL/yKYOw5EBDP+vaYh/onsW/9bFBfhZZn7/e
    wh2o9eFXv+VkMIC1CSe/7C5GtlpgNsAQEacb7SXkP+1Lq/EU7Ms/9txlSEdh1b/ihkifJXuf
    v6V6KyrJ2Y1AFI5//YMrS8AJgNKBRoPqP8J02OlXcfu/5v/4ySYXX7/4SdPCj3kzwAOtl6kQ
    Iku/t8KKanQnQb/ihJ/+rYqIv/RMxiBdSK0/93bQSoA7Dz/9nb1ni4etP5wHLwzBDHw/9PUB
    rM0sTz/+q9kv0Jn2v/N/nKpuVw9AEM3q0SwRkT/PBZhsTAzSv7gGPLpzZd8/9Qe6VsdkPb/n
    mL3wH8E7QAiISVUMOIm/+SLoq06Vn7/04yM3jvYAP5PHfK5Q178/yer1wvK1okADtA/BDjm+
    v/J4OonlbhRAD2rgvLXA+T//n79fYRLxwCDLuIxDTCxAJYDkB1RlkMAY7AImJW2KQCnaZUoG
    NvpAE6x6o+oNiMAbzdwiE1fzQBm8GVRz1F/AAg6OrPXj0D/0dV73bs0YwBQwbygbgA1AGp6A
    DT9567/0CqABK/Ruv/hBGtEQQHU/5ySHfC9QLj/qGG8z9BiRwAAMEzyFLH/AJKQG3q2ZAEAj
    NoO5iqtnv5knU4jtemfAGCgK1EpKXr/44wNEnBBDwAYF+KwLNRJAG66fU8QdBj/7WwRpZtj5
    wBNtFxSZUC9AC7NdqeHKe8AaUKtZ9H4rQAJnGlADYQTAEiCjjt+7gT/q+XmMRbGxP/d68TbX
    c6nAEzyYyH2lmUAkSq8dOJEDwBbslSjQ9N1AHogta4591MAjTwIRp+s0wBENpVtR/k6/8Qm4
    MBLXej/2Sq4s0ajlP/8mB7TW/8DAHe2NyydIaD/29zqgC2jmP5a9QvrRcKHAGaZXzdHRF0Ak
    3uQ1oqLBwAehgmi9d79AKeMP3c30YMAT7NlzWMUVv/EwiqSIr+i/7ur9/Ec3SkAJw2pKIm7c
    P+hCaVcn5W2/w7K+PE5Ie8AzPh1zWO7DQClY78Ucavw/6UMEPvK/ocAxwbR1vGLAQBFBHb+n
    c7zAMY3le15accAYqusR058SQBeBWHClES3AGr//eNmj18ABACH40Pd7QCD1L7KQD74/u/0C
    ClCBX0AhPkO0UgH1QB+m1Uwiky5AOTc+ki71GUArPasdeqFAwDT9Rk66PLbAHmUzzCQ4isAj
    ZflodmAOP/OoeALJtM5AEkoBjamdbEAjlwXKDNuRQCkvhWIksinAJZqj6P3dyMAeRHPEi9Ow
    QBMdN5LRjRHAMETN1yKwk0AVpb/Ani1tQBA+VRuIIbLACqkNlYRkzL/8P5RYFalhwAWs06Va
    PvNAJpcEwDVH7UAXm+G85N49wDnfzT9JjElAPBAtNk/8H0A04io/sDFZwBe+OA28No/AGyfa
    WsQWOsAooX9HtNwcQBCWQOPQ+9XAIh2pIegZ2z/6frHllUI/QCAJdcB1W+nAJvcd0geWOkAh
    sKbSPptGP6BXpzRw/a2/3PGq70AzYb/LPu48cSJTQAo6V5FQEXM//N4zZEDOP7/0mSLWlG04
    QAZTf5n1UmG/5T8ZCxf51D/ujfUC6l8vwAVgolVNSmlAA9Q83nK0rb/dDUidIxKQP+QIIJ/8
    wZS/+HXzg6tq3b/RwA9DI2e/P8NlZGapNIpADzzPZXYpd8ABZKaR1HnwQANg23NLMOlACrPD
    EuBurcAFZpS2fgfQv/e9XIOozslABuFxNvcF9j/yNEsNK65Jv/pz8UjOHZa/9Aw/FO+Rm0AB
    E2NMEDwLP+U+FJfZOaW/rc3+Hn4zRT+VnfN+ei9XP/y5tCfMZUY/9iq9Ryh4bz/wOwcSONDT
    v/gvs7z5GHa/8q7tXE8178AEOhrvFHsiwAYjCdVmDV4/7PADp0wK8T/PvMRi9JClwAUZzGnp
    dCTABRIUHjB5eMAB5HRLUV0vP/BqrLV54Xe/9P/cUDeCyT/2NatFBb7aQAbdGrNO8oy/7gDW
    8swWJT/H0pCFnqoxwAWAb6CLUVDAARkv1TOrYUAWqArJeCsMwAT8pw6K5l8/8bZhG5a/9UAC
    6mCoIPRLQAF1P1kLB7PABUhYVwzwfD/wlkqwjnzEv5DdCxRvtv0/+onzHA6lwL/yzVOndo3Q
    wAdIuefVSLo/9mgAHvDeq7/OGCCe95KAv9wlBkDU7xBAEc6R+4YoBUARmn2Ykvf1QBjCJMMK
    hj7AJqCxVjawXkAvZJv6QNRVv/Raic8hlFzAEXQ8yopWw0ASR+ARPWEEP//qvry7n+O/0g8z
    p7kai0AhXA5BKRCZwA95OcSDMCRAIOF/P9p9q8Af5IBLRsIqP+T0SQ1rCAy/2MI0uZXiQUAD
    j9j2EkCrwB3vHD86cvfAFmzDlOY5cUAdoPED8mxbwBFvjhNiohhAFpsLwET5LMAapkhMoNwf
    QBR1880a9X6/6p1vJ/z1ksAQ8NvLQTOVQBUofTDw1gu///mVWU9pez/A6EugUt8AwBcWk8UF
    p/rAHrKCKtATYEAha4iXfvpTwCEVf1ntjqNACR3zp3ptvsAtHaLANe+Cv/Es1Vsbe09AKY6T
    CbtuP8AJpR65jvCJQDWCqep1evPAJTMrd4WbLkAJ0ajjmOo8wBOrdBmniyw/8WgDuXWYrUAT
    15ay01k0P94B4noJ5OFAKC9LZJcH28AEbsFwhUx/QDHXBv/o7tJABNZH4cIBSEAhaGG/+mKG
    wA7SRwPNLUdAI4afVStlRsAVpZHhKUTwwBzAmr4T6RXAEGCs90BIwkAHv3X0fO/VQBkji2Fv
    3stAG6EgLLsCqMAlPbCSA3DSP+j2lvTbRjpALw1BuMEOLb/nEzlrujOGP/AjARGr8TzAH5D5
    /u8h98AJ58Ap5W0gwAD6kxRH7vDAMqVEUFyYnkAGCsTnvYkbQCvgR7gFxYjAL9vH7utdhsAi
    OMj1e8a3QB1BZvyGzijADjDuMLMDy0Ati8o/d5oswB0LGx3taoJADzd9qlwG5kAuQz5LPJHf
    wCIGBgGKbLrAJjxPB7XnMMAlMG4w8RQKwC2TeeAM/CvAGo0vcHyhcsAE9PJB2u/8P/i51/xo
    CrrAK7mIgCIGKz/+YUGlbHi9P/r9ntjaXXC/uJfofpN9mT/VWykYHig2wA6yd1auxqY/851P
    rNfPjD/eM+jro+T9P+9+HO/SUCS/9xpJAa/8x7/dSZG6SLuRP7PjdM/NqC5AEhN5Xufmz0AA
    wAWED8EsP/e4HG+xijc/wRaSpmX21T/cFeXmxeMSv/MP412ZJx6/+2QTYY+Z/cALzT9I5SQO
    P782R2LKpMu/xT1HxqPBHz/DO4TLJ/mYP/ZYT1XC/1W/+otZlaYDHD/0PEzAls3zwAurkwOj
    uFZADs4vvEB5Eb/YLbb/NwWrP9K+7aqnxiXABxOPHcmvy7/0f31u84cKQANqOyh/bpY/xfuX
    OyEfmL/zHDf23rX6QAZkg2mqtm3ABKHNwNfGIEAKmdK1AHzPwAbRn5yCg5o//Mhd6Wn+G7/c
    GqwY84OjP/XJJepCc+Y/yfjBJL1x5L/qQ+d2H8BXP+usrVQXFt/ABZArJgWb/b/Gdig4oewc
    v/I0TdVLcdg/8VORb5lXo7/Q40wlmBVVv+of9KlAx0I/3TLLRs5Ctb/7HRaeiiwIQBJ2s2sr
    tnrAHCCDo51KkT/j1dgvfwv/wB6xfz1OXlVAABkEdkFM4kAMz4ULiVscwBFxile7Dro/6Z0L
    cAAPtD/oYXyHHRTNP/ievCgL/eK/8tpfwcy+rr/5Xz+sWz1oQBgi2Oi8fVY/99pBWrCYiD/a
    yNe/7ZP5P/phbMNxXiw/+XfEGIzPqsARyDAX1v3zwADWX57gAoy/8vJraQGTlL/hHEC+Wnp4
    P+DI1R9CiA4//844B8D35z/wp+nuodbEP/r6LC6SJBE/zerO129qqUAMsljM/Xu2wA3bJjFn
    jBpAAGhfsItOfz/dEiFG9s76v+L84SxJlNxAEEyqZ0RWuMAC09sPWlJcwAh5Wme7ZXc/6O0e
    xQAUNkAFP0DSoOYtP/ku5CPFkAG//bKB67gT+r+xYLLLvZU/QBDBrTuY84e/5TGZlbIs58AI
    bbvsbp5AP/ikWtgYUNJABxQxJhEFLMAUdPb2AtuuQAR90arA9ZrAER8PWt2wkz/ELYjv11Dw
    v+GcgUm76WLAEXBk2fpWN8ASMSprIoQhwCFaVyCDFOZAM6sH9PLlxUAzYMoYEZ8XwCVAdmL5
    zEZAGcEKPR10A0A9yAvKEAGeQB+s8d/B14VAOgunyi44tr/4H7jMhmgxQA6OE43Lo6ZAE4hq
    ds1NPkAFG/Bg4jaNwDBlwxLQ/Sq/8ry73k+Jk8Awqc7jvM2HwBrP8HSMPrXAQCgc9XS9k8Az
    0XMagQfCQDqct6g7XrC/9LxkVuIL30Az/hbxAUdtQBmStbvHJavAJpb75o5xEMAhnN8ASjbN
    wDBLHiB6HBzAGCEMixnS7EAR4i5XcO3RQBRPM57+3ERALcAyVmTxc8ARW1lz/qJQwCheCjp7
    nGG/ycSmj6UQ0kAeymrODV5gwAKBGP37Aq5AIT0NQxO0XEACsS5BKkAdQC+Z1y9TXN/AQFPJ
    cz5EOMAyqZ9y41S/QBgGVxoTdTVANNC9ucR1c0AoVe0LERYjwCai1ej9GLvAEEja88UX2MAW
    xdDIrdPHwARKuCy4wRk/4ch6xXEZ1cAnBgnShIbWv9ZkJwlTl6q/9eEsrD1MgD/14ihJGrLq
    v+bi7AGVJOY/9X2Iq/6q2z/08SWJLMkpwBg7d2NH/Fy/6QZwSeH9uz/xKHCt896nwAGiu1QQ
    MxNABAy4E383gL/fi01MaouJv/sxkbXgwv0/0jp76fDSvD/50iAivYuMv9gqXBrzmKxAC1ff
    cFAbj0ABu339xnDiP/aal/vFUsM//07bNCqaUj/+6x3a+lN+QAJ/tAyYFrU/3bTba3PHHT/V
    0kS07/9JP/2aqD41Qng/1A/dpOiN3z//MK1CdgtQwAk6gdIQlZW/+KXOxmScFL/jkGBG+Hx2
    wAB1VAZU+ALAAAa3tuCko0AKYMbPostvP/hKPG/9gPLAAfygLCLON7/bX4aUralSv+WJbdGn
    p8k/4Yxq6EXrdj+zGO6H9dOoP6bMhQ3j31o/4k5tHIBtS0ABUDyR4aNqP7Ft4hYrjiW/6ibb
    jFJry7/2RMjpAhbPwAAMqbL1QqTAA5lAOf0qS7+0+J+2ifDxv/ktb7ROx2W/68knk2Whl8AA
    lNYhugQuwAUZJnOjBkhAFGVf0+vQssAsoe2GrTcyQCVeRRELZEPAFJCIm4liRMAMbSMA6oJq
    QB1TDtaKfjLAFvjUpYhK8kAeBvFTZ0h/P9JaJsa0FcNAADFxrsHNZcAYO36Qq7StwBFTIVRw
    2/fAIZ7B9mKP3z/kkyftEZ0mwCfS/RRj55hAIUX44PonS8AnG/DH2SnnQBXxT/piB5lAE9rL
    6czjU8AjVIqo+afQQAuWj6IWN89AC5RTiRj2X8AnfUaNSWzsQBiwi98CcM/AJXFQIcnEekAk
    sjxqKMWKQAH9SvWRBvK/9A2AJioIqsAk6HtU/HqXQC6C1zRZlgNADgrba0VlIj/0dKO/IyQb
    QBnJfJhSmh7AAxknLmbnyz/CRkzX5RnawCJnfryOZrHABpMrcTUkwkAiKFXtn5+vwCWXHmVn
    XQa/703zVKZ/fEAJy9PqBR8LQBFTygl8kS4/3ChRqOlznMAQ14l+A41+QClBKk6D66nAEi/L
    8iyg4EAvWAEo2vOrQBFS1LqSP0HALBnPFYLKFEAW2VmyXHqgwCAWeIvzu9LAFxPtFSQ7asAx
    2ZEUkjXTQDFLUKAWOKzAC0BdKprodcAxqSXk56twQBT5l1Wv/g7AM4znkf82cMAM0dfnqtS9
    v/WteqWYuAa/1SjwNBxFsMAgtlwwxfUJQDET9QVqhNLAGBFnQaRh7UAiVn6935IkQCRRakIx
    Y4ZAMgc9FNWel0Atu+KNP4d7wCy1mOYwlDnAGz5HHZbX8MASxP74j8PMwABbIzMOGPXAAch5
    3IdYikAdhuflUJQ2QCk0aot2d08/nRZP+V83tb/lX7jn6BzZv/uaqQEldEVAEnRc9VECNkAV
    T+Lb+1X4wCz8njrsrzpAHGXmVbLGHUAS0jilujE0v/kCAiuTK6ZABU36LMWEwMAjedsdCyIV
    wC++GjbhhNxANnP0olOgfEAgzuMpQ/LTwA7DatZDvJdAE0sfcFV1LsAh8EKVK+GAQBMrwnT7
    D55AHC060mbzG8AQA/LHCyLRv/dvEX/k7Lw/8CDD/Ds+E0Af1/a9qJDAv9u/3JUxL6Q/9rN6
    7TGNwkAG55LxxQtxv/W/BEe348m/8sw1j6qMdb/pq6+enCqgv/g7G2JK/+K/50sjF/onpb/y
    lH9yF1jzwAD4isP9eDc/1X7I+aE8I0AAybXsBgH4P+PABSjf2dk/8+2CZnu5Jz/phyb1uTlc
    P7W/KxvwXUI/8HuIZlwWqb/4Kd+vyV8KP/fAbM/Cejy/+IYe+7BlU7/3RFNzLPQvwAGHTkr0
    3wU/79ka30wN20AAOdp4HH/qQAJJvZUdZke/8wY/VuV2ccAIgVooNWKCv/uTDP1RKYI///7L
    Q47pJz/5AzFZxW4XQAx+YNdg4pG/+HeYPlartD/frW0zWwzLwAfZGZlOxCq/4+LLCQ4PpUAG
    S8kDAeOrv8+1ltQRtD2//tTZBC8AFsABqE1pHwD3P/s93dyd6SPAC0MYcG+2UT/YFcBhvoxI
    QAp3nIckNvU/8+ZPhlA/fj/0X6JI1d1iv/gR8UTx7IHABJ3HAKdNrD/fl6LIcbBeP/cNTkIR
    /w4/9uFppoilfwAABAIAAAABAAQACQAAAANkaW0AAAANAAAAAgAAAJYAAAAsAAAEAgAAAAEA
    BAAJAAAACGRpbW5hbWVzAAAAEwAAAAIAAAAQAAAAlgAEAAkAAAAJRDFfY2VsbF8xAAQACQAA
    AAlEMV9jZWxsXzIABAAJAAAACUQxX2NlbGxfMwAEAAkAAAAJRDFfY2VsbF80AAQACQAAAAlE
    MV9jZWxsXzUABAAJAAAACUQxX2NlbGxfNgAEAAkAAAAJRDFfY2VsbF83AAQACQAAAAlEMV9j
    ZWxsXzgABAAJAAAACUQxX2NlbGxfOQAEAAkAAAAKRDFfY2VsbF8xMAAEAAkAAAAKRDFfY2Vs
    bF8xMQAEAAkAAAAKRDFfY2VsbF8xMgAEAAkAAAAKRDFfY2VsbF8xMwAEAAkAAAAKRDFfY2Vs
    bF8xNAAEAAkAAAAKRDFfY2VsbF8xNQAEAAkAAAAKRDFfY2VsbF8xNgAEAAkAAAAKRDFfY2Vs
    bF8xNwAEAAkAAAAKRDFfY2VsbF8xOAAEAAkAAAAKRDFfY2VsbF8xOQAEAAkAAAAKRDFfY2Vs
    bF8yMAAEAAkAAAAKRDFfY2VsbF8yMQAEAAkAAAAKRDFfY2VsbF8yMgAEAAkAAAAKRDFfY2Vs
    bF8yMwAEAAkAAAAKRDFfY2VsbF8yNAAEAAkAAAAKRDFfY2VsbF8yNQAEAAkAAAAKRDFfY2Vs
    bF8yNgAEAAkAAAAKRDFfY2VsbF8yNwAEAAkAAAAKRDFfY2VsbF8yOAAEAAkAAAAKRDFfY2Vs
    bF8yOQAEAAkAAAAKRDFfY2VsbF8zMAAEAAkAAAAKRDFfY2VsbF8zMQAEAAkAAAAKRDFfY2Vs
    bF8zMgAEAAkAAAAKRDFfY2VsbF8zMwAEAAkAAAAKRDFfY2VsbF8zNAAEAAkAAAAKRDFfY2Vs
    bF8zNQAEAAkAAAAKRDFfY2VsbF8zNgAEAAkAAAAKRDFfY2VsbF8zNwAEAAkAAAAKRDFfY2Vs
    bF8zOAAEAAkAAAAKRDFfY2VsbF8zOQAEAAkAAAAKRDFfY2VsbF80MAAEAAkAAAAKRDFfY2Vs
    bF80MQAEAAkAAAAKRDFfY2VsbF80MgAEAAkAAAAKRDFfY2VsbF80MwAEAAkAAAAKRDFfY2Vs
    bF80NAAEAAkAAAAKRDFfY2VsbF80NQAEAAkAAAAKRDFfY2VsbF80NgAEAAkAAAAKRDFfY2Vs
    bF80NwAEAAkAAAAKRDFfY2VsbF80OAAEAAkAAAAKRDFfY2VsbF80OQAEAAkAAAAKRDFfY2Vs
    bF81MAAEAAkAAAAJRDJfY2VsbF8xAAQACQAAAAlEMl9jZWxsXzIABAAJAAAACUQyX2NlbGxf
    MwAEAAkAAAAJRDJfY2VsbF80AAQACQAAAAlEMl9jZWxsXzUABAAJAAAACUQyX2NlbGxfNgAE
    AAkAAAAJRDJfY2VsbF83AAQACQAAAAlEMl9jZWxsXzgABAAJAAAACUQyX2NlbGxfOQAEAAkA
    AAAKRDJfY2VsbF8xMAAEAAkAAAAKRDJfY2VsbF8xMQAEAAkAAAAKRDJfY2VsbF8xMgAEAAkA
    AAAKRDJfY2VsbF8xMwAEAAkAAAAKRDJfY2VsbF8xNAAEAAkAAAAKRDJfY2VsbF8xNQAEAAkA
    AAAKRDJfY2VsbF8xNgAEAAkAAAAKRDJfY2VsbF8xNwAEAAkAAAAKRDJfY2VsbF8xOAAEAAkA
    AAAKRDJfY2VsbF8xOQAEAAkAAAAKRDJfY2VsbF8yMAAEAAkAAAAKRDJfY2VsbF8yMQAEAAkA
    AAAKRDJfY2VsbF8yMgAEAAkAAAAKRDJfY2VsbF8yMwAEAAkAAAAKRDJfY2VsbF8yNAAEAAkA
    AAAKRDJfY2VsbF8yNQAEAAkAAAAKRDJfY2VsbF8yNgAEAAkAAAAKRDJfY2VsbF8yNwAEAAkA
    AAAKRDJfY2VsbF8yOAAEAAkAAAAKRDJfY2VsbF8yOQAEAAkAAAAKRDJfY2VsbF8zMAAEAAkA
    AAAKRDJfY2VsbF8zMQAEAAkAAAAKRDJfY2VsbF8zMgAEAAkAAAAKRDJfY2VsbF8zMwAEAAkA
    AAAKRDJfY2VsbF8zNAAEAAkAAAAKRDJfY2VsbF8zNQAEAAkAAAAKRDJfY2VsbF8zNgAEAAkA
    AAAKRDJfY2VsbF8zNwAEAAkAAAAKRDJfY2VsbF8zOAAEAAkAAAAKRDJfY2VsbF8zOQAEAAkA
    AAAKRDJfY2VsbF80MAAEAAkAAAAKRDJfY2VsbF80MQAEAAkAAAAKRDJfY2VsbF80MgAEAAkA
    AAAKRDJfY2VsbF80MwAEAAkAAAAKRDJfY2VsbF80NAAEAAkAAAAKRDJfY2VsbF80NQAEAAkA
    AAAKRDJfY2VsbF80NgAEAAkAAAAKRDJfY2VsbF80NwAEAAkAAAAKRDJfY2VsbF80OAAEAAkA
    AAAKRDJfY2VsbF80OQAEAAkAAAAKRDJfY2VsbF81MAAEAAkAAAAJRDNfY2VsbF8xAAQACQAA
    AAlEM19jZWxsXzIABAAJAAAACUQzX2NlbGxfMwAEAAkAAAAJRDNfY2VsbF80AAQACQAAAAlE
    M19jZWxsXzUABAAJAAAACUQzX2NlbGxfNgAEAAkAAAAJRDNfY2VsbF83AAQACQAAAAlEM19j
    ZWxsXzgABAAJAAAACUQzX2NlbGxfOQAEAAkAAAAKRDNfY2VsbF8xMAAEAAkAAAAKRDNfY2Vs
    bF8xMQAEAAkAAAAKRDNfY2VsbF8xMgAEAAkAAAAKRDNfY2VsbF8xMwAEAAkAAAAKRDNfY2Vs
    bF8xNAAEAAkAAAAKRDNfY2VsbF8xNQAEAAkAAAAKRDNfY2VsbF8xNgAEAAkAAAAKRDNfY2Vs
    bF8xNwAEAAkAAAAKRDNfY2VsbF8xOAAEAAkAAAAKRDNfY2VsbF8xOQAEAAkAAAAKRDNfY2Vs
    bF8yMAAEAAkAAAAKRDNfY2VsbF8yMQAEAAkAAAAKRDNfY2VsbF8yMgAEAAkAAAAKRDNfY2Vs
    bF8yMwAEAAkAAAAKRDNfY2VsbF8yNAAEAAkAAAAKRDNfY2VsbF8yNQAEAAkAAAAKRDNfY2Vs
    bF8yNgAEAAkAAAAKRDNfY2VsbF8yNwAEAAkAAAAKRDNfY2VsbF8yOAAEAAkAAAAKRDNfY2Vs
    bF8yOQAEAAkAAAAKRDNfY2VsbF8zMAAEAAkAAAAKRDNfY2VsbF8zMQAEAAkAAAAKRDNfY2Vs
    bF8zMgAEAAkAAAAKRDNfY2VsbF8zMwAEAAkAAAAKRDNfY2VsbF8zNAAEAAkAAAAKRDNfY2Vs
    bF8zNQAEAAkAAAAKRDNfY2VsbF8zNgAEAAkAAAAKRDNfY2VsbF8zNwAEAAkAAAAKRDNfY2Vs
    bF8zOAAEAAkAAAAKRDNfY2VsbF8zOQAEAAkAAAAKRDNfY2VsbF80MAAEAAkAAAAKRDNfY2Vs
    bF80MQAEAAkAAAAKRDNfY2VsbF80MgAEAAkAAAAKRDNfY2VsbF80MwAEAAkAAAAKRDNfY2Vs
    bF80NAAEAAkAAAAKRDNfY2VsbF80NQAEAAkAAAAKRDNfY2VsbF80NgAEAAkAAAAKRDNfY2Vs
    bF80NwAEAAkAAAAKRDNfY2VsbF80OAAEAAkAAAAKRDNfY2VsbF80OQAEAAkAAAAKRDNfY2Vs
    bF81MAAAABAAAAAsAAQACQAAAAZEMV9QQzEABAAJAAAABkQxX1BDMgAEAAkAAAAGRDFfUEMz
    AAQACQAAAAZEMV9QQzQABAAJAAAABkQxX1BDNQAEAAkAAAAGRDFfUEM2AAQACQAAAAZEMV9Q
    QzcABAAJAAAABkQxX1BDOAAEAAkAAAAGRDFfUEM5AAQACQAAAAdEMV9QQzEwAAQACQAAAAdE
    MV9QQzExAAQACQAAAAdEMV9QQzEyAAQACQAAAAdEMV9QQzEzAAQACQAAAAdEMV9QQzE0AAQA
    CQAAAAdEMV9QQzE1AAQACQAAAAdEMV9QQzE2AAQACQAAAAdEMV9QQzE3AAQACQAAAAdEMV9Q
    QzE4AAQACQAAAAdEMV9QQzE5AAQACQAAAAdEMV9QQzIwAAQACQAAAAZEMV9MRDEABAAJAAAA
    BkQxX0xEMgAEAAkAAAAGRDFfTEQzAAQACQAAAAZEMV9MRDQABAAJAAAABkQzX1BDMQAEAAkA
    AAAGRDNfUEMyAAQACQAAAAZEM19QQzMABAAJAAAABkQzX1BDNAAEAAkAAAAGRDNfUEM1AAQA
    CQAAAAZEM19QQzYABAAJAAAABkQzX1BDNwAEAAkAAAAGRDNfUEM4AAQACQAAAAZEM19QQzkA
    BAAJAAAAB0QzX1BDMTAABAAJAAAAB0QzX1BDMTEABAAJAAAAB0QzX1BDMTIABAAJAAAAB0Qz
    X1BDMTMABAAJAAAAB0QzX1BDMTQABAAJAAAAB0QzX1BDMTUABAAJAAAAB0QzX1BDMTYABAAJ
    AAAAB0QzX1BDMTcABAAJAAAAB0QzX1BDMTgABAAJAAAAB0QzX1BDMTkABAAJAAAAB0QzX1BD
    MjAAAAD+

# classifyEmbedding works

    WAoAAAACAAQEAQACAwAAAAITAAAABAAAAxMAAAAEAAAAEAAAAGQABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAABAAAABkAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2IABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9kAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJ
    AAAABnR5cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYwAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAA
    AAZ0eXBlX2IAAAAQAAAAZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2IABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYgAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9h
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2MABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAAADgAAAGRAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAU
    AAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAA
    QBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAA
    AABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAA
    AAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAU
    AAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAA
    QBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAA
    AABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAA
    AAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAU
    AAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAA
    QBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAA
    AABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAA
    AAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAU
    AAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAA
    QBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAAAABAFAAAAAAAAEAUAAAAAAAAQBQAAAAA
    AABAFAAAAAAAAAAABAIAAAABAAQACQAAAAVuYW1lcwAAABAAAAAEAAQACQAAAAxpbnB1dF9s
    YWJlbHMABAAJAAAAFHJlc3Vic3RpdHV0ZWRfbGFiZWxzAAQACQAAABBwcmVkaWN0ZWRfbGFi
    ZWxzAAQACQAAAAFrAAAEAgAAAAEABAAJAAAACXJvdy5uYW1lcwAAABAAAABkAAQACQAAAAZj
    ZWxsXzEABAAJAAAABmNlbGxfMgAEAAkAAAAGY2VsbF8zAAQACQAAAAZjZWxsXzQABAAJAAAA
    BmNlbGxfNQAEAAkAAAAGY2VsbF82AAQACQAAAAZjZWxsXzcABAAJAAAABmNlbGxfOAAEAAkA
    AAAGY2VsbF85AAQACQAAAAdjZWxsXzEwAAQACQAAAAdjZWxsXzExAAQACQAAAAdjZWxsXzEy
    AAQACQAAAAdjZWxsXzEzAAQACQAAAAdjZWxsXzE0AAQACQAAAAdjZWxsXzE1AAQACQAAAAdj
    ZWxsXzE2AAQACQAAAAdjZWxsXzE3AAQACQAAAAdjZWxsXzE4AAQACQAAAAdjZWxsXzE5AAQA
    CQAAAAdjZWxsXzIwAAQACQAAAAdjZWxsXzIxAAQACQAAAAdjZWxsXzIyAAQACQAAAAdjZWxs
    XzIzAAQACQAAAAdjZWxsXzI0AAQACQAAAAdjZWxsXzI1AAQACQAAAAdjZWxsXzI2AAQACQAA
    AAdjZWxsXzI3AAQACQAAAAdjZWxsXzI4AAQACQAAAAdjZWxsXzI5AAQACQAAAAdjZWxsXzMw
    AAQACQAAAAdjZWxsXzMxAAQACQAAAAdjZWxsXzMyAAQACQAAAAdjZWxsXzMzAAQACQAAAAdj
    ZWxsXzM0AAQACQAAAAdjZWxsXzM1AAQACQAAAAdjZWxsXzM2AAQACQAAAAdjZWxsXzM3AAQA
    CQAAAAdjZWxsXzM4AAQACQAAAAdjZWxsXzM5AAQACQAAAAdjZWxsXzQwAAQACQAAAAdjZWxs
    XzQxAAQACQAAAAdjZWxsXzQyAAQACQAAAAdjZWxsXzQzAAQACQAAAAdjZWxsXzQ0AAQACQAA
    AAdjZWxsXzQ1AAQACQAAAAdjZWxsXzQ2AAQACQAAAAdjZWxsXzQ3AAQACQAAAAdjZWxsXzQ4
    AAQACQAAAAdjZWxsXzQ5AAQACQAAAAdjZWxsXzUwAAQACQAAAAdjZWxsXzUxAAQACQAAAAdj
    ZWxsXzUyAAQACQAAAAdjZWxsXzUzAAQACQAAAAdjZWxsXzU0AAQACQAAAAdjZWxsXzU1AAQA
    CQAAAAdjZWxsXzU2AAQACQAAAAdjZWxsXzU3AAQACQAAAAdjZWxsXzU4AAQACQAAAAdjZWxs
    XzU5AAQACQAAAAdjZWxsXzYwAAQACQAAAAdjZWxsXzYxAAQACQAAAAdjZWxsXzYyAAQACQAA
    AAdjZWxsXzYzAAQACQAAAAdjZWxsXzY0AAQACQAAAAdjZWxsXzY1AAQACQAAAAdjZWxsXzY2
    AAQACQAAAAdjZWxsXzY3AAQACQAAAAdjZWxsXzY4AAQACQAAAAdjZWxsXzY5AAQACQAAAAdj
    ZWxsXzcwAAQACQAAAAdjZWxsXzcxAAQACQAAAAdjZWxsXzcyAAQACQAAAAdjZWxsXzczAAQA
    CQAAAAdjZWxsXzc0AAQACQAAAAdjZWxsXzc1AAQACQAAAAdjZWxsXzc2AAQACQAAAAdjZWxs
    Xzc3AAQACQAAAAdjZWxsXzc4AAQACQAAAAdjZWxsXzc5AAQACQAAAAdjZWxsXzgwAAQACQAA
    AAdjZWxsXzgxAAQACQAAAAdjZWxsXzgyAAQACQAAAAdjZWxsXzgzAAQACQAAAAdjZWxsXzg0
    AAQACQAAAAdjZWxsXzg1AAQACQAAAAdjZWxsXzg2AAQACQAAAAdjZWxsXzg3AAQACQAAAAdj
    ZWxsXzg4AAQACQAAAAdjZWxsXzg5AAQACQAAAAdjZWxsXzkwAAQACQAAAAdjZWxsXzkxAAQA
    CQAAAAdjZWxsXzkyAAQACQAAAAdjZWxsXzkzAAQACQAAAAdjZWxsXzk0AAQACQAAAAdjZWxs
    Xzk1AAQACQAAAAdjZWxsXzk2AAQACQAAAAdjZWxsXzk3AAQACQAAAAdjZWxsXzk4AAQACQAA
    AAdjZWxsXzk5AAQACQAAAAhjZWxsXzEwMAAABAIAAAABAAQACQAAAAVjbGFzcwAAABAAAAAB
    AAQACQAAAApkYXRhLmZyYW1lAAAA/gAAABAAAAABAAQACQAAAAAAAAAQAAAAAAAAABAAAAAA
    AAAEAgAAAf8AAAAQAAAABAAEAAkAAAAGcmVzdWx0AAQACQAAAAZvdXRwdXQABAAJAAAACHdh
    cm5pbmdzAAQACQAAAAhtZXNzYWdlcwAAAP4=

---

    WAoAAAACAAQEAQACAwAAAAITAAAABAAAAxMAAAAEAAAAEAAAAGQABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAABAAAABkAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9j
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfZAAE
    AAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAA
    AAZ0eXBlX2IAAAAQAAAAZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2MABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9h
    AAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfZAAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAAADgAAAGRAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAA
    AAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAA
    QAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAA
    AABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAA
    AAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAA
    AAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAA
    QAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAQAAAAAAA
    AABAAAAAAAAAAEAAAAAAAAAAQAAAAAAAAABAAAAAAAAAAEAAAAAAAAAAf/AAAAAAB6J/8AAA
    AAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/w
    AAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAei
    f/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAA
    B6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAA
    AAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/w
    AAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAei
    f/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAA
    B6J/8AAAAAAHogAABAIAAAABAAQACQAAAAVuYW1lcwAAABAAAAAEAAQACQAAAAxpbnB1dF9s
    YWJlbHMABAAJAAAAFHJlc3Vic3RpdHV0ZWRfbGFiZWxzAAQACQAAABBwcmVkaWN0ZWRfbGFi
    ZWxzAAQACQAAAAFrAAAEAgAAAAEABAAJAAAACXJvdy5uYW1lcwAAABAAAABkAAQACQAAAAZj
    ZWxsXzEABAAJAAAABmNlbGxfMgAEAAkAAAAGY2VsbF8zAAQACQAAAAZjZWxsXzQABAAJAAAA
    BmNlbGxfNQAEAAkAAAAGY2VsbF82AAQACQAAAAZjZWxsXzcABAAJAAAABmNlbGxfOAAEAAkA
    AAAGY2VsbF85AAQACQAAAAdjZWxsXzEwAAQACQAAAAdjZWxsXzExAAQACQAAAAdjZWxsXzEy
    AAQACQAAAAdjZWxsXzEzAAQACQAAAAdjZWxsXzE0AAQACQAAAAdjZWxsXzE1AAQACQAAAAdj
    ZWxsXzE2AAQACQAAAAdjZWxsXzE3AAQACQAAAAdjZWxsXzE4AAQACQAAAAdjZWxsXzE5AAQA
    CQAAAAdjZWxsXzIwAAQACQAAAAdjZWxsXzIxAAQACQAAAAdjZWxsXzIyAAQACQAAAAdjZWxs
    XzIzAAQACQAAAAdjZWxsXzI0AAQACQAAAAdjZWxsXzI1AAQACQAAAAdjZWxsXzI2AAQACQAA
    AAdjZWxsXzI3AAQACQAAAAdjZWxsXzI4AAQACQAAAAdjZWxsXzI5AAQACQAAAAdjZWxsXzMw
    AAQACQAAAAdjZWxsXzMxAAQACQAAAAdjZWxsXzMyAAQACQAAAAdjZWxsXzMzAAQACQAAAAdj
    ZWxsXzM0AAQACQAAAAdjZWxsXzM1AAQACQAAAAdjZWxsXzM2AAQACQAAAAdjZWxsXzM3AAQA
    CQAAAAdjZWxsXzM4AAQACQAAAAdjZWxsXzM5AAQACQAAAAdjZWxsXzQwAAQACQAAAAdjZWxs
    XzQxAAQACQAAAAdjZWxsXzQyAAQACQAAAAdjZWxsXzQzAAQACQAAAAdjZWxsXzQ0AAQACQAA
    AAdjZWxsXzQ1AAQACQAAAAdjZWxsXzQ2AAQACQAAAAdjZWxsXzQ3AAQACQAAAAdjZWxsXzQ4
    AAQACQAAAAdjZWxsXzQ5AAQACQAAAAdjZWxsXzUwAAQACQAAAAdjZWxsXzUxAAQACQAAAAdj
    ZWxsXzUyAAQACQAAAAdjZWxsXzUzAAQACQAAAAdjZWxsXzU0AAQACQAAAAdjZWxsXzU1AAQA
    CQAAAAdjZWxsXzU2AAQACQAAAAdjZWxsXzU3AAQACQAAAAdjZWxsXzU4AAQACQAAAAdjZWxs
    XzU5AAQACQAAAAdjZWxsXzYwAAQACQAAAAdjZWxsXzYxAAQACQAAAAdjZWxsXzYyAAQACQAA
    AAdjZWxsXzYzAAQACQAAAAdjZWxsXzY0AAQACQAAAAdjZWxsXzY1AAQACQAAAAdjZWxsXzY2
    AAQACQAAAAdjZWxsXzY3AAQACQAAAAdjZWxsXzY4AAQACQAAAAdjZWxsXzY5AAQACQAAAAdj
    ZWxsXzcwAAQACQAAAAdjZWxsXzcxAAQACQAAAAdjZWxsXzcyAAQACQAAAAdjZWxsXzczAAQA
    CQAAAAdjZWxsXzc0AAQACQAAAAdjZWxsXzc1AAQACQAAAAdjZWxsXzc2AAQACQAAAAdjZWxs
    Xzc3AAQACQAAAAdjZWxsXzc4AAQACQAAAAdjZWxsXzc5AAQACQAAAAdjZWxsXzgwAAQACQAA
    AAdjZWxsXzgxAAQACQAAAAdjZWxsXzgyAAQACQAAAAdjZWxsXzgzAAQACQAAAAdjZWxsXzg0
    AAQACQAAAAdjZWxsXzg1AAQACQAAAAdjZWxsXzg2AAQACQAAAAdjZWxsXzg3AAQACQAAAAdj
    ZWxsXzg4AAQACQAAAAdjZWxsXzg5AAQACQAAAAdjZWxsXzkwAAQACQAAAAdjZWxsXzkxAAQA
    CQAAAAdjZWxsXzkyAAQACQAAAAdjZWxsXzkzAAQACQAAAAdjZWxsXzk0AAQACQAAAAdjZWxs
    Xzk1AAQACQAAAAdjZWxsXzk2AAQACQAAAAdjZWxsXzk3AAQACQAAAAdjZWxsXzk4AAQACQAA
    AAdjZWxsXzk5AAQACQAAAAhjZWxsXzEwMAAABAIAAAABAAQACQAAAAVjbGFzcwAAABAAAAAB
    AAQACQAAAApkYXRhLmZyYW1lAAAA/gAAABAAAAABAAQACQAAAAAAAAAQAAAAAQAEAAkAAAAo
    J2snIGNhcHBlZCBhdCB0aGUgbnVtYmVyIG9mIG9ic2VydmF0aW9ucwAAABAAAAA8AAQACQAA
    AAxSZXAgMSBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUK
    AAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1
    IG9mIDUKAAQACQAAAAxSZXAgMiBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAM
    Rm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAE
    AAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgMyBvZiAxMAoABAAJAAAADEZvbGQgMSBv
    ZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZv
    bGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgNCBvZiAxMAoABAAJ
    AAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2Yg
    NQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAg
    NSBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAA
    AAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUK
    AAQACQAAAAxSZXAgNiBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAy
    IG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAM
    Rm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgNyBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAE
    AAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBv
    ZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgOCBvZiAxMAoABAAJAAAADEZv
    bGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJ
    AAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgOSBvZiAx
    MAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xk
    IDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAA
    AA1SZXAgMTAgb2YgMTAKAAQACQAAAAxGb2xkIDEgb2YgNQoABAAJAAAADEZvbGQgMiBvZiA1
    CgAEAAkAAAAMRm9sZCAzIG9mIDUKAAQACQAAAAxGb2xkIDQgb2YgNQoABAAJAAAADEZvbGQg
    NSBvZiA1CgAABAIAAAH/AAAAEAAAAAQABAAJAAAABnJlc3VsdAAEAAkAAAAGb3V0cHV0AAQA
    CQAAAAh3YXJuaW5ncwAEAAkAAAAIbWVzc2FnZXMAAAD+

---

    WAoAAAACAAQFAgACAwAAAAITAAAABAAAAxMAAAAEAAAAEAAAAGQABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAABAAAABkAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9kAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAA
    AAZ0eXBlX2IAAAAQAAAAZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9h
    AAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBl
    X2MABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAAADgAAAGRACAAAAAAAAEAAAAAAAAAAQAgAAAAAAABACAAAAAAAAEAI
    AAAAAAAAQAgAAAAAAABAAAAAAAAAAEAIAAAAAAAAQAgAAAAAAABACAAAAAAAAEAIAAAAAAAA
    QAAAAAAAAABACAAAAAAAAEAIAAAAAAAAQAgAAAAAAABACAAAAAAAAEAAAAAAAAAAQAgAAAAA
    AABACAAAAAAAAEAIAAAAAAAAQAgAAAAAAABAAAAAAAAAAEAIAAAAAAAAQAgAAAAAAABACAAA
    AAAAAEAIAAAAAAAAQAAAAAAAAABACAAAAAAAAEAIAAAAAAAAQAgAAAAAAABACAAAAAAAAEAA
    AAAAAAAAQAgAAAAAAABACAAAAAAAAEAIAAAAAAAAQAgAAAAAAABAAAAAAAAAAEAIAAAAAAAA
    QAgAAAAAAABACAAAAAAAAEAIAAAAAAAAQAAAAAAAAABACAAAAAAAAEAIAAAAAAAAQAgAAAAA
    AABACAAAAAAAAEAAAAAAAAAAQAgAAAAAAABACAAAAAAAAEAIAAAAAAAAf/AAAAAAB6J/8AAA
    AAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/w
    AAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAei
    f/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAA
    B6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAA
    AAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/w
    AAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAei
    f/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAAB6J/8AAAAAAHon/wAAAAAAeif/AAAAAA
    B6J/8AAAAAAHogAABAIAAAABAAQACQAAAAVuYW1lcwAAABAAAAAEAAQACQAAAAxpbnB1dF9s
    YWJlbHMABAAJAAAAFHJlc3Vic3RpdHV0ZWRfbGFiZWxzAAQACQAAABBwcmVkaWN0ZWRfbGFi
    ZWxzAAQACQAAAAFrAAAEAgAAAAEABAAJAAAACXJvdy5uYW1lcwAAABAAAABkAAQACQAAAAZj
    ZWxsXzEABAAJAAAABmNlbGxfMgAEAAkAAAAGY2VsbF8zAAQACQAAAAZjZWxsXzQABAAJAAAA
    BmNlbGxfNQAEAAkAAAAGY2VsbF82AAQACQAAAAZjZWxsXzcABAAJAAAABmNlbGxfOAAEAAkA
    AAAGY2VsbF85AAQACQAAAAdjZWxsXzEwAAQACQAAAAdjZWxsXzExAAQACQAAAAdjZWxsXzEy
    AAQACQAAAAdjZWxsXzEzAAQACQAAAAdjZWxsXzE0AAQACQAAAAdjZWxsXzE1AAQACQAAAAdj
    ZWxsXzE2AAQACQAAAAdjZWxsXzE3AAQACQAAAAdjZWxsXzE4AAQACQAAAAdjZWxsXzE5AAQA
    CQAAAAdjZWxsXzIwAAQACQAAAAdjZWxsXzIxAAQACQAAAAdjZWxsXzIyAAQACQAAAAdjZWxs
    XzIzAAQACQAAAAdjZWxsXzI0AAQACQAAAAdjZWxsXzI1AAQACQAAAAdjZWxsXzI2AAQACQAA
    AAdjZWxsXzI3AAQACQAAAAdjZWxsXzI4AAQACQAAAAdjZWxsXzI5AAQACQAAAAdjZWxsXzMw
    AAQACQAAAAdjZWxsXzMxAAQACQAAAAdjZWxsXzMyAAQACQAAAAdjZWxsXzMzAAQACQAAAAdj
    ZWxsXzM0AAQACQAAAAdjZWxsXzM1AAQACQAAAAdjZWxsXzM2AAQACQAAAAdjZWxsXzM3AAQA
    CQAAAAdjZWxsXzM4AAQACQAAAAdjZWxsXzM5AAQACQAAAAdjZWxsXzQwAAQACQAAAAdjZWxs
    XzQxAAQACQAAAAdjZWxsXzQyAAQACQAAAAdjZWxsXzQzAAQACQAAAAdjZWxsXzQ0AAQACQAA
    AAdjZWxsXzQ1AAQACQAAAAdjZWxsXzQ2AAQACQAAAAdjZWxsXzQ3AAQACQAAAAdjZWxsXzQ4
    AAQACQAAAAdjZWxsXzQ5AAQACQAAAAdjZWxsXzUwAAQACQAAAAdjZWxsXzUxAAQACQAAAAdj
    ZWxsXzUyAAQACQAAAAdjZWxsXzUzAAQACQAAAAdjZWxsXzU0AAQACQAAAAdjZWxsXzU1AAQA
    CQAAAAdjZWxsXzU2AAQACQAAAAdjZWxsXzU3AAQACQAAAAdjZWxsXzU4AAQACQAAAAdjZWxs
    XzU5AAQACQAAAAdjZWxsXzYwAAQACQAAAAdjZWxsXzYxAAQACQAAAAdjZWxsXzYyAAQACQAA
    AAdjZWxsXzYzAAQACQAAAAdjZWxsXzY0AAQACQAAAAdjZWxsXzY1AAQACQAAAAdjZWxsXzY2
    AAQACQAAAAdjZWxsXzY3AAQACQAAAAdjZWxsXzY4AAQACQAAAAdjZWxsXzY5AAQACQAAAAdj
    ZWxsXzcwAAQACQAAAAdjZWxsXzcxAAQACQAAAAdjZWxsXzcyAAQACQAAAAdjZWxsXzczAAQA
    CQAAAAdjZWxsXzc0AAQACQAAAAdjZWxsXzc1AAQACQAAAAdjZWxsXzc2AAQACQAAAAdjZWxs
    Xzc3AAQACQAAAAdjZWxsXzc4AAQACQAAAAdjZWxsXzc5AAQACQAAAAdjZWxsXzgwAAQACQAA
    AAdjZWxsXzgxAAQACQAAAAdjZWxsXzgyAAQACQAAAAdjZWxsXzgzAAQACQAAAAdjZWxsXzg0
    AAQACQAAAAdjZWxsXzg1AAQACQAAAAdjZWxsXzg2AAQACQAAAAdjZWxsXzg3AAQACQAAAAdj
    ZWxsXzg4AAQACQAAAAdjZWxsXzg5AAQACQAAAAdjZWxsXzkwAAQACQAAAAdjZWxsXzkxAAQA
    CQAAAAdjZWxsXzkyAAQACQAAAAdjZWxsXzkzAAQACQAAAAdjZWxsXzk0AAQACQAAAAdjZWxs
    Xzk1AAQACQAAAAdjZWxsXzk2AAQACQAAAAdjZWxsXzk3AAQACQAAAAdjZWxsXzk4AAQACQAA
    AAdjZWxsXzk5AAQACQAAAAhjZWxsXzEwMAAABAIAAAABAAQACQAAAAVjbGFzcwAAABAAAAAB
    AAQACQAAAApkYXRhLmZyYW1lAAAA/gAAABAAAAABAAQACQAAAAAAAAAQAAAAAAAAABAAAAA8
    AAQACQAAAAxSZXAgMSBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAy
    IG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAM
    Rm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgMiBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAE
    AAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBv
    ZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgMyBvZiAxMAoABAAJAAAADEZv
    bGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJ
    AAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgNCBvZiAx
    MAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xk
    IDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAA
    AAxSZXAgNSBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUK
    AAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1
    IG9mIDUKAAQACQAAAAxSZXAgNiBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAM
    Rm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAE
    AAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgNyBvZiAxMAoABAAJAAAADEZvbGQgMSBv
    ZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2YgNQoABAAJAAAADEZv
    bGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAgOCBvZiAxMAoABAAJ
    AAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAAAAxGb2xkIDMgb2Yg
    NQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUKAAQACQAAAAxSZXAg
    OSBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiA1CgAEAAkAAAAMRm9sZCAyIG9mIDUKAAQACQAA
    AAxGb2xkIDMgb2YgNQoABAAJAAAADEZvbGQgNCBvZiA1CgAEAAkAAAAMRm9sZCA1IG9mIDUK
    AAQACQAAAA1SZXAgMTAgb2YgMTAKAAQACQAAAAxGb2xkIDEgb2YgNQoABAAJAAAADEZvbGQg
    MiBvZiA1CgAEAAkAAAAMRm9sZCAzIG9mIDUKAAQACQAAAAxGb2xkIDQgb2YgNQoABAAJAAAA
    DEZvbGQgNSBvZiA1CgAABAIAAAH/AAAAEAAAAAQABAAJAAAABnJlc3VsdAAEAAkAAAAGb3V0
    cHV0AAQACQAAAAh3YXJuaW5ncwAEAAkAAAAIbWVzc2FnZXMAAAD+

---

    WAoAAAACAAQEAQACAwAAAAITAAAABAAAAxMAAAAEAAAAEAAAAGQABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAA
    AAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////
    AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf//
    //8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ/////wAAAAn/////AAAACf////8AAAAJ
    /////wAAABAAAABkAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9kAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfZAAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9l
    AAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBl
    X2QABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAA
    AAZ0eXBlX2IAAAAQAAAAZAAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5
    cGVfYwAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAG
    dHlwZV9iAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAA
    AAZ0eXBlX2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAE
    AAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9i
    AAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2EABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5
    cGVfZQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAG
    dHlwZV9kAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJ
    AAAABnR5cGVfYgAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfZQAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9k
    AAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBl
    X2UABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYgAEAAkAAAAG
    dHlwZV9hAAQACQAAAAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAA
    AAZ0eXBlX2QABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9kAAQACQAAAAZ0eXBlX2QABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAE
    AAkAAAAGdHlwZV9hAAQACQAAAAZ0eXBlX2MABAAJAAAABnR5cGVfYgAEAAkAAAAGdHlwZV9h
    AAQACQAAAAZ0eXBlX2IABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBl
    X2MABAAJAAAABnR5cGVfYwAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5
    cGVfZAAEAAkAAAAGdHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZAAEAAkAAAAG
    dHlwZV9lAAQACQAAAAZ0eXBlX2EABAAJAAAABnR5cGVfZQAEAAkAAAAGdHlwZV9iAAQACQAA
    AAZ0eXBlX2MABAAJAAAABnR5cGVfYQAEAAkAAAAGdHlwZV9iAAQACQAAAAZ0eXBlX2IABAAJ
    AAAABnR5cGVfYQAEAAkAAAAGdHlwZV9jAAQACQAAAAZ0eXBlX2UABAAJAAAABnR5cGVfYQAE
    AAkAAAAGdHlwZV9iAAAADQAAAGQAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAA
    AAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAAD
    AAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAA
    AAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAAD
    AAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAA
    AAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAAD
    AAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAA
    AAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAAAwAAAAMAAAADAAAEAgAAAAEABAAJ
    AAAABW5hbWVzAAAAEAAAAAQABAAJAAAADGlucHV0X2xhYmVscwAEAAkAAAAUcmVzdWJzdGl0
    dXRlZF9sYWJlbHMABAAJAAAAEHByZWRpY3RlZF9sYWJlbHMABAAJAAAAAWsAAAQCAAAAAQAE
    AAkAAAAJcm93Lm5hbWVzAAAAEAAAAGQABAAJAAAABmNlbGxfMQAEAAkAAAAGY2VsbF8yAAQA
    CQAAAAZjZWxsXzMABAAJAAAABmNlbGxfNAAEAAkAAAAGY2VsbF81AAQACQAAAAZjZWxsXzYA
    BAAJAAAABmNlbGxfNwAEAAkAAAAGY2VsbF84AAQACQAAAAZjZWxsXzkABAAJAAAAB2NlbGxf
    MTAABAAJAAAAB2NlbGxfMTEABAAJAAAAB2NlbGxfMTIABAAJAAAAB2NlbGxfMTMABAAJAAAA
    B2NlbGxfMTQABAAJAAAAB2NlbGxfMTUABAAJAAAAB2NlbGxfMTYABAAJAAAAB2NlbGxfMTcA
    BAAJAAAAB2NlbGxfMTgABAAJAAAAB2NlbGxfMTkABAAJAAAAB2NlbGxfMjAABAAJAAAAB2Nl
    bGxfMjEABAAJAAAAB2NlbGxfMjIABAAJAAAAB2NlbGxfMjMABAAJAAAAB2NlbGxfMjQABAAJ
    AAAAB2NlbGxfMjUABAAJAAAAB2NlbGxfMjYABAAJAAAAB2NlbGxfMjcABAAJAAAAB2NlbGxf
    MjgABAAJAAAAB2NlbGxfMjkABAAJAAAAB2NlbGxfMzAABAAJAAAAB2NlbGxfMzEABAAJAAAA
    B2NlbGxfMzIABAAJAAAAB2NlbGxfMzMABAAJAAAAB2NlbGxfMzQABAAJAAAAB2NlbGxfMzUA
    BAAJAAAAB2NlbGxfMzYABAAJAAAAB2NlbGxfMzcABAAJAAAAB2NlbGxfMzgABAAJAAAAB2Nl
    bGxfMzkABAAJAAAAB2NlbGxfNDAABAAJAAAAB2NlbGxfNDEABAAJAAAAB2NlbGxfNDIABAAJ
    AAAAB2NlbGxfNDMABAAJAAAAB2NlbGxfNDQABAAJAAAAB2NlbGxfNDUABAAJAAAAB2NlbGxf
    NDYABAAJAAAAB2NlbGxfNDcABAAJAAAAB2NlbGxfNDgABAAJAAAAB2NlbGxfNDkABAAJAAAA
    B2NlbGxfNTAABAAJAAAAB2NlbGxfNTEABAAJAAAAB2NlbGxfNTIABAAJAAAAB2NlbGxfNTMA
    BAAJAAAAB2NlbGxfNTQABAAJAAAAB2NlbGxfNTUABAAJAAAAB2NlbGxfNTYABAAJAAAAB2Nl
    bGxfNTcABAAJAAAAB2NlbGxfNTgABAAJAAAAB2NlbGxfNTkABAAJAAAAB2NlbGxfNjAABAAJ
    AAAAB2NlbGxfNjEABAAJAAAAB2NlbGxfNjIABAAJAAAAB2NlbGxfNjMABAAJAAAAB2NlbGxf
    NjQABAAJAAAAB2NlbGxfNjUABAAJAAAAB2NlbGxfNjYABAAJAAAAB2NlbGxfNjcABAAJAAAA
    B2NlbGxfNjgABAAJAAAAB2NlbGxfNjkABAAJAAAAB2NlbGxfNzAABAAJAAAAB2NlbGxfNzEA
    BAAJAAAAB2NlbGxfNzIABAAJAAAAB2NlbGxfNzMABAAJAAAAB2NlbGxfNzQABAAJAAAAB2Nl
    bGxfNzUABAAJAAAAB2NlbGxfNzYABAAJAAAAB2NlbGxfNzcABAAJAAAAB2NlbGxfNzgABAAJ
    AAAAB2NlbGxfNzkABAAJAAAAB2NlbGxfODAABAAJAAAAB2NlbGxfODEABAAJAAAAB2NlbGxf
    ODIABAAJAAAAB2NlbGxfODMABAAJAAAAB2NlbGxfODQABAAJAAAAB2NlbGxfODUABAAJAAAA
    B2NlbGxfODYABAAJAAAAB2NlbGxfODcABAAJAAAAB2NlbGxfODgABAAJAAAAB2NlbGxfODkA
    BAAJAAAAB2NlbGxfOTAABAAJAAAAB2NlbGxfOTEABAAJAAAAB2NlbGxfOTIABAAJAAAAB2Nl
    bGxfOTMABAAJAAAAB2NlbGxfOTQABAAJAAAAB2NlbGxfOTUABAAJAAAAB2NlbGxfOTYABAAJ
    AAAAB2NlbGxfOTcABAAJAAAAB2NlbGxfOTgABAAJAAAAB2NlbGxfOTkABAAJAAAACGNlbGxf
    MTAwAAAEAgAAAAEABAAJAAAABWNsYXNzAAAAEAAAAAEABAAJAAAACmRhdGEuZnJhbWUAAAD+
    AAAAEAAAAAEABAAJAAAAAAAAABAAAAAAAAAAEAAAACgABAAJAAAADFJlcCAxIG9mIDEwCgAE
    AAkAAAAMRm9sZCAxIG9mIDMKAAQACQAAAAxGb2xkIDIgb2YgMwoABAAJAAAADEZvbGQgMyBv
    ZiAzCgAEAAkAAAAMUmVwIDIgb2YgMTAKAAQACQAAAAxGb2xkIDEgb2YgMwoABAAJAAAADEZv
    bGQgMiBvZiAzCgAEAAkAAAAMRm9sZCAzIG9mIDMKAAQACQAAAAxSZXAgMyBvZiAxMAoABAAJ
    AAAADEZvbGQgMSBvZiAzCgAEAAkAAAAMRm9sZCAyIG9mIDMKAAQACQAAAAxGb2xkIDMgb2Yg
    MwoABAAJAAAADFJlcCA0IG9mIDEwCgAEAAkAAAAMRm9sZCAxIG9mIDMKAAQACQAAAAxGb2xk
    IDIgb2YgMwoABAAJAAAADEZvbGQgMyBvZiAzCgAEAAkAAAAMUmVwIDUgb2YgMTAKAAQACQAA
    AAxGb2xkIDEgb2YgMwoABAAJAAAADEZvbGQgMiBvZiAzCgAEAAkAAAAMRm9sZCAzIG9mIDMK
    AAQACQAAAAxSZXAgNiBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiAzCgAEAAkAAAAMRm9sZCAy
    IG9mIDMKAAQACQAAAAxGb2xkIDMgb2YgMwoABAAJAAAADFJlcCA3IG9mIDEwCgAEAAkAAAAM
    Rm9sZCAxIG9mIDMKAAQACQAAAAxGb2xkIDIgb2YgMwoABAAJAAAADEZvbGQgMyBvZiAzCgAE
    AAkAAAAMUmVwIDggb2YgMTAKAAQACQAAAAxGb2xkIDEgb2YgMwoABAAJAAAADEZvbGQgMiBv
    ZiAzCgAEAAkAAAAMRm9sZCAzIG9mIDMKAAQACQAAAAxSZXAgOSBvZiAxMAoABAAJAAAADEZv
    bGQgMSBvZiAzCgAEAAkAAAAMRm9sZCAyIG9mIDMKAAQACQAAAAxGb2xkIDMgb2YgMwoABAAJ
    AAAADVJlcCAxMCBvZiAxMAoABAAJAAAADEZvbGQgMSBvZiAzCgAEAAkAAAAMRm9sZCAyIG9m
    IDMKAAQACQAAAAxGb2xkIDMgb2YgMwoAAAQCAAAB/wAAABAAAAAEAAQACQAAAAZyZXN1bHQA
    BAAJAAAABm91dHB1dAAEAAkAAAAId2FybmluZ3MABAAJAAAACG1lc3NhZ2VzAAAA/g==

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAdaptiveK.R
\name{getAdaptiveK}
\alias{getAdaptiveK}
\title{Adaptive k selection for KNN classification}
\usage{
getAdaptiveK(E, labels = NULL, local = NULL, outputPerCell = TRUE, ...)
}
\arguments{
\item{E}{An error matrix with rows corresponding to cells and columns
corresponding to candidate k values, with values themselves corresponding to
error values (either binary for single classification, or continuous after
multiple classification).}

\item{labels}{Group labels for cells.}

\item{local}{A neighbourhood index representation, as typically output using
BiocNeighbors::findKNN().}

\item{outputPerCell}{Logical whether to return adaptive k for each cell, not
just for each label type (used for when labels is given).}

\item{...}{Includes return_colnames, whether to give the colnames of the best
selected, or just the index, which is default TRUE.}
}
\value{
Vector of adaptive k values.
}
\description{
Given an error matrix, identify the k that maximises the accuracy for cells
belonging to a provided labelling/grouping. If no labelling given, expect a
cell-cell similarity network to identify the k that maximises the accuracy
for cells within that neighbourhood. If neither are given, simply treat all
cells as if they have the same labelling/grouping
}
\examples{
E <- matrix(runif(100), 20, 5)
colnames(E) <- paste0("K_", 1:5)

# generate cell labels
labels <- factor(rep(letters[1:2], each = 10))

# generate nearest neighbourhood index representation
data <- matrix(rpois(10 * 20, 10), 10, 20) # 10 genes, 20 cells
local <- BiocNeighbors::findKNN(t(data), k = 5, get.distance = FALSE)$index

best_k_labels <- getAdaptiveK(E,
  labels = labels
)
best_k_local <- getAdaptiveK(E,
  local = local
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mosaicDataUpSet.R
\name{mosaicDataUpSet}
\alias{mosaicDataUpSet}
\title{mosaicDataUpSet}
\usage{
mosaicDataUpSet(assay_list, plot = FALSE, ...)
}
\arguments{
\item{assay_list}{a list of data matrices with rownames (features) specified.}

\item{plot}{logical (default FALSE) whether the UpSet plot should be printed.}

\item{...}{further arguments passed to `upset` from the `UpSetR` package.}
}
\value{
UpSet object displaying degree of overlap of rownames (features)
among each of the data matrices in \code{assay_list}. Set bars correspond to
the number of cells/samples present in each data matrix.
}
\description{
Plots feature overlaps of mosaic data as an UpSet plot.
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
lapply(assay_list, dim)
mosaicDataUpSet(assay_list)

# additional arguments from UpSetR::upset()
mosaicDataUpSet(assay_list, empty.intersections = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{combineBinaryErrors}
\alias{combineBinaryErrors}
\title{combineBinaryErrors}
\usage{
combineBinaryErrors(E_list)
}
\arguments{
\item{E_list}{A list containing matrices. Each matrix must have the same
number of columns (k-values) and contain rownames (cells).}
}
\value{
A sparse error matrix.
}
\description{
Combines binary error matrices by averaging error values across all matrices,
for each entry (row and column combination)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runOps.R
\name{.runOps}
\alias{.runOps}
\title{Run a sequence of binary operations}
\usage{
.runOps(obj, ops, leftToRight = TRUE)
}
\arguments{
\item{obj}{list of objects.}

\item{ops}{list of operations (length should be 1 less than `obj`).}

\item{leftToRight}{logical whether operations should be performed in order
from left to right (default), or right to left.}
}
\value{
matrix or array output of the sequence of binary operations
}
\description{
Run a sequence of binary operations
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getArgMin}
\alias{getArgMin}
\title{getArgMin}
\usage{
getArgMin(M, return_colnames = TRUE, identicalNA = TRUE)
}
\arguments{
\item{M}{A matrix.}

\item{return_colnames}{Logical whether to return column names of matrix
(default TRUE). Otherwise return index.}

\item{identicalNA}{Logical whether to return NA if all values in a row are
identical (default TRUE).}
}
\value{
A vector containing the first index or column name of the
minimum values for each row of the matrix.
}
\description{
For each row in a matrix calculate the first index which gives the minimum
value
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/imputeEmbedding.R
\name{imputeEmbedding}
\alias{imputeEmbedding}
\title{Impute values using StabMap joint embedding}
\usage{
imputeEmbedding(
  assay_list,
  embedding,
  reference = Reduce(union, lapply(assay_list, colnames)),
  query = Reduce(union, lapply(assay_list, colnames)),
  neighbours = 5,
  fun = mean
)
}
\arguments{
\item{assay_list}{List of mosaic data from which to perform imputation.}

\item{embedding}{Joint embedding from which to extract nearest neighbour
relationships.}

\item{reference}{Character vector of cell names to treat as reference cells.}

\item{query}{Character vector of cell names to treat as query cells.}

\item{neighbours}{Number of nearest neighbours to consider (default 5).}

\item{fun}{function (default `mean`) to aggregate nearest neighbours'
imputed values.}
}
\value{
List containing imputed values from each assay_list
data matrix which contains reference cells.
}
\description{
Performs naive imputation of values from the list of mosaic data
and joint embedding from StabMap.
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
lapply(assay_list, dim)

# stabMap
out <- stabMap(assay_list,
  ncomponentsReference = 20,
  ncomponentsSubset = 20
)

# impute values
imp <- imputeEmbedding(assay_list, out)

# inspect the imputed values
lapply(imp, dim)
imp[[1]][1:5, 1:5]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getModeFirst}
\alias{getModeFirst}
\title{getModeFirst}
\usage{
getModeFirst(x, first)
}
\arguments{
\item{x}{A character or a factor.}

\item{first}{An integer.}
}
\value{
A character of the mode of x.
}
\description{
Identify the mode of x up to the first index
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getBinaryErrorFromPredictions}
\alias{getBinaryErrorFromPredictions}
\title{getBinaryErrorFromPredictions}
\usage{
getBinaryErrorFromPredictions(pred, labels)
}
\arguments{
\item{pred}{Is a matrix of class label predictions.}

\item{labels}{Is a named vector of true labels.}
}
\value{
A sparse binary error matrix.
}
\description{
Compute binary error between predicted labels and true labels
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grapes-projpred-grapes.R
\name{\%projpred\%}
\alias{\%projpred\%}
\title{Project and/or predict data using feature weights or a LDA model object}
\usage{
a \%projpred\% b
}
\arguments{
\item{a}{a matrix with colnames specified}

\item{b}{a matrix with rownames specified, or a lda model object, or a
list containing a matrix and/or a lda model object.}
}
\value{
matrix
}
\description{
This function takes a data matrix a and, depending on the class of b,
projects the data using feature weights, or predicts new values using
linear discriminant analysis (LDA) model object, or both.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{buildLabelsDataFrame}
\alias{buildLabelsDataFrame}
\title{buildLabelsDataFrame}
\usage{
buildLabelsDataFrame(labels, resubstituted_labels, k_adaptive)
}
\arguments{
\item{labels}{Is a named character vector with true labels.}

\item{resubstituted_labels}{Is a named character vector with predicted
labels.}

\item{k_adaptive}{Is a named vector of the k-values, this could be a single
integer when fixed.}
}
\value{
A dataframe with rows the same as resubstituted_labels and columns
for input_labels, predicted_labels, and resubstituted_labels.
}
\description{
Build dataframe for output from `classifyEmbedding`
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{allEqual}
\alias{allEqual}
\title{allEqual}
\usage{
allEqual(x)
}
\arguments{
\item{x}{A vector.}
}
\value{
logical whether a a vector is equal to its first element.
}
\description{
Checks if a vector is equal to its first element
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{isUnequal}
\alias{isUnequal}
\title{isUnequal}
\usage{
isUnequal(x, y)
}
\arguments{
\item{x}{A vector.}

\item{y}{A vector.}
}
\value{
An integer vector. 1 for unequal. 0 for equal
}
\description{
Checks if elements of 2 vectors are unequal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding.R
\name{classifyEmbedding}
\alias{classifyEmbedding}
\title{Adaptive k-Nearest Neighbour Classification using the StabMap joint embedding}
\usage{
classifyEmbedding(
  coords,
  labels,
  type = c("uniform_fixed", "adaptive_labels", "adaptive_local", "uniform_optimised"),
  k_values = 5,
  error_measure = c("simple_error", "balanced_error"),
  adaptive_nFold = 2,
  adaptive_nRep = 5,
  adaptive_local_nhood = 100,
  adaptive_local_smooth = 10,
  verbose = TRUE
)
}
\arguments{
\item{coords}{A cells (rows) x dimensions data matrix, on which euclidean
distances are to be calculated for KNN classification. Must have rownames.
Typically, output from `stabMap()`.}

\item{labels}{A named character vector of labels for the training set.}

\item{type}{A character of the type of adaptive KNN classification to be
used. Must be one of "adaptive_local", "adaptive_labels",
"uniform_optimised", or "uniform_fixed". Default
is "uniform_fixed".}

\item{k_values}{A numeric vector of potential k values. If type is
"uniform_fixed", then the first value of k_values is used. Default is 5.}

\item{error_measure}{Is the error type to use for selection of the best k.
Must be one of "simple_error" or "balanced_error". "simple_error" weights all
cells equally. "balanced_error" weights error by `labels` factors. Only
affects error type for type == "uniform_optimised".}

\item{adaptive_nFold}{Is the number of folds for adaptive selection
cross-validation.}

\item{adaptive_nRep}{Is the number of repetitions of adaptive selection
cross-validation.}

\item{adaptive_local_nhood}{Is the neighbourhood size for optimising locally.}

\item{adaptive_local_smooth}{Is the number of neighbours to use for smoothing
locally.}

\item{verbose}{Logical whether to print repetition and fold number for
adaptive selection cross-validation.}
}
\value{
Is a dataframe with rows the same as coords, and same rownames.
Columns are: input_labels is the training labels that were provided in
`labels` (NA is used as labels for the testing set), resubstituted_labels is
predicted labels for all rows (including for the training data),
predicted_labels is predicted labels for the testing set but true labels as
provided in `labels` for the training set, k is the adaptive k value used for
that each row of the training set.
}
\description{
Performs adaptive k-nearest neighbour classification of discrete labels for a
training set from a query set, leveraging the StabMap joint embedding. The
training labels are defined in `labels`, with all other rows of the
embedding treated as the testing set.
}
\examples{
set.seed(100)
# Simulate coordinates
coords <- matrix(rnorm(1000), 100, 10)
rownames(coords) <- paste0("cell_", seq_len(nrow(coords)))

# Define labels of the first 50 cells
labels <- rep(paste0("type_", letters[1:5]), 10)
names(labels) <- rownames(coords)[seq_along(labels)]

# Uniform fixed KNN classification
knn_out <- classifyEmbedding(
  coords, labels,
  type = "uniform_fixed", k_values = 5
)
table(knn_out$predicted_labels)

# Adaptive KNN classification using local error
knn_out <- classifyEmbedding(
coords, labels,
type = "adaptive_local",
k_values = 2:3,
adaptive_nFold = 5,
adaptive_nRep = 10
)
table(knn_out$predicted_labels)

knn_out <- classifyEmbedding(
  coords, labels,
  type = "adaptive_labels",
  k_values = 2:3,
  adaptive_nFold = 5,
  adaptive_nRep = 10
)
table(knn_out$predicted_labels)

# Adaptive KNN classification using uniform optimised with balanced error
knn_out <- classifyEmbedding(
  coords, labels,
  type = "uniform_optimised",
  k_values = 2:3,
  adaptive_nFold = 3,
  adaptive_nRep = 10,
  error_measure = "balanced_error"
)
table(knn_out$predicted_labels)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mosaicDataTopology.R
\name{mosaicDataTopology}
\alias{mosaicDataTopology}
\title{mosaicDataTopology}
\usage{
mosaicDataTopology(assay_list)
}
\arguments{
\item{assay_list}{a list of data matrices with rownames (features) specified.}
}
\value{
igraph weighted network with nodes corresponding to
\code{assay_list} elements, and edges present if the matrices share at
least one rowname. Edge weights correspond to the number of shared
rownames among data matrices.
}
\description{
Generate mosaic data topology network as an igraph object.
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
mdt <- mosaicDataTopology(assay_list)
mdt
plot(mdt)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stabMap.R
\name{stabMap}
\alias{stabMap}
\title{Stabilised mosaic single cell data integration using unshared features}
\usage{
stabMap(
  assay_list,
  labels_list = NULL,
  reference_list = NULL,
  reference_features_list = lapply(assay_list, rownames),
  reference_scores_list = NULL,
  ncomponentsReference = 50,
  ncomponentsSubset = 50,
  suppressMessages = TRUE,
  projectAll = FALSE,
  restrictFeatures = FALSE,
  maxFeatures = 1000,
  plot = TRUE,
  scale.center = TRUE,
  scale.scale = TRUE,
  SE_assay_names = "logcounts",
  BPPARAM = SerialParam(),
  verbose = TRUE
)
}
\arguments{
\item{assay_list}{A list of data matrices with rownames (features) specified.}

\item{labels_list}{(optional) named list containing cell labels}

\item{reference_list}{Named list containing logical values whether the data
matrix should be considered as a reference dataset, alternatively a
character vector containing the names of the reference data matrices. If
NULL, defaults to:
 sapply(names(assay_list), function(x) TRUE, simplify = FALSE)}

\item{reference_features_list}{List of features to consider as reference data
(default is all available features).}

\item{reference_scores_list}{Named list of reference scores (default NULL).
If provided, matrix of cells (rows with rownames given) and dimensions
(columns with colnames given) are used as the reference low-dimensional
embedding to target, as opposed to performing PCA or LDA on the input
reference data.}

\item{ncomponentsReference}{Number of principal components for embedding
reference data, given either as an integer or a named list for each
reference dataset.}

\item{ncomponentsSubset}{Number of principal components for embedding query
data prior to projecting to the reference, given either as an integer or a
named list for each reference dataset.}

\item{suppressMessages}{Logical whether to suppress messages (default TRUE).}

\item{projectAll}{Logical whether to re-project reference data along with
query (default FALSE).}

\item{restrictFeatures}{logical whether to restrict to features used in
dimensionality reduction of reference data (default FALSE). Overall it's
recommended that this be FALSE for single-hop integrations and TRUE for
multi-hop integrations.}

\item{maxFeatures}{Maximum number of features to consider for predicting
principal component scores (default 1000).}

\item{plot}{Logical whether to plot mosaic data UpSet plot and mosaic data
topology networks (default TRUE).}

\item{scale.center}{Logical whether to re-center data to a mean of 0 (default
FALSE).}

\item{scale.scale}{Logical whether to re-scale data to standard deviation of
1 (default FALSE).}

\item{SE_assay_names}{Either a string indicating the name of the assays for
the SummarizedExperiment objects in assay_list or a named list of assay
names, where the names corrispond to the names SE objects in assay_list
(default "logcounts")}

\item{BPPARAM}{a BiocParallelParam object specifying how parallelisation
should be performed}

\item{verbose}{Logical whether console output is provided (default TRUE)}
}
\value{
matrix containing common embedding with rows corresponding to cells,
and columns corresponding to PCs or LDs for reference dataset(s).
}
\description{
stabMap performs mosaic data integration by first building a mosaic data
topology, and for each reference dataset, traverses the topology to
project and predict data onto a common principal component (PC) or linear
discriminant (LD) embedding.
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
lapply(assay_list, dim)

# specify which datasets to use as reference coordinates
reference_list <- c("D1", "D3")

# specify some sample labels to distinguish using linear discriminant
# analysis (LDA)
labels_list <- list(
  D1 = rep(letters[1:5], length.out = ncol(assay_list[["D1"]]))
)

# examine the topology of this mosaic data integration
mosaicDataUpSet(assay_list)
plot(mosaicDataTopology(assay_list))

# stabMap
out <- stabMap(assay_list,
  reference_list = reference_list,
  labels_list = labels_list,
  ncomponentsReference = 20,
  ncomponentsSubset = 20
)

head(out)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grapes-pred-grapes.R
\name{\%pred\%}
\alias{\%pred\%}
\title{Binary operator for model predictions on data}
\usage{
data \%pred\% models
}
\arguments{
\item{data}{is a matrix with rows corresponding to features, and columns
corresponding to cells/observations}

\item{models}{is a list of univariate outcome models with the features as
explanatory variables}
}
\value{
a matrix with rows equal to \code{length(models)} and columns
corresponding to cells/observations
}
\description{
This function performs model predictions via the \code{predict} function
for each column of data.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{smoothLocal}
\alias{smoothLocal}
\title{smoothLocal}
\usage{
smoothLocal(best_k, local, smooth = 10, mean_type = "geometric")
}
\arguments{
\item{best_k}{Is a named vector of local best k values}

\item{local}{Is a KNN matrix, with rows same as best_k and values indices of
best_k.}

\item{smooth}{An integer of k-nearest neighbours to smooth over.}

\item{mean_type}{Character indicating to calculate the 'geometric' or
'arithmetic' mean.}
}
\value{
A numeric vector of smoothed adaptive k-values.
}
\description{
Smooth out the adaptive k values. Can be smoothed by computing the
arithmetic or geometric mean of the adaptive k-values for each cells
neighbourhood
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stabMap_utils.R
\name{selectFeatures}
\alias{selectFeatures}
\title{selectFeatures}
\usage{
selectFeatures(assay, features, maxFeatures)
}
\arguments{
\item{assay}{An assay matrix rows are features, columns are cells}

\item{features}{Character vector of the current features that are selected}

\item{maxFeatures}{Integer of the number of maxFeatures to select}
}
\value{
A character vector of the selected features according to variance
ranking.
}
\description{
For a given assay and set of features, perform variance ranking and select
a subset of features
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getBestColumn}
\alias{getBestColumn}
\title{getBestColumn}
\usage{
getBestColumn(E, balanced_labels = NULL)
}
\arguments{
\item{E}{An error matrix.}

\item{balanced_labels}{Class labels for each row (cell) of E.}
}
\value{
The index of the best performing column of E
}
\description{
Identifies the index of the column of a matrix with the minimum mean.
If balanced_labels is given then calculate the balanced mean
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reWeightEmbedding.R
\name{reWeightEmbedding}
\alias{reWeightEmbedding}
\title{Re-weight StabMap embedding}
\usage{
reWeightEmbedding(embedding, weights = NULL, factor = 1e+06)
}
\arguments{
\item{embedding}{Joint embedding as output from stabMap.}

\item{weights}{(optional) named numeric vector giving relative weights for
each reference dataset.}

\item{factor}{numeric multiplicative value to offset near-zero values.}
}
\value{
matrix of same dimensions as `embedding`.
}
\description{
Re-weights embedding according to given weights for each reference dataset.
This gives more or less weighting to each contributing dataset and method
(PCA or LDA),
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
lapply(assay_list, dim)

# specify which datasets to use as reference coordinates
reference_list <- c("D1", "D3")

# specify some sample labels to distinguish using linear discriminant
# analysis (LDA)
labels_list <- list(
  D1 = rep(letters[1:5], length.out = ncol(assay_list[["D1"]]))
)

# stabMap
out <- stabMap(assay_list,
  reference_list = reference_list,
  labels_list = labels_list,
  ncomponentsReference = 20,
  ncomponentsSubset = 20
)

# look at the scale of each component and discriminant
boxplot(out, las = 2, outline = FALSE)

# re-weight embedding for less contribution from LDs and equal contribution
# from PCs of both references
out_reweighted <- reWeightEmbedding(
  out,
  weights = c("D1_LD" = 0.5, "D1_PC" = 1, "D3_PC" = 1)
)

# look at the new scale of each component and discriminant
boxplot(out_reweighted, las = 2, outline = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grapes-times-times-grapes.R
\name{\%**\%}
\alias{\%**\%}
\title{Sorted matrix multiplication}
\usage{
X \%**\% Y
}
\arguments{
\item{X}{a matrix with colnames specified.}

\item{Y}{a matrix with rownames specified. Alternatively, a list assumed to
contain two objects, a matrix with rownames specified, and a vector of
scaling values for subtraction.}
}
\value{
matrix
}
\description{
This function multiplies two matrices but first reorders the rows of the
second matrix to match the columns of the first matrix
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grapes-times-1-grapes.R
\name{\%*1\%}
\alias{\%*1\%}
\title{Sorted matrix multiplication with intercept column}
\usage{
a \%*1\% b
}
\arguments{
\item{a}{a matrix with rownames specified}

\item{b}{a matrix with colnames specified}
}
\value{
matrix
}
\description{
This function first binds a column filled with 1s named \code{intercept} to
\code{a}, then performs rownames and colnames-aware (\code{\%**\%}) matrix
multiplication with \code{b}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getQueryK}
\alias{getQueryK}
\title{getQueryK}
\usage{
getQueryK(knn, k_local)
}
\arguments{
\item{knn}{Is a k-nearest neighbour matrix, giving the indices of the
training set that the query is closest to. Rows are the query cells, columns
are the NNs, should be a large value. Typically output using
BiocNeighbors::queryKNN(,,k = max(k_local)).}

\item{k_local}{Is an integer vector length of the reference set, giving the
local k to use. If k_local is given as a single integer, then that value is
used as k for all observations.}
}
\value{
An integer vector with local k to use for each query cell.
}
\description{
For each cell in the query data, use the 1NN's adaptive k value
(of the reference data) to identify the local best k value
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mockMosaicData.R
\name{mockMosaicData}
\alias{mockMosaicData}
\title{mockMosaicData}
\usage{
mockMosaicData(
  names = c("D1", "D2", "D3"),
  ncells = c(50, 50, 50),
  ngenes = list(1:150, 76:225, 151:300),
  fun = "rnorm",
  ...
)
}
\arguments{
\item{names}{character vector of mock datasets.}

\item{ncells}{integer vector of cells in each mock dataset.}

\item{ngenes}{list containing integer vectors of features measured in each
mock dataset.}

\item{fun}{name of function to simulate data, default "rnorm".}

\item{...}{further arguments passed to `fun`.}
}
\value{
assay_list a list of data matrices with rownames (features)
specified.
}
\description{
Mock up a mosaic data list using simulated data, for use in documentation
examples.
}
\examples{
set.seed(2021)
assay_list <- mockMosaicData()
lapply(assay_list, dim)

# simulate data from another distribution
assay_list <- mockMosaicData(fun = "rnbinom", size = 5, prob = 0.5)
lapply(assay_list, dim)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{queryNamedKNN}
\alias{queryNamedKNN}
\title{queryNamedKNN}
\usage{
queryNamedKNN(coords_reference, coords_query, k)
}
\arguments{
\item{coords_reference}{coords_reference}

\item{coords_query}{coords_query}

\item{k}{k}
}
\value{
matrix
}
\description{
queryNamedKNN
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/adaptiveKNN.R
\name{adaptiveKNN}
\alias{adaptiveKNN}
\title{Adaptive k-Nearest Neighbour Classification}
\usage{
adaptiveKNN(knn, class, k_local)
}
\arguments{
\item{knn}{Is a k-nearest neighbour matrix, giving the indices of the
training set that the query is closest to. Rows are the query cells, columns
are the NNs. Typically output using
BiocNeighbors::queryKNN(,,k = max(k_local)).}

\item{class}{Is the labels associated with the training set.}

\item{k_local}{Is an integer vector length of the training set, giving the
local k to use if k_local is given as a single integer, then that value is
used as k for all observations.}
}
\value{
A character vector of of classifications for the test set.
}
\description{
Adaptive k-Nearest Neighbour Classification for a k-nearest neighbour matrix,
given class labels and local k values for the training data
}
\examples{
# Generate example data
data <- matrix(rpois(10 * 20, 10), 10, 20) # 10 genes, 20 cells
data_2 <- matrix(rpois(10 * 30, 10), 10, 30) # 10 genes, 30 cells

# Generate error matrix for k_local
E <- matrix(runif(100), 20, 5)
colnames(E) <- paste0("K_", 1:5)

# Define training class labels and adaptive k-values
class <- factor(rep(letters[1:2], each = 10))
k_local <- getAdaptiveK(E, labels = class)

knn <- BiocNeighbors::queryKNN(
  t(data), t(data_2),
  k = max(as.numeric(gsub("K_", "", k_local)))
)$index

# Adaptive KNN classification
test <- adaptiveKNN(
  knn, class, as.numeric(gsub("K_", "", k_local))
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vectorSubset.R
\name{vectorSubset}
\alias{vectorSubset}
\title{vectorSubset}
\usage{
vectorSubset(vec, mat)
}
\arguments{
\item{vec}{vec}

\item{mat}{mat}
}
\value{
matrix
}
\description{
vectorSubset
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{getBinaryError}
\alias{getBinaryError}
\title{getBinaryError}
\usage{
getBinaryError(knn, k_values, class_train, class_true)
}
\arguments{
\item{knn}{Is a k-nearest neighbour matrix, giving the indices of the
training set that the query is closest to. Rows are the query cells, columns
are the NNs, should be a large value. Typically output using
BiocNeighbors::queryKNN(,,k = max(k_values)).}

\item{k_values}{Is an integer vector of the values of k to consider for
extracting accuracy. If k_values has names then pass these to colnames of E.}

\item{class_train}{Is a factor or character vector of classes that
corresponds to the indices given within knn.}

\item{class_true}{Is a factor or character vector that corresponds to the
rows of knn. If class_true has names then pass these to rownames of E.}
}
\value{
A sparse binary error matrix.
}
\description{
For potential k values, generate a binary error matrix from KNN label
classification
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifyEmbedding_utils.R
\name{gm_mean}
\alias{gm_mean}
\title{gm_mean}
\usage{
gm_mean(x, na.rm = TRUE)
}
\arguments{
\item{x}{A vector.}

\item{na.rm}{A logical value indicating whether NA values should be stripped
before calculating the geometric mean.}
}
\value{
A numeric.
}
\description{
Calculate the geometric mean
}
\keyword{internal}
